
function clientCmdShowBankGui()
{
	Suburbia_WeaponGroup.displayPlayerBankWeapons();
	SRB_BankMoneyTransferInput.setValue("");
	Canvas.pushDialog(SRB_Bank_Main);
}

function clientCmdHideBankGui()
{
	Canvas.popDialog(SRB_Bank_Main);
}

function clientCmdBankTransferSuccess(%sound)
{
	if(!%sound)
		alxPlay(Suburbia_BankTransferSound);
	else
		alxPlay(Suburbia_BankWeaponTransferSound);
}

// for the bank shit
function Suburbia_FoodGroup::displayPlayerBankFood(%this)
{
	SRB_BK_PlayerFoodContainer.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 1; %i <= 4; %i++)
	{
		%tier_list = %this.tier[%i];
		
		%tier_list.sort(0, true);
		
		%count = %tier_list.rowCount();
		for(%x = 0; %x < %count; %x++)
		{
			%data = %this.food[%tier_list.getRowText(%x)];
			
			if(!isObject(%data) || %data.count <= 0 || %displayed[%tier_list.getRowText(%x)] == true)
				continue;
			
			%displayed[%tier_list.getRowText(%x)] = true;
			
			// swatch used for highlighting selected items
			%swatch = new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 4";
				extent = "140 24";
				minExtent = "8 2";
				enabled = "1";
				visible = false;
				clipToParent = "1";
				color = "180 180 180 255";
			};
			SRB_BK_PlayerFoodContainer.add(%swatch);
			%swatch.position = 0 SPC %food_count * 23 + 4;
			
			// creating bitmap/text
			%bitmap = new GuiBitmapCtrl()
			{
				alignLeft = false;
				alignTop = false;
				bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %data.icon @ ".png";
				clipToParent = true;
				enabled = true;
				extent = "24 24";
				horizSizing = "right";
				keepCached = false;
				lockAspectRatio = false;
				mColor = "255 255 255 255";
				minExtent = "1 1";
				mMultiply = false;
				overflowImage = false;
				position = "2 2";
				profile = "GuiDefaultProfile";
				vertSizing = "bottom";
				visible = true;
				wrap = false;
				
				food_text = %text;
			};
			SRB_BK_PlayerFoodContainer.add(%bitmap);
			%bitmap.position = 5 SPC %food_count * 23 + 4;
			
			%text = new GuiMLTextCtrl()
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "96 20";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 99";
				profile = "GuiMLTextProfile";
				selectable = false;
				text = %data.count SPC %data.text @ (%data.count != 1 ? "'s" : "");
				vertSizing = "bottom";
				visible = true;
				
				food_text = %text;
			};
			SRB_BK_PlayerFoodContainer.add(%text);
			%text.position = 33 SPC %food_count * 23 + 9;
			
			%mouse = new GuiMouseEventCtrl(SRB_BankInventoryTransfer)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "140 24";
				minExtent = "8 2";
				enabled = true;
				visible = true;
				clipToParent = true;
				lockMouse = false;
				
				type = "food_player";
				food = %data.text;
				icon = %data.icon;
				count = %data.count;
				
				swatch = %swatch;
			};
			SRB_BK_PlayerFoodContainer.add(%mouse);
			%mouse.position = 0 SPC %food_count * 23 + 4;
			
			%food_count++;
		}
	}
	
	SRB_BK_PlayerFoodContainer.resize(1, 1, getWord(SRB_BK_PlayerFoodContainer.extent, 0), mClamp(%food_count * 23 + 10, 184, 1000));
}



if(!isObject(Suburbia_BankFoodGroup))
{
	%this = new ScriptGroup(Suburbia_BankFoodGroup);
	
	%this.tier1 = new GuiTextListCtrl();
	%this.tier2 = new GuiTextListCtrl();
	%this.tier3 = new GuiTextListCtrl();
	%this.tier4 = new GuiTextListCtrl();
	
	Suburbia_BankFoodGroup.deleteAll();
	SRB_BK_PlayerFoodContainer.deleteAll();
}

function clientCmdAddBankFood(%icon_file, %text, %count, %tier)
{
	Suburbia_BankFoodGroup.addFoodIcon(%icon_file, %text, %count, %tier);
}

function Suburbia_BankFoodGroup::changeFoodCount(%this, %text, %count)
{
	%this.food[%text].count = %count;
	
	cancel(%this.display_sch);
	%this.display_sch = %this.schedule(5, displayBankFood);
}

function Suburbia_BankFoodGroup::addFoodIcon(%this, %icon_file, %text, %count, %tier)
{
	if(isObject(%this.food[%text]))
	{
		%this.changeFoodCount(%text, %count);
		return;
	}
	
	// food data scriptobject used to reorganize shit
	%so = new ScriptObject()
	{
		icon = %icon_file;
		text = %text;
		count = %count;
		tier = %tier;
	};
	%this.add(%so);
	%this.food[%text] = %so;
	
	%this.tier[%tier].addRow(%this.tier[%tier].rowCount(), %text);
	
	cancel(%this.display_sch);
	%this.display_sch = %this.schedule(5, displayBankFood);
}

function Suburbia_BankFoodGroup::displayBankFood(%this)
{
	SRB_BK_BankFoodContainer.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 1; %i <= 4; %i++)
	{
		%tier_list = %this.tier[%i];
		
		%tier_list.sort(0, true);
		
		%count = %tier_list.rowCount();
		for(%x = 0; %x < %count; %x++)
		{
			%data = %this.food[%tier_list.getRowText(%x)];
			
			if(!isObject(%data) || %data.count <= 0 || %displayed[%tier_list.getRowText(%x)] == true)
				continue;
			
			%displayed[%tier_list.getRowText(%x)] = true;
			
			// swatch used for highlighting selected items
			%swatch = new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 4";
				extent = "140 24";
				minExtent = "8 2";
				enabled = "1";
				visible = false;
				clipToParent = "1";
				color = "180 180 180 255";
			};
			SRB_BK_BankFoodContainer.add(%swatch);
			%swatch.position = 0 SPC %food_count * 23 + 4;
			
			// creating bitmap/text
			%bitmap = new GuiBitmapCtrl()
			{
				alignLeft = false;
				alignTop = false;
				bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %data.icon @ ".png";
				clipToParent = true;
				enabled = true;
				extent = "24 24";
				horizSizing = "right";
				keepCached = false;
				lockAspectRatio = false;
				mColor = "255 255 255 255";
				minExtent = "1 1";
				mMultiply = false;
				overflowImage = false;
				position = "2 2";
				profile = "GuiDefaultProfile";
				vertSizing = "bottom";
				visible = true;
				wrap = false;
				
				food_text = %text;
			};
			SRB_BK_BankFoodContainer.add(%bitmap);
			%bitmap.position = 5 SPC %food_count * 23 + 4;
			
			%text = new GuiMLTextCtrl()
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "96 20";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 99";
				profile = "GuiMLTextProfile";
				selectable = false;
				text = %data.count SPC %data.text @ (%data.count != 1 ? "'s" : "");
				vertSizing = "bottom";
				visible = true;
				
				food_text = %text;
			};
			SRB_BK_BankFoodContainer.add(%text);
			%text.position = 33 SPC %food_count * 23 + 9;
			
			%mouse = new GuiMouseEventCtrl(SRB_BankInventoryTransfer)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "140 24";
				minExtent = "8 2";
				enabled = true;
				visible = true;
				clipToParent = true;
				lockMouse = false;
				
				type = "food_bank";
				food = %data.text;
				icon = %data.icon;
				count = %data.count;
				
				swatch = %swatch;
			};
			SRB_BK_BankFoodContainer.add(%mouse);
			%mouse.position = 0 SPC %food_count * 23 + 4;
			
			%food_count++;
		}
	}
	
	SRB_BK_BankFoodContainer.resize(1, 1, getWord(SRB_BK_BankFoodContainer.extent, 0), mClamp(%food_count * 23 + 10, 184, 1000));
}

function displayPlayerBankResources()
{
	SRB_BK_PlayerResourceContainer.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 0; %i < 14; %i++)
	{
		%name = SuburbiaClient.ingredients[%i];
		%count = SuburbiaClient.ingredients[%name];
		
		if(%count <= 0 || %displayed[%name] == true)
			continue;
		
		%displayed[%name] = true;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 24";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_BK_PlayerResourceContainer.add(%swatch);
		%swatch.position = 0 SPC %food_count * 23 + 4;
		
		if(%name $= "Mystery Meat")
			%icon = "corpse";
		else
			%icon = %name;
		
		// creating bitmap/text
		%bitmap = new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon @ ".png";
			clipToParent = true;
			enabled = true;
			extent = "24 24";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
			
			food_text = %text;
		};
		SRB_BK_PlayerResourceContainer.add(%bitmap);
		%bitmap.position = 5 SPC %food_count * 23 + 4;
		
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %count SPC %name @ ((%count != 1 && %name $= "Egg") ? "s" : "");
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_BK_PlayerResourceContainer.add(%text);
		%text.position = 33 SPC %food_count * 23 + 9;
		
		%mouse = new GuiMouseEventCtrl(SRB_BankInventoryTransfer)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 24";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "resource_player";
			resource = %name;
			icon = %icon;
			count = %count;
			
			swatch = %swatch;
		};
		SRB_BK_PlayerResourceContainer.add(%mouse);
		%mouse.position = 0 SPC %food_count * 23 + 4;
		
		%food_count++;
	}
	
	SRB_BK_PlayerResourceContainer.resize(1, 1, getWord(SRB_BK_PlayerResourceContainer.extent, 0), mClamp(%food_count * 23 + 10, 184, 1000));
}

function displayBankResources()
{
	SRB_BK_BankResourceContainer.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 0; %i < 14; %i++)
	{
		%name = SuburbiaClient.ingredients[%i];
		%count = SuburbiaClient.bank_ingredients[%name];
		
		if(%count <= 0 || %displayed[%name] == true)
			continue;
		
		%displayed[%name] = true;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 24";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_BK_BankResourceContainer.add(%swatch);
		%swatch.position = 0 SPC %food_count * 23 + 4;
		
		if(%name $= "Mystery Meat")
			%icon = "corpse";
		else
			%icon = %name;
		
		// creating bitmap/text
		%bitmap = new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon @ ".png";
			clipToParent = true;
			enabled = true;
			extent = "24 24";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
			
			food_text = %text;
		};
		SRB_BK_BankResourceContainer.add(%bitmap);
		%bitmap.position = 5 SPC %food_count * 23 + 4;
		
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %count SPC %name @ ((%count != 1 && %name $= "Egg") ? "s" : "");
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_BK_BankResourceContainer.add(%text);
		%text.position = 33 SPC %food_count * 23 + 9;
		
		%mouse = new GuiMouseEventCtrl(SRB_BankInventoryTransfer)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 24";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "resource_bank";
			resource = %name;
			icon = %icon;
			count = %count;
			
			swatch = %swatch;
		};
		SRB_BK_BankResourceContainer.add(%mouse);
		%mouse.position = 0 SPC %food_count * 23 + 4;
		
		// echo(%name);
		
		%food_count++;
	}
	
	SRB_BK_BankResourceContainer.resize(1, 1, getWord(SRB_BK_BankResourceContainer.extent, 0), mClamp(%food_count * 23 + 10, 184, 1000));
}

function clientCmdUpdateBankIngredients(%wheat, %meat, %egg, %cheese, %corn, %cabbage, %gold, %uranium, %volcanium, %puff, %henk, %krunt, %boom, %corpse)
{
	SuburbiaClient.bank_ingredients["Wheat"] = %wheat;
	SuburbiaClient.bank_ingredients["Meat"] = %meat;
	SuburbiaClient.bank_ingredients["Egg"] = %egg;
	SuburbiaClient.bank_ingredients["Cheese"] = %cheese;
	SuburbiaClient.bank_ingredients["Corn"] = %corn;
	SuburbiaClient.bank_ingredients["Cabbage"] = %cabbage;
	SuburbiaClient.bank_ingredients["Gold"] = %gold;
	SuburbiaClient.bank_ingredients["Uranium"] = %uranium;
	SuburbiaClient.bank_ingredients["Volcanium"] = %volcanium;
	SuburbiaClient.bank_ingredients["Puff"] = %puff;
	SuburbiaClient.bank_ingredients["Henk"] = %henk;
	SuburbiaClient.bank_ingredients["Krunt"] = %krunt;
	SuburbiaClient.bank_ingredients["Boom"] = %boom;
	SuburbiaClient.bank_ingredients["Mystery Meat"] = %corpse;
	
	displayBankResources();
}




if(!isObject(Suburbia_WeaponGroup))
{
	%group = new ScriptGroup(Suburbia_WeaponGroup);
	%group.player_weapons = new GuiTextListCtrl();
	%group.bank_weapons = new GuiTextListCtrl();
}

function clientCmdAddBankWeapon(%text, %count)
{
	Suburbia_WeaponGroup.addBankWeapon(%text, %count);
}

function Suburbia_WeaponGroup::changeFoodCount(%this, %text, %count)
{
	%this.weapon[%text].count = %count;
	
	cancel(%this.display_sch);
	%this.display_sch = %this.schedule(5, displayBankWeapons);
}

function Suburbia_WeaponGroup::addBankWeapon(%this, %text, %count)
{
	if(isObject(%this.weapon[%text]))
	{
		%this.changeFoodCount(%text, %count);
		return;
	}
	
	// weapon data scriptobject used to reorganize shit
	%so = new ScriptObject()
	{
		text = %text;
		count = %count;
	};
	%this.add(%so);
	%this.weapon[%text] = %so;
	
	%this.bank_weapons.addRow(%this.bank_weapons.rowCount(), %text);
	
	cancel(%this.display_sch);
	%this.display_sch = %this.schedule(5, displayBankWeapons);
}

function Suburbia_WeaponGroup::displayBankWeapons(%this)
{
	SRB_BK_BankWeaponsContainer.deleteAll();
	
	%this.bank_weapons.sort(0, true);
	
	// going through the different tiers and then putting them in
	%count = %this.bank_weapons.rowCount();
	for(%i = 0; %i < %count; %i++)
	{
		%data = %this.weapon[%this.bank_weapons.getRowText(%i)];
		
		if(!isObject(%data) || %data.count <= 0 || %data.text $= "")
			continue;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 18";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_BK_BankWeaponsContainer.add(%swatch);
		%swatch.position = 0 SPC %weapon_count * 20 + 4;
		
		// creating bitmap/text
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "200 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %data.count SPC %data.text @ (%data.count != 1 ? "s" : "");
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_BK_BankWeaponsContainer.add(%text);
		%text.position = 8 SPC %weapon_count * 20 + 6;
		
		%mouse = new GuiMouseEventCtrl(SRB_BankInventoryTransfer)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 18";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "weapons_bank";
			weapon = %data.text;
			count = %data.count;
			
			swatch = %swatch;
		};
		SRB_BK_BankWeaponsContainer.add(%mouse);
		%mouse.position = 0 SPC %weapon_count * 20 + 4;
		
		%weapon_count++;
	}
	
	SRB_BK_BankWeaponsContainer.resize(1, 1, getWord(SRB_BK_BankWeaponsContainer.extent, 0), mClamp(%weapon_count * 23 + 10, 184, 1000));
}



function clientCmdSetPlayerWeapons(%weapon1, %weapon2, %weapon3, %weapon4, %weapon5, %weapon6, %weapon7, %weapon8, %weapon9, %weapon10)
{
	Suburbia_WeaponGroup.player_weapons.clear();
	
	for(%i = 0; %i <= 10; %i++)
		Suburbia_WeaponGroup.player_weapons.addRow(Suburbia_WeaponGroup.player_weapons.rowCount(), %weapon[%i]);
	
	Suburbia_WeaponGroup.displayPlayerBankWeapons();
}

function Suburbia_WeaponGroup::displayPlayerBankWeapons()
{
	SRB_BK_PlayerWeaponsContainer.deleteAll();
	
	Suburbia_WeaponGroup.player_weapons.sort(0, true);
	
	// going through the different tiers and then putting them in
	%count = Suburbia_WeaponGroup.player_weapons.rowCount();
	for(%i = 0; %i < %count; %i++)
	{
		%name = trim(Suburbia_WeaponGroup.player_weapons.getRowText(%i));
		
		if(%name $= "" || strLwr(%name) $= "hammer" || strLwr(%name) $= "wrench" || strLwr(%name) $= "printer")
			continue;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 18";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_BK_PlayerWeaponsContainer.add(%swatch);
		%swatch.position = 0 SPC %weapon_count * 20 + 4;
		
		// creating bitmap/text
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %name;
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_BK_PlayerWeaponsContainer.add(%text);
		%text.position = 8 SPC %weapon_count * 20 + 6;
		
		%mouse = new GuiMouseEventCtrl(SRB_BankInventoryTransfer)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 18";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "weapons_player";
			weapon = %name;
			icon = %icon;
			count = 1;
			
			swatch = %swatch;
		};
		SRB_BK_PlayerWeaponsContainer.add(%mouse);
		%mouse.position = 0 SPC %weapon_count * 20 + 4;
		
		%weapon_count++;
	}
	
	SRB_BK_PlayerWeaponsContainer.resize(1, 1, getWord(SRB_BK_PlayerWeaponsContainer.extent, 0), mClamp(%weapon_count * 23 + 10, 184, 1000));
}






function SRB_BankInventoryTransfer::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = true;
	%this.mousedown = true;
}

function SRB_BankInventoryTransfer::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
	
	SRB_BankTransferInput.setValue("");
	
	if(%this.type $= "food_player") // transfer from player -> bank
	{
		SRB_Bank_Transfer_Bitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %this.icon @ ".png";
		SRB_Bank_Transfer_Text1.setText("<font:Calibri:24>" @ %this.count SPC %this.food @ (%this.count != 1 ? "'s" : ""));
		
		SuburbiaClient.bank_transfer_max = %this.count;
		SuburbiaClient.bank_transfer_command = "food_player";
		SuburbiaClient.bank_transfer_name = %this.food;
		
		%food_name = trim(strReplace(%this.food, "1", ""));
		%food_name = trim(strReplace(%food_name, "2", ""));
		%food_name = trim(strReplace(%food_name, "3", ""));
		
		SRB_Bank_Transfer_Bitmap.position = 54 + SuburbiaClient.food_offset[%food_name] SPC 29;
		SRB_Bank_Transfer_Text1.position = 100 + SuburbiaClient.food_offset[%food_name] SPC 38;
		
		SRB_BankTransferButton.setText("Transfer to Bank Inventory");
		
		Canvas.pushDialog(SRB_Bank_Transfer);
	}
	else if(%this.type $= "food_bank") // transfer from bank -> player
	{
		SRB_Bank_Transfer_Bitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %this.icon @ ".png";
		SRB_Bank_Transfer_Text1.setText("<font:Calibri:24>" @ %this.count SPC %this.food @ (%this.count != 1 ? "'s" : ""));
		
		SuburbiaClient.bank_transfer_max = %this.count;
		SuburbiaClient.bank_transfer_command = "food_bank";
		SuburbiaClient.bank_transfer_name = %this.food;
		
		%food_name = trim(strReplace(%this.food, "1", ""));
		%food_name = trim(strReplace(%food_name, "2", ""));
		%food_name = trim(strReplace(%food_name, "3", ""));
		
		SRB_Bank_Transfer_Bitmap.position = 54 + SuburbiaClient.food_offset[%food_name] SPC 29;
		SRB_Bank_Transfer_Text1.position = 100 + SuburbiaClient.food_offset[%food_name] SPC 38;
		
		SRB_BankTransferButton.setText("Transfer to Player Inventory");
		
		Canvas.pushDialog(SRB_Bank_Transfer);
	}
	else if(%this.type $= "resource_player")
	{
		SRB_Bank_Transfer_Bitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %this.icon @ ".png";
		SRB_Bank_Transfer_Text1.setText("<font:Calibri:24>" @ %this.count SPC %this.resource @ ((%this.count != 1 && %this.resource $= "Egg") ? "s" : ""));
		
		SuburbiaClient.bank_transfer_max = %this.count;
		SuburbiaClient.bank_transfer_command = "resource_player";
		SuburbiaClient.bank_transfer_name = %this.resource;
		
		SRB_Bank_Transfer_Bitmap.position = 54 + SuburbiaClient.food_offset[%this.resource] SPC 29;
		SRB_Bank_Transfer_Text1.position = 100 + SuburbiaClient.food_offset[%this.resource] SPC 38;
		
		SRB_BankTransferButton.setText("Transfer to Bank Inventory");
		
		Canvas.pushDialog(SRB_Bank_Transfer);
	}
	else if(%this.type $= "resource_bank")
	{
		SRB_Bank_Transfer_Bitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %this.icon @ ".png";
		SRB_Bank_Transfer_Text1.setText("<font:Calibri:24>" @ %this.count SPC %this.resource @ ((%this.count != 1 && %this.resource $= "Egg") ? "s" : ""));
		
		SuburbiaClient.bank_transfer_max = %this.count;
		SuburbiaClient.bank_transfer_command = "resource_bank";
		SuburbiaClient.bank_transfer_name = %this.resource;
		
		SRB_Bank_Transfer_Bitmap.position = 54 + SuburbiaClient.food_offset[%this.resource] SPC 29;
		SRB_Bank_Transfer_Text1.position = 100 + SuburbiaClient.food_offset[%this.resource] SPC 38;
		
		SRB_BankTransferButton.setText("Transfer to Player Inventory");
		
		Canvas.pushDialog(SRB_Bank_Transfer);
	}
	else if(%this.type $= "weapons_player")
		CommandToServer('BankTransfer', "weapons_player", %this.weapon);
	else
		CommandToServer('BankTransfer', "weapons_bank", %this.weapon);
}

function SRB_BankInventoryTransfer::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
}



function setBankTransferInput(%val)
{
	if(%val !$= "")
		SRB_BankTransferInput.setValue(mClamp(%val, 0, SuburbiaClient.bank_transfer_max));
}



function sendBankTransferCommand()
{
	Canvas.popDialog(SRB_Bank_Transfer);
	CommandToServer('BankTransfer', SuburbiaClient.bank_transfer_command, SuburbiaClient.bank_transfer_name, mClamp(SRB_BankTransferInput.getValue(), 0, SuburbiaClient.bank_transfer_max));
}










function clientCmdBankMoneyTransferSuccess()
{
	alxPlay(Suburbia_MoneySound);
}

function clientCmdSetBankMoney(%amt)
{
	SRB_BankMoneyText.setText("<color:bbbbbb><font:Calibri:26>Funds: <color:00cc00>$" @ mFloor(%amt));
}

function setBankMoneyInput(%val)
{
	if(%val !$= "")
		SRB_BankMoneyTransferInput.setValue(mClamp(%val, 0, 100000000));
}

function bankWithdraw()
{
	CommandToServer('BankWithdrawMoney', SRB_BankMoneyTransferInput.getValue());
}

function bankDeposit()
{
	CommandToServer('BankDepositMoney', SRB_BankMoneyTransferInput.getValue());
}

function bankDepositAll()
{
	CommandToServer('BankDepositMoney', 100000000);
}