
if(!isObject(SRB_ButtonsGui))
	exec("./gui/SRB_ButtonsGui.gui");

function showButtonsGui()
{
	if($Suburbia::HandshakeCompleted)
	{
		PlayGui.remove(SRB_ButtonsGui);
		
		// Canvas.pushDialog(SRB_ButtonsGui);
		NewChatHud.add(SRB_ButtonsSwatch);
		NewChatHud.pushToBack(SRB_ButtonsSwatch);
		// Canvas.pushToBack(NewChatHud);
		
		schedule(100, 0, positionButtonsGui);
	}
	
	killButtonsGui();
}

function hideButtonsGui()
{
	if($Suburbia::HandshakeCompleted)
	{
		if(SRB_ButtonsSwatch.getGroup().getName() $= "NewChatHud")
			NewChatHud.remove(SRB_ButtonsSwatch);
		
		SRB_ButtonsGui.add(SRB_ButtonsSwatch);
		PlayGui.add(SRB_ButtonsGui);
		
		schedule(100, 0, positionButtonsGui);
	}
	
	killButtonsGui();
}

function killButtonsGui()
{
	if(!$Suburbia::HandshakeCompleted)
	{
		if(SRB_ButtonsSwatch.getGroup().getName() $= "NewChatHud")
			NewChatHud.remove(SRB_ButtonsSwatch);
		
		PlayGui.remove(SRB_ButtonsGui);
	}
}

function positionButtonsGui()
{
	if(!$Suburbia::PaintOn)
		SRB_ButtonsSwatch.position = "0" SPC getWord(PlayGui.extent, 1) - getWord(SRB_ButtonsSwatch.extent, 1);
	else
		SRB_ButtonsSwatch.position = "0" SPC (getWord(PlayGui.extent, 1) - getWord(SRB_ButtonsSwatch.extent, 1)) - 150;
	
	SRB_HidePlayGui.extent = PlayGui.extent;
}

function srb_createGuiButton(%name, %command, %color, %already_exists)
{
	%y = (-54 * SRB_ButtonsSwatch.getCount()) + 160;
	
	%button = new GuiBitmapButtonCtrl("SRB_Button_" @ getSafeVariableName(%name))
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "21" SPC %y;
		extent = "136 48";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		command = %command;
		text = %name;
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "Add-Ons/System_BlocklandGlass/image/gui/btn";
		lockAspectRatio = "0";
		alignLeft = "0";
		alignTop = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = %color;
	};
	SRB_ButtonsSwatch.add(%button);
	%button.position = "21" SPC %y;
	
	if(!%already_exists)
	{
		if($Suburbia::ButtonsCount $= "")
			$Suburbia::ButtonsCount = 0;
		
		$Suburbia::Buttons[$Suburbia::ButtonsCount] = %name TAB %command TAB %color;
		$Suburbia::Buttons[%name] = $Suburbia::ButtonsCount;
		$Suburbia::ButtonsCount++;
	}
	
	return %button;
}

function clientCmdAddGuiButtonSafe(%name, %command, %color)
{
	if(!isObject("SRB_Button_" @ getSafeVariableName(%name)))
		srb_createGuiButton(%name, %command, %color);
}

function clientCmdAddGuiButton(%name, %command, %color)
{
	srb_createGuiButton(%name, %command, %color);
}

function clientCmdRemoveGuiButton(%name)
{
	if(isObject("SRB_Button_" @ getSafeVariableName(%name)))
	{
		("SRB_Button_" @ getSafeVariableName(%name)).delete();
		%index = $Suburbia::Buttons[%name];
		$Suburbia::Buttons[%index] = "";
		$Suburbia::Buttons[%name] = "";
		
		srb_reorganizeButtons();
	}
}

function srb_reorganizeButtons()
{
	for(%i = 0; %i < $Suburbia::ButtonsCount; %i++)
	{
		%name = getField($Suburbia::Buttons[%i], 0);
		%command = getField($Suburbia::Buttons[%i], 1);
		%color = getField($Suburbia::Buttons[%i], 2);
		
		if(%name $= "")
			continue;
		
		("SRB_Button_" @ getSafeVariableName(%name)).delete();
		
		srb_createGuiButton(%name, %command, %color, true);
	}
}

// puts big black swatch over play gui
function SuburbiaClient::hidePlayGui(%this)
{
	if(!isObject(SRB_HidePlayGui))
	{
		new GuiSwatchCtrl(SRB_HidePlayGui)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "1920 1080";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "0 0 0 255";
		};
		PlayGui.add(SRB_HidePlayGui);
	}
	
	SRB_HidePlayGui.color = "0 0 0 255";
	SRB_HidePlayGui.visible = true;
}

function SuburbiaClient::showPlayGui(%this)
{
	SRB_HidePlayGui.color = "0 0 0 255";
	SRB_HidePlayGui.visible = false;
}

function clientCmdSuburbia_HidePlayGui(%hide)
{
	if(%hide)
		SuburbiaClient.hidePlayGui();
	else
		SuburbiaClient.showPlayGui();
}

function clientCmdSuburbia_FadeInPlayGui(%factor)
{
	SuburbiaClient.fadeInPlayGui(%factor);
}

function SuburbiaClient::fadeInPlayGui(%this, %factor, %a)
{
	cancel(%this.playgui_fadein);
	
	if(%a $= "")
		%a = 255;
	
	%a -= %factor;
	
	if(%a <= 0)
	{
		%this.showPlayGui();
		return;
	}
	
	SRB_HidePlayGui.color = "0 0 0" SPC %a;
	
	%this.playgui_fadein = %this.schedule(6, fadeInPlayGui, %factor, %a);
}

DeactivatePackage(Suburbia_ButtonsGui);
package Suburbia_ButtonsGui
{
	function PlayGui::onWake(%this)
	{
		showButtonsGui();
		schedule(100, 0, positionButtonsGui);
		
		Parent::onWake(%this);
	}
	
	function PlayGui::onSleep(%this)
	{
		Parent::onSleep(%this);
		
		hideButtonsGui();
	}
	
	function ToggleCursor(%val)
	{
		if(%val == 1)
		{
			if(Canvas.isCursorOn() $= "1")
			{
				schedule(10, 0, hideButtonsGui);
				SRB_ButtonsGui.noCursor = false;
			}
			else
			{
				showButtonsGui();
				SRB_ButtonsGui.noCursor = false;
			}
		}
		
		Parent::ToggleCursor(%val);
	}
	
	function Canvas::cursorOff(%this)
	{
		Parent::cursorOff(%this);
		
		schedule(10, 0, hideButtonsGui);
	}
	
	function Canvas::cursorOn(%this)
	{
		Parent::cursorOn(%this);
	}
	
	function shiftPaintColumn(%amt)
	{
		Parent::shiftPaintColumn(%amt);
	}
	
	function useSprayCan(%val)
	{
		Parent::useSprayCan(%val);
		
		if(!$PaintingDisabled)
		{
			$Suburbia::PaintOn = true;
			positionButtonsGui();
		}
	}
	
	function PlayGui::hidePaintBox(%this, %dist, %totalSteps, %currStep)
	{
		Parent::hidePaintBox(%this, %dist, %totalSteps, %currStep);
		
		if(%totalSteps > 1 && %dist > 0)
		{
			if(%totalSteps == %currStep)
			{
				$Suburbia::PaintOn = false;
				positionButtonsGui();
			}
		}
	}
};
ActivatePackage(Suburbia_ButtonsGui);