
if(!$Suburbia::KeybindsSet)
{
	$remapDivision[$remapCount] = "Suburbia";
	$remapName[$remapCount] = "Open Character Gui";
	$remapCmd[$remapCount] = "showCharacterGui";
	$remapCount++;
}

function clientCmdSuburbia_PlayTutorialMusic()
{
	if(!isObject($Suburbia::TutorialMusic))
	{
		$Suburbia::TutorialMusic = new AudioProfile("SuburbiaTutorialMusic")
		{
			description = SuburbiaEngineSoundDescription;
			fileName = "Add-Ons/Client_Suburbia/sounds/tutorial.wav";
		};
	}
	
	$Suburbia::TutorialMusicIdx = alxPlay($Suburbia::TutorialMusic.getName());
	alxSourcef($Suburbia::TutorialMusicIdx, "AL_REFERENCE_DISTANCE", 2);
}

function clientCmdSuburbia_StopTutorialMusic()
{
	alxStop($Suburbia::TutorialMusicIdx);
}

function spaceCharacterTabs(%width, %space)
{
	%orig = 81;
	
	for(%i = 1; %i <= 8; %i++)
	{
		%pos = ((%width * (%i - 1)) + %space * %i) + %orig;
		("SRB_Character_Tab" @ %i + 1).position = %pos SPC 29;
		("SRB_Character_Tab" @ %i + 1).extent = %width SPC 30;
	}
}

function clientCmdSuburbia_SetFov(%fov)
{
	setFov(%fov);
}

function clientCmdSuburbia_ResetFov()
{
	setFov($Pref::Player::DefaultFov);
}

function clientCmdSuburbia_DisplayTitle()
{
	SuburbiaClient.startSuburbiaText();
}

function SuburbiaClient::startSuburbiaText(%this)
{
	if(isEventPending(%this.title_sch))
		return;
	
	%orig = $CameraSpeed;
	$CameraSpeed = 5;
	$FirstPerson = true;
	$CameraSpeed = %orig;
	
	ClientCmdCenterPrint("a");
	
	%this.title_size = 1;
	%this.title_size2 = 0;
	%this.showSuburbiaText();
	%this.old_centerprint = CenterPrintDlg.extent;
	CenterPrintDlg.resize(getWord(CenterPrintDlg.position, 0), getWord(CenterPrintDlg.position, 1), 1500, 203);
	CenterPrintText.resize(getWord(CenterPrintText.position, 0), getWord(CenterPrintText.position, 1), 1500, 203);
	CenterPrintDlg.centerX();
	CenterPrintText.vertSizing = "center";
	
	refreshCenterTextCtrl();
	
	Crosshair.visible = false;
}

function SuburbiaClient::showSuburbiaText(%this)
{
	cancel(%this.title_sch);
	
	// %size = mPow(0.99, (%this.title_size / 30) - 10);
	%size = mLog(%this.title_size + 1) / mLog(1.04) - 15;
	%this.title_size2 = %size;
	%this.title_size += 0.5;
	
	CenterPrintText.maxBitmapHeight = %this.title_size2;
	
	CenterPrintText.setText("<just:center><color:FFFF00><bitmap:Add-Ons/Client_Suburbia/gui/suburbia>");
	CenterPrintText.centerY();
	CenterPrintText.position = "0 -100";
	
	if(%this.title_size2 > 140)
	{
		%this.stopSuburbiaText();
		return;
	}
	
	%this.title_sch = %this.schedule(6, showSuburbiaText);
}

function SuburbiaClient::stopSuburbiaText(%this)
{
	// CenterPrintText.setText("<just:center><color:FFFF00><font:Arial bold:" @ mFloor(%this.title_size2) @ "><bitmap:config/egg3>");
	CenterPrintText.setText("<just:center><color:FFFF00><bitmap:Add-Ons/Client_Suburbia/gui/suburbia>");
	CenterPrintText.centerY();
	%this.title_sch = %this.schedule(4000, resetCenterPrint);
}

function SuburbiaClient::resetCenterPrint(%this)
{
	CenterPrintText.extent = %this.old_centerprint;
	CenterPrintDlg.extent = %this.old_centerprint;
	CenterPrintDlg.centerX();
	
	ClientCmdCenterPrint("");
	
	Crosshair.visible = true;
}

function showCharacterGui(%val)
{
	if(%val == 1)
	{
		if(SRB_Character_Main.getGroup().getName() $= "Canvas")
			Canvas.popDialog(SRB_Character_Main);
		else
			CommandToServer('Character');
	}
}

function clientCmdShowCharacterGui(%tab)
{
	if(%tab !$= "")
		setCharacterTab(%tab);
	
	setCraftingMode(0);
	resetSelectedPerkIcon();
	resetSelectedJobIcon();
	displayPerks();
	displayJobs();
	setCharacterTab(1);
	loadSuburbiaHelp();
	resetCraftingScreens();
	Canvas.pushDialog(SRB_Character_Main);
	displayCharacterLaws();
	SRB_Piety.setText("Piety Level:" SPC SuburbiaClient.piety);
}

function clientCmdSetInflation(%estimate, %percent)
{
	SuburbiaClient.inflation_estimate = %estimate;
	SuburbiaClient.inflation_percent = %percent;
	
	if(%estimate < 0)
		%money = "-$" @ mAbs(%estimate);
	else
		%money = "$" @ mAbs(%estimate);
	
	if(%estimate < 10)
	{
		SRB_Inflation_Image.position = VectorAdd("138 142", "7 0");
		SRB_Inflation.position = VectorAdd("166 146", "7 0");
	}
	else
	{
		SRB_Inflation_Image.position = "138 142";
		SRB_Inflation.position = "166 146";
	}
	
	SRB_Inflation.setText("Inflation Estimate: ~" @ %money);
}

function SuburbiaClient::getInflationDifference(%this, %money)
{
	%difference = mFloor(%this.inflation_percent * %money) - %money;
	
	if(%difference < 0)
		return "--$" @ mAbs(%difference);
	else
		return "$" @ %difference;
}

function SuburbiaClient::getInflationSum(%this, %money)
{
	%sum = mFloor(%this.inflation_percent * %money);
	
	if(%sum < 0)
		return "-$" @ mAbs(%sum);
	else
		return "$" @ %sum;
}

function clientCmdUpdateIngredients(%wheat, %meat, %egg, %cheese, %corn, %cabbage, %gold, %uranium, %volcanium, %puff, %henk, %krunt, %boom, %corpse)
{
	SRB_CH_Wheat.setText(mClamp(%wheat, 0, 100000) SPC "Wheat");
	SRB_CH_Meat.setText(mClamp(%meat, 0, 100000) SPC "Meat");
	SRB_CH_Egg.setText(mClamp(%egg, 0, 100000) SPC (%egg != 1 ? "Eggs" : "Egg"));
	SRB_CH_Cheese.setText(mClamp(%cheese, 0, 100000) SPC "Cheese");
	SRB_CH_Corn.setText(mClamp(%corn, 0, 100000) SPC "Corn");
	SRB_CH_Cabbage.setText(mClamp(%cabbage, 0, 100000) SPC "Cabbage");
	SRB_CH_Gold.setText(mClamp(%gold, 0, 100000) SPC "Gold");
	SRB_CH_Uranium.setText(mClamp(%uranium, 0, 100000) SPC "Uranium");
	SRB_CH_Volcanium.setText(mClamp(%volcanium, 0, 100000) SPC "Volcanium");
	SRB_CH_Puff.setText(mClamp(%puff, 0, 100000) SPC "Puff");
	SRB_CH_Henk.setText(mClamp(%henk, 0, 100000) SPC "Henk");
	SRB_CH_Krunt.setText(mClamp(%krunt, 0, 100000) SPC "Krunt");
	SRB_CH_Boom.setText(mClamp(%boom, 0, 100000) SPC "Boom");
	SRB_CH_Corpse.setText(mClamp(%corpse, 0, 100000) SPC "Mystery Meat");
	
	SuburbiaClient.ingredients[0] = "Cabbage";
	SuburbiaClient.ingredients[1] = "Cheese";
	SuburbiaClient.ingredients[2] = "Corn";
	SuburbiaClient.ingredients[3] = "Egg";
	SuburbiaClient.ingredients[4] = "Meat";
	SuburbiaClient.ingredients[5] = "Wheat";
	
	SuburbiaClient.ingredients[6] = "Gold";
	SuburbiaClient.ingredients[7] = "Uranium";
	SuburbiaClient.ingredients[8] = "Volcanium";
	
	SuburbiaClient.ingredients[9] = "Puff";
	SuburbiaClient.ingredients[10] = "Henk";
	SuburbiaClient.ingredients[11] = "Krunt";
	SuburbiaClient.ingredients[12] = "Boom";
	
	SuburbiaClient.ingredients[13] = "Mystery Meat";
	
	SuburbiaClient.ingredients["Wheat"] = %wheat;
	SuburbiaClient.ingredients["Meat"] = %meat;
	SuburbiaClient.ingredients["Egg"] = %egg;
	SuburbiaClient.ingredients["Cheese"] = %cheese;
	SuburbiaClient.ingredients["Corn"] = %corn;
	SuburbiaClient.ingredients["Cabbage"] = %cabbage;
	SuburbiaClient.ingredients["Gold"] = %gold;
	SuburbiaClient.ingredients["Uranium"] = %uranium;
	SuburbiaClient.ingredients["Volcanium"] = %volcanium;
	SuburbiaClient.ingredients["Puff"] = %puff;
	SuburbiaClient.ingredients["Henk"] = %henk;
	SuburbiaClient.ingredients["Krunt"] = %krunt;
	SuburbiaClient.ingredients["Boom"] = %boom;
	SuburbiaClient.ingredients["Mystery Meat"] = %corpse;
	
	// displayPlayerBankResources();
}

function SRB_Secret_Gator1_Mouse::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	if(SRB_Secret_Gator1.visible == true)
		SRB_Secret_Gator1.visible = false;
	else
		SRB_Secret_Gator1.visible = true;
}

if(!isObject(Suburbia_FoodGroup))
{
	%this = new ScriptGroup(Suburbia_FoodGroup);
	
	%this.tier1 = new GuiTextListCtrl();
	%this.tier2 = new GuiTextListCtrl();
	%this.tier3 = new GuiTextListCtrl();
	%this.tier4 = new GuiTextListCtrl();
	
	SRB_CH_FoodContainer.deleteAll();
}

function Suburbia_FoodGroup::changeFoodCount(%this, %text, %count)
{
	%this.food[%text].count = %count;
	
	cancel(%this.display_sch);
	cancel(%this.display_sch2);
	%this.display_sch = %this.schedule(5, reorganizeFood);
	// %this.display_sch2 = %this.schedule(5, displayPlayerBankFood);
}

function clientCmdAddFood(%icon_file, %text, %count, %tier)
{
	Suburbia_FoodGroup.addFoodIcon(%icon_file, %text, %count, %tier);
}

function Suburbia_FoodGroup::addFoodIcon(%this, %icon_file, %text, %count, %tier)
{
	if(isObject(%this.food[%text]))
	{
		%this.changeFoodCount(%text, %count);
		return;
	}
	
	// food data scriptobject used to reorganize shit
	%so = new ScriptObject()
	{
		icon = %icon_file;
		text = %text;
		count = %count;
		tier = %tier;
	};
	%this.add(%so);
	%this.food[%text] = %so;
	
	%this.tier[%tier].addRow(%this.tier[%tier].rowCount(), %text);
	
	cancel(%this.display_sch);
	cancel(%this.display_sch2);
	%this.display_sch = %this.schedule(5, reorganizeFood);
	// %this.display_sch2 = %this.schedule(5, displayPlayerBankFood);
}

function Suburbia_FoodGroup::removeFoodIcon(%this, %text)
{
	%this.food[%text].delete();
	%this.reorganizeFood();
}

function Suburbia_FoodGroup::reorganizeFood(%this)
{
	SRB_CH_FoodContainer.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 1; %i <= 4; %i++)
	{
		%tier_list = %this.tier[%i];
		
		%tier_list.sort(0, true);
		
		%count = %tier_list.rowCount();
		for(%x = 0; %x < %count; %x++)
		{
			%data = %this.food[%tier_list.getRowText(%x)];
			
			if(!isObject(%data) || %data.count <= 0 || %displayed[%tier_list.getRowText(%x)] == true)
				continue;
			
			%displayed[%tier_list.getRowText(%x)] = true;
			
			%swatch = new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 4";
				extent = "500 24";
				minExtent = "8 2";
				enabled = "1";
				visible = false;
				clipToParent = "1";
				color = "180 180 180 255";
			};
			SRB_CH_FoodContainer.add(%swatch);
			%swatch.position = 0 SPC %food_count * 23 + 4;
			
			// creating bitmap/text
			%bitmap = new GuiBitmapCtrl()
			{
				alignLeft = false;
				alignTop = false;
				bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ strReplace(%data.icon, " ", "") @ ".png";
				clipToParent = true;
				enabled = true;
				extent = "24 24";
				horizSizing = "right";
				keepCached = false;
				lockAspectRatio = false;
				mColor = "255 255 255 255";
				minExtent = "1 1";
				mMultiply = false;
				overflowImage = false;
				position = "2 2";
				profile = "GuiDefaultProfile";
				vertSizing = "bottom";
				visible = true;
				wrap = false;
				
				food_text = %text;
			};
			SRB_CH_FoodContainer.add(%bitmap);
			%bitmap.position = 5 SPC %food_count * 23 + 4;
			
			%text = new GuiMLTextCtrl()
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "500 20";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 99";
				profile = "GuiMLTextProfile";
				selectable = false;
				text = %data.count SPC trim(%data.text) @ (%data.count != 1 ? "'s" : "");
				vertSizing = "bottom";
				visible = true;
				
				food_text = %text;
			};
			SRB_CH_FoodContainer.add(%text);
			%text.position = 33 SPC %food_count * 23 + 9;
			
			%mouse = new GuiMouseEventCtrl(SRB_FoodInventoryEat)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "140 24";
				minExtent = "8 2";
				enabled = true;
				visible = true;
				clipToParent = true;
				lockMouse = false;
				
				food = trim(%data.text);
				icon = %data.icon;
				count = %data.count;
				
				swatch = %swatch;
			};
			SRB_CH_FoodContainer.add(%mouse);
			%mouse.position = 0 SPC %food_count * 23 + 4;
			
			%food_count++;
		}
	}
	
	SRB_CH_FoodContainer.resize(1, 1, getWord(SRB_CH_FoodContainer.extent, 0), mClamp(%food_count * 23 + 10, 236, 1000));
}

function SRB_FoodInventoryEat::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = true;
	%this.mousedown = true;
}

function SRB_FoodInventoryEat::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
	
	SuburbiaClient.eat_food = %this.food;
	SuburbiaClient.eat_food_icon = %this.icon;
	
	SRB_Food_Eat_Text.setText("<just:center>Do you want to eat a" SPC %this.food @ "?");
	Canvas.pushDialog(SRB_Character_Eat);
}

function SRB_FoodInventoryEat::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
}

function displayFoodInfo()
{
	if(SuburbiaClient.eat_food !$= "")
	{
		%name = SuburbiaClient.eat_food;
		%icon = SuburbiaClient.eat_food_icon;
		
		Suburbia_FoodInfoTitle.setText("<just:center><font:Arial Bold: 25>" @ %name);
	
		%icon = strReplace(%icon, " 1", "");
		%icon = strReplace(%icon, " 2", "");
		%icon = strReplace(%icon, " 3", "");
		%icon = strReplace(%icon, " ", "");
		
		Suburbia_FoodInfoBitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon @ ".png");
		Suburbia_FoodInfoBitmap.visible = true;
		Suburbia_FoodInfoBackground.visible = true;
		
		Canvas.pushDialog(SRB_Character_FoodInfo);
		
		%position = 170;
		
		for(%i = 0; %i < 4; %i++)
		{
			%element = ("Suburbia_FoodInfoText" @ %i);
			
			%text = SuburbiaClient.food_recipe[%name, "info" @ %i];
			%element.setText("<font:Arial:16>" @ %text);
			%element.forceReflow();
			%element.position = 10 SPC %position;
			%position += getWord(%element.extent, 1) + 6;
		}
	}
}





function setCharacterTab(%tab)
{
	for(%i = 1; %i <= 7; %i++)
		("SRB_Screen_Tab" @ %i).visible = false;
	
	("SRB_Screen_Tab" @ %tab).visible = true;
	
	if(%tab == 1)
		SRB_Character_Window.extent = "530 420";
	else if(%tab == 2)
		SRB_Character_Window.extent = "530 400";
	else if(%tab == 3 || %tab == 4 || %tab == 6)
		SRB_Character_Window.extent = "530 450";
	else
		SRB_Character_Window.extent = "530 396";
	
	for(%i = 1; %i <= 7; %i++)
		("SRB_Character_Tab" @ %i).mColor = "255 255 255 255";
	
	("SRB_Character_Tab" @ %tab).mColor = "90 96 254 255";
}







function clientCmdSetBuffs(%buff1, %buff1_desc, %buff2, %buff2_desc, %buff3, %buff3_desc, %buff4, %buff4_desc)
{
	SuburbiaClient.buff_count = 0;
	
	if(%buff1 !$= "")
	{
		SuburbiaClient.buff[SuburbiaClient.buff_count] = %buff1;
		SuburbiaClient.buff[SuburbiaClient.buff_count, "desc"] = %buff1_desc;
		SuburbiaClient.buff_count++;
	}
	else
	{
		displayFoodBuffs();
		
		SRB_VomitButton.visible = false;
		SRB_NoBuffsText.visible = true;
		return;
	}
	
	if(%buff2 !$= "")
	{
		SuburbiaClient.buff[SuburbiaClient.buff_count] = %buff2;
		SuburbiaClient.buff[SuburbiaClient.buff_count, "desc"] = %buff2_desc;
		SuburbiaClient.buff_count++;
	}
	
	if(%buff3 !$= "")
	{
		SuburbiaClient.buff[SuburbiaClient.buff_count] = %buff3;
		SuburbiaClient.buff[SuburbiaClient.buff_count, "desc"] = %buff3_desc;
		SuburbiaClient.buff_count++;
	}
	
	if(%buff4 !$= "")
	{
		SuburbiaClient.buff[SuburbiaClient.buff_count] = %buff4;
		SuburbiaClient.buff[SuburbiaClient.buff_count, "desc"] = %buff4_desc;
		SuburbiaClient.buff_count++;
	}
	
	SRB_VomitButton.visible = (SuburbiaClient.perk !$= "Second Stomach");
	SRB_NoBuffsText.visible = false;
	
	displayFoodBuffs();
}

function displayFoodBuffs()
{
	SRB_Buff_Container.deleteAll();
	SRB_BuffDesc_Container.deleteAll();
	
	%count = SuburbiaClient.buff_count;
	%shift = (%count * 104) / 2;
	%shift2 = (%count * 138) / 2;
	for(%i = 0; %i < %count; %i++)
	{
		%x = (%i * 104);
		%mod = 260;
		%x += %mod;
		
		%name = SuburbiaClient.buff[%i];
		
		%icon = strReplace(%name, " 1", "");
		%icon = strReplace(%icon, " 2", "");
		%icon = strReplace(%icon, " 3", "");
		
		%buff_panel = new GuiSwatchCtrl() 
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "52 32";
			extent = "98 116";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			color = "0 0 0 255";
			
			new GuiSwatchCtrl() 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "2 2";
				extent = "94 94";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				color = "0 132 192 255";
			};
			
			new GuiBitmapCtrl() 
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "2 2";
				extent = "94 94";
				minExtent = "1 1";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon;
				wrap = "0";
				lockAspectRatio = "0";
				alignLeft = "0";
				alignTop = "0";
				overflowImage = "0";
				keepCached = "0";
				mColor = "255 255 255 255";
				mMultiply = "0";
			};
			
			new GuiMLTextCtrl() 
			{
				profile = "ServerListProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 99";
				extent = "96 14";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				lineSpacing = "2";
				allowColorChars = "1";
				maxChars = "-1";
				text = "<color:ffffff><just:center><font:Arial:14>" @ %name;
				maxBitmapHeight = "-1";
				selectable = "1";
				autoResize = "1";
			};
			
			new GuiMLTextCtrl(SRB_TextTemp) 
			{
				profile = "Suburbia_BuffTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "72 58";
				extent = "24 43";
				minExtent = "8 2";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				text = "";
				maxBitmapHeight = "-1";
				selectable = "1";
				autoResize = "0";
			};
		};
		SRB_Buff_Container.add(%buff_panel);
		
		if(strPos(%name, "1") != -1)
		{
			SRB_TextTemp.setText("<just:center><font:Arial bold:45>1");
			SRB_TextTemp.position = "76 58";
		}
		else if(strPos(%name, "2") != -1)
		{
			SRB_TextTemp.setText("<just:center><font:Arial bold:45>2");
			SRB_TextTemp.position = "72 58";
		}
		else if(strPos(%name, "3") != -1)
		{
			SRB_TextTemp.setText("<just:center><font:Arial bold:45>3");
			SRB_TextTemp.position = "73 58";
		}
		
		%buff_panel.position = (%x - %shift) SPC 32;
		
		
		
		%x = (%i * 138);
		%mod = 260 + 3;
		%x += %mod;
		
		%title = new GuiMLTextCtrl() 
		{
			profile = "GuiMLTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "191 30";
			extent = "132 16";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "<font:Arial bold:16>" SPC %name;
			maxBitmapHeight = "-1";
			selectable = "1";
			autoResize = "1";
		};
		SRB_BuffDesc_Container.add(%title);
		%title.position = (%x - %shift2) SPC 30;
		
		%desc = new GuiMLTextCtrl()
		{
			profile = "GuiMLTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "191 49";
			extent = "132 89";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "-" SPC SuburbiaClient.buff[%i, "desc"];
			maxBitmapHeight = "-1";
			selectable = "1";
			autoResize = "0";
		};
		SRB_BuffDesc_Container.add(%desc);
		%desc.position = (%x - %shift2) SPC 49;
		
		if(SuburbiaClient.perk $= "Second Stomach")
		{
			%button = new GuiBitmapButtonCtrl()
			{
				profile = "BlockButtonProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "194 125";
				extent = "112 30";
				minExtent = "1 1";
				enabled = "1";
				visible = "1";
				clipToParent = "1";
				command = "CommandToServer('Vomit', " @ %i + 1 @ ");";
				text = "Vomit";
				groupNum = "-1";
				buttonType = "PushButton";
				bitmap = "base/client/ui/button1";
				lockAspectRatio = "0";
				alignLeft = "0";
				alignTop = "0";
				overflowImage = "0";
				mKeepCached = "0";
				mColor = "255 255 255 255";
				color = "255 255 255 255";
			};
			SRB_BuffDesc_Container.add(%button);
			%button.position = (%x - %shift2) + 6 SPC 125;
		}
	}
}





















function createPerkIcon(%name, %icon_file, %position)
{
	%gui_name = "SRB_PerkIcon_" @ %name;
	
	%icon = new GuiSwatchCtrl(%gui_name)
	{
		clipToParent = 1;
		color = "0 0 0 255";
		enabled = 1;
		extent = "98 116";
		horizSizing = "right";
		minExtent = "1 1";
		position = %position;
		profile = "GuiDefaultProfile";
		vertSizing = "bottom";
		visible = 1;
		
		new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = "Add-Ons/Client_Suburbia/gui/icons/perks/" @ %icon_file @ ".png";
			clipToParent = true;
			enabled = true;
			extent = "94 94";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
		};
		
		new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "ServerListProfile";
			selectable = true;
			text = "<color:ffffff><just:center><font:Arial:14>" @ %name;
			caption = %name;
			vertSizing = "bottom";
			visible = true;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "0 0";
			extent = "98 116";
			horizSizing = "right";
			minExtent = "1 1";
			position = "0 0";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "2 2";
			extent = "94 94";
			horizSizing = "right";
			minExtent = "1 1";
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiMouseEventCtrl(SRB_PerkIconMouse)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "98 116";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
		};
	};
	Suburbia_PerkScrollBackground.add(%icon);
	%icon.position = %position;
	
	%icon.icon_image = %icon.getObject(0);
	%icon.icon_caption = %icon.getObject(1);
	%icon.white_tint = %icon.getObject(2);
	%icon.yellow_tint = %icon.getObject(3);
	%icon.icon_mouseCtrl = %icon.getObject(4);
	
	%icon.original_position = %position;
	
	%icon.perk_name = %name;
	
	return %gui_name;
}

function addPerkIcon(%name, %icon_file)
{
	if(Suburbia_PerkScroll.suburbia_currentRow $= "")
		Suburbia_PerkScroll.suburbia_currentRow = 1;
	
	// calculate the height that we should be at
	%current_row = Suburbia_PerkScroll.suburbia_currentRow;
	%height = (((%current_row - 1) * 116) + (%current_row * 7));
	
	// determine where along the x axis we should place the icon
	if(Suburbia_PerkScroll.suburbia_row[%current_row, "slot"] $= "")
		Suburbia_PerkScroll.suburbia_row[%current_row, "slot"] = 1;
	
	%current_slot = Suburbia_PerkScroll.suburbia_row[%current_row, "slot"];
	%width = (((%current_slot - 1) * 98) + (%current_slot * 7));
	
	// create the gui and file the icon under an array all at the same time
	%icon = Suburbia_PerkScroll.suburbia_row[%current_slot, Suburbia_PerkScroll.suburbia_row[%current_row, "slot"]] = createPerkIcon(%name, %icon_file, %width SPC %height);
	
	// if we have too many icons on one row, increment the total row count so next time we start on a new row
	if(Suburbia_PerkScroll.suburbia_row[%current_row, "slot"] == 2)
		Suburbia_PerkScroll.suburbia_currentRow++;
	else
		Suburbia_PerkScroll.suburbia_row[%current_row, "slot"]++;
		
	// resizing the background so that the scroll works right
	%background_height = (%current_row * 116) + ((%current_row + 1) * 7);
	
	if(%background_height < 335)
		%background_height = 335;
	
	Suburbia_PerkScrollBackground.resize(1, 1, 220, %background_height);
	
	return %icon;
}

function SRB_PerkIconMouse::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setMouseDown();
}

function SRB_PerkIconMouse::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	if(%this.mouseDown)
		%this.setSelectColors();
}

function SRB_PerkIconMouse::onMouseEnter(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setHoverColors();
}

function SRB_PerkIconMouse::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.resetHoverColors();
	
	%scroll = %this.getGroup().getGroup();
	if(%this.mouseDown == true && %this.isSelected == false && %scroll.currently_selected == %this)
		%this.resetSelectColors();
	
	if(%this.mouseDown == true)
		%this.resetMouseDown();
	
	%this.mouseDown = false;
}

function SRB_PerkIconMouse::setHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("255 255 255 90");
	
	%this.hoverActive = true;
}

function SRB_PerkIconMouse::resetHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("0 0 0 0");
	
	%this.hoverActive = false;
}

function SRB_PerkIconMouse::setSelectColors(%this)
{
	%this.resetMouseDown();
	%parent = %this.getGroup();
	
	%parent.yellow_tint.setColor("255 255 0 115");
	%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:14>" @ %parent.icon_caption.caption);
	
	%scroll = %parent.getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	// set the description shit
	Suburbia_PerkDescTitle.setValue("<just:center><font:Arial bold:24>" @ %parent.perk_name);
	Suburbia_PerkDescBitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/perks/" @ $Suburbia::PerkData[%parent.perk_name, "icon"] @ ".png");
	Suburbia_PerkDescCover.visible = false;
	
	
	%desc_parent = Suburbia_PerkDescParent;
	%real_name = %parent.perk_name;
	
	// remove old perk descriptions
	%count = %desc_parent.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = %desc_parent.getObject(%i);
		
		if(isObject(%obj))
			if(%obj.getName() $= "Suburbia_PerkDescContent")
				%obj.delete();
	}
	
	// perk descriptions
	%desc_count = 1;
	%position = 190;
	for(%i = 1; %i < 4; %i++)
	{
		%index = "desc" @ %i;
		
		if($Suburbia::PerkData[%real_name, %index] !$= "")
		{
			%text = $Suburbia::PerkData[%real_name, %index];
			
			%desc = new GuiMLTextCtrl(Suburbia_PerkDescContent)
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "240 0";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 0";
				profile = "GuiMLTextProfile";
				selectable = true;
				text = "";
				caption = %name;
				vertSizing = "bottom";
				visible = true;
			};
			%desc_parent.add(%desc);
			%desc.setText("<font:Arial:17><lmargin:20>- " @ setWord(%text, 2, "<lmargin:33>" @ getWord(%text, 2)));
			%desc.forceReflow();
			%desc.position = 0 SPC %position;
			%position += getWord(%desc.extent, 1) + 6;
		}
		else
			break;
	}
	
	%scroll.currently_selected = %this;
	%this.isSelected = true;
}

function SRB_PerkIconMouse::resetSelectColors(%this)
{
	%this.getGroup().yellow_tint.setColor("0 0 0 0");
	%this.getGroup().icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	
	%scroll = %this.getGroup().getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	%scroll.currently_selected = "";
	
	%this.isSelected = false;
}

function SRB_PerkIconMouse::setMouseDown(%this)
{
	%parent = %this.getGroup();
	
	if(%parent.original_position $= "")
		%parent.original_position = %parent.position;
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0) + 2, getWord(%position, 1) + 2, 94, 112);
	
	if(!%this.isSelected)
		%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	else
		%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	
	%parent.icon_caption.resize(0, 96, 92, 20);
	
	%parent.icon_image.resize(2, 2, 90, 90);
	%parent.yellow_tint.resize(2, 2, 90, 90);
	
	%this.mouseDown = true;
}

function SRB_PerkIconMouse::resetMouseDown(%this)
{
	%parent = %this.getGroup();
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0), getWord(%position, 1), 98, 116);
	
	%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	%parent.icon_caption.resize(0, 99, 96, 20);
	
	%parent.icon_image.resize(2, 2, 94, 94);
	%parent.yellow_tint.resize(2, 2, 94, 94);
	
	%this.mouseDown = false;
}

function resetSelectedPerkIcon()
{
	if(isObject(Suburbia_PerkScrollBackground.currently_selected))
		if(isFunction(Suburbia_PerkScrollBackground.currently_selected.getName(), resetSelectColors))
			Suburbia_PerkScrollBackground.currently_selected.resetSelectColors();
	
	Suburbia_PerkDescCover.visible = true;
	Suburbia_PerkDescTitle.setText("");
}

function displayPerks()
{
	clearPerkScrollList();
	
	for(%i = 0; %i < $Suburbia::PerkDataCount; %i++)
	{
		%perk_name = $Suburbia::PerkData[%i];
		%icon_name = $Suburbia::PerkData[%perk_name, "icon"];
		%icon = addPerkIcon(%perk_name, %icon_name);
		%icon.perk_name = %perk_name;
	}
	// $Suburbia::PerkStatsDisplayed = true;
}

function clearPerkScrollList()
{
	%count = getTaggedFieldCount(Suburbia_PerkScroll);
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%field = Suburbia_PerkScroll.getTaggedField(%i);
		%field_name = expandEscape(getField(%field, 0));
		eval("Suburbia_PerkScroll." @ %field_name @ " = \"\";");
	}
	
	%count = Suburbia_PerkScrollBackground.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = Suburbia_PerkScrollBackground.getObject(%i);
		
		if(isObject(%obj))
			%obj.delete();
	}
}

function clearPerks()
{
	$Suburbia::PerkStatsDisplayed = false;
	DeleteVariables("$Suburbia::PerkData*");
	clearPerkScrollList();
	Suburbia_PerkDescCover.visible = true;
}

function clientCmdReceivePerkData(%perk_name, %icon_name, %desc1, %desc2, %desc3, %desc4)
{
	if($Suburbia::PerkDataCount $= "")
		$Suburbia::PerkDataCount = 0;
	
	$Suburbia::PerkData[$Suburbia::PerkDataCount] = %perk_name;
	$Suburbia::PerkData[%perk_name, "icon"] = %icon_name;
	$Suburbia::PerkData[%perk_name, "desc1"] = %desc1;
	$Suburbia::PerkData[%perk_name, "desc2"] = %desc2;
	$Suburbia::PerkData[%perk_name, "desc3"] = %desc3;
	$Suburbia::PerkData[%perk_name, "desc4"] = %desc4;
	
	$Suburbia::PerkDataCount++;
}

function clientCmdClearPerks()
{
	clearPerks();
}

function clientCmdSetPerk(%perk)
{
	SuburbiaClient.perk = %perk;
	SRB_CurrentPerkText.setText("<font:Arial bold:18>Current Perk:" SPC (%perk !$= "" ? %perk : "None"));
}

function selectPerk()
{
	CommandToServer('SetPerk', Suburbia_PerkScrollBackground.currently_selected.getGroup().perk_name);
}




function clientCmdSetCraftingBrickInfo(%public, %law)
{
	SuburbiaClient.public_crafting = %public;
	SuburbiaClient.public_crafting_illegal = %law;
}

function clientCmdClearRecipeInfo()
{
	SuburbiaClient.weapon_recipie_count = 0;
	SuburbiaClient.food_recipie_count = 0;
}

function showRecipe()
{
	if(SuburbiaClient.recipe_section $= "weapons")
	{
		%name = SuburbiaClient.recipe_list.getRowTextById(SuburbiaClient.recipe_list.getSelectedId());
		%icon = SuburbiaClient.weapon_recipe[%name, "icon"];
		%recipe = SuburbiaClient.weapon_recipe[%name, "recipe"];
		%info0 = SuburbiaClient.weapon_recipe[%name, "info0"];
		%info1 = SuburbiaClient.weapon_recipe[%name, "info1"];
		%info2 = SuburbiaClient.weapon_recipe[%name, "info2"];
		%info3 = SuburbiaClient.weapon_recipe[%name, "info3"];
		
		if(%recipe $= "")
		{
			SuburbiaClient.recipe_cover.visible = true;
			return;
		}
		else
			SuburbiaClient.recipe_cover.visible = false;
		
		setWeaponCraftingRecipeInfo(%name, %icon, %recipe, %info0, %info1, %info2, %info3);
		
		Suburbia_CraftingButton.setText("Craft Weapon");
	}
	else if(SuburbiaClient.recipe_section $= "food")
	{
		%name = SuburbiaClient.recipe_list.getRowTextById(SuburbiaClient.recipe_list.getSelectedId());
		%icon = SuburbiaClient.food_recipe[%name, "icon"];
		%recipe = SuburbiaClient.food_recipe[%name, "recipe"];
		%info0 = SuburbiaClient.food_recipe[%name, "info0"];
		%info1 = SuburbiaClient.food_recipe[%name, "info1"];
		%info2 = SuburbiaClient.food_recipe[%name, "info2"];
		%info3 = SuburbiaClient.food_recipe[%name, "info3"];
		
		if(%recipe $= "")
		{
			SuburbiaClient.recipe_cover.visible = true;
			return;
		}
		else
			SuburbiaClient.recipe_cover.visible = false;
		
		setFoodCraftingRecipeInfo(%name, %icon, %recipe, %info0, %info1, %info2, %info3);
		
		Suburbia_CraftingButton.setText("Craft Food");
	}
}

function displayWeaponRecipes()
{
	SuburbiaClient.recipe_cover.visible = true;
	
	SuburbiaClient.recipe_weapon_button.mColor = "90 96 245 255";
	SuburbiaClient.recipe_food_button.mColor = "225 225 225 255";
	
	SuburbiaClient.recipe_list.clear();
	
	SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), " ");
	
	%displayed_law = false;
	for(%i = 1; %i <= 5; %i++)
	{
		// not showing illegal tier weapons
		if(SuburbiaClient.public_crafting && SuburbiaClient.recipe_list !$= Suburbia_RecipeList)
		{
			if(SuburbiaClient.public_crafting_illegal == 3 && %i == 5)
			{
				SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), "\c5The Quake Tier weapons are illegal to");
				SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), "\c5craft at this public crafting brick!");
				break;
			}
			else if(SuburbiaClient.public_crafting_illegal == 2 && (%i == 5 || %i == 3))
			{
				if(%displayed_law == false)
				{
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5The Quake Tier and Specialist Tier");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5weapons are illegal to craft at this public");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5crafting brick!");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), " ");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5The status of these weapons has been");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5enacted via law by the Mayor.");
					%displayed_law = true;
					// echo(%displayed_law);
				}
				continue;
			}
			else if(SuburbiaClient.public_crafting_illegal == 1 && (%i == 5 || %i == 3 || %i == 2))
			{
				if(%displayed_law == false)
				{
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5The Quake Tier, Specialist Tier and");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5Normal Tier weapons are illegal to craft at");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5this public crafting brick!");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), " ");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5The status of these weapons has been");
					SuburbiaClient.recipe_list.schedule(1, addRow, SuburbiaClient.recipe_list.rowCount(), "\c5enacted via law by the Mayor.");
					%displayed_law = true;
				}
				continue;
			}
		}
		
		if(%i == 1)
			%tier = "Bad Weapons";
		else if(%i == 2)
			%tier = "Normal Weapons";
		else if(%i == 3)
			%tier = "Specialist Weapons";
		else if(%i == 4)
			%tier = "Non-Harmful Items";
		else if(%i == 5)
			%tier = "Quake Weapons";
		
		SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), "\c4" @ %tier);
		SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), "\c4---------------------------------------------------");
		
		for(%x = 0; %x < SuburbiaClient.weapon_recipe_count[%i]; %x++)
		{
			%name = SuburbiaClient.weapon_recipe[%i, %x];
			SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), %name);
		}
		
		SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), " ");
	}
}

function clientCmdAddWeaponInfo(%name, %icon, %tier, %recipe, %illegal, %info0, %info1, %info2, %info3)
{
	if(SuburbiaClient.weapon_recipe[%name, "icon"] $= "")
		%noexist = true;
	else
		%noexist = false;
	
	// echo(%name SPC %illegal SPC %noexist);
	
	SuburbiaClient.weapon_recipe[%name, "icon"] = %icon;
	SuburbiaClient.weapon_recipe[%name, "tier"] = %tier;
	SuburbiaClient.weapon_recipe[%name, "recipe"] = %recipe;
	SuburbiaClient.weapon_recipe[%name, "illegal"] = %illegal;
	SuburbiaClient.weapon_recipe[%name, "info0"] = %info0;
	SuburbiaClient.weapon_recipe[%name, "info1"] = %info1;
	SuburbiaClient.weapon_recipe[%name, "info2"] = %info2;
	SuburbiaClient.weapon_recipe[%name, "info3"] = %info3;
	
	if(%noexist)
	{
		if(SuburbiaClient.weapon_recipe_count[%tier] $= "")
			SuburbiaClient.weapon_recipe_count[%tier] = 0;
		
		SuburbiaClient.weapon_recipe[%tier, SuburbiaClient.weapon_recipe_count[%tier]] = %name;
		SuburbiaClient.weapon_recipe_count[%tier]++;
	}
}

function setWeaponCraftingRecipeInfo(%name, %icon, %recipe, %info0, %info1, %info2, %info3)
{
	SuburbiaClient.recipe_title.setText("<just:center><font:Arial Bold: 25>" @ %name);
	
	SuburbiaClient.recipe_bitmap.setBitmap(%icon);
	SuburbiaClient.recipe_bitmap.visible = true;
	SuburbiaClient.recipe_background.visible = true;
	
	%position = 170;
	SuburbiaClient.recipe_text.setText("<font:Arial:16>Recipe:" SPC %recipe);
	SuburbiaClient.recipe_text.forceReflow();
	SuburbiaClient.recipe_text.position = 10 SPC %position;
	%position += getWord(SuburbiaClient.recipe_text.extent, 1) + 6;
	
	for(%i = 0; %i < 4; %i++)
	{
		%text = %info[%i];
		SuburbiaClient.recipe_infotext[%i].setText("<font:Arial:16>" @ %text);
		SuburbiaClient.recipe_infotext[%i].forceReflow();
		SuburbiaClient.recipe_infotext[%i].position = 10 SPC %position;
		%position += getWord(SuburbiaClient.recipe_infotext[%i].extent, 1) + 6;
	}
}







function displayFoodRecipes()
{
	SuburbiaClient.recipe_cover.visible = true;
	
	SuburbiaClient.recipe_food_button.mColor = "90 96 245 255";
	SuburbiaClient.recipe_weapon_button.mColor = "225 225 225 255";
	
	SuburbiaClient.recipe_list.clear();
	
	SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), " ");
	
	for(%i = 1; %i <= 4; %i++)
	{
		if(SuburbiaClient.public_crafting && %i == 4 && SuburbiaClient.recipe_list !$= Suburbia_RecipeList)
		{
			SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), "\c5The Tier 4 foods are illegal to craft at this");
			SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), "\c5public crafting brick!");
			break;
		}
		
		SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), "\c4Tier" SPC %i);
		SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), "\c4---------------------------------------------------");
		
		for(%x = 0; %x < SuburbiaClient.food_recipe_count[%i]; %x++)
		{
			%name = SuburbiaClient.food_recipe[%i, %x];
			SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), %name);
		}
		
		SuburbiaClient.recipe_list.addRow(SuburbiaClient.recipe_list.rowCount(), " ");
	}
}

function clientCmdAddFoodInfo(%name, %tier, %recipe, %illegal, %info0, %info1, %info2, %info3)
{
	SuburbiaClient.food_recipe[%name, "icon"] = %name;
	SuburbiaClient.food_recipe[%name, "tier"] = %tier;
	SuburbiaClient.food_recipe[%name, "recipe"] = %recipe;
	SuburbiaClient.food_recipe[%name, "illegal"] = %illegal;
	SuburbiaClient.food_recipe[%name, "info0"] = %info0;
	SuburbiaClient.food_recipe[%name, "info1"] = %info1;
	SuburbiaClient.food_recipe[%name, "info2"] = %info2;
	SuburbiaClient.food_recipe[%name, "info3"] = %info3;
	
	if(SuburbiaClient.food_recipe_count[%tier] $= "")
		SuburbiaClient.food_recipe_count[%tier] = 0;
	
	SuburbiaClient.food_recipe[%tier, SuburbiaClient.food_recipe_count[%tier]] = %name;
	SuburbiaClient.food_recipe_count[%tier]++;
}

function setFoodCraftingRecipeInfo(%name, %icon, %recipe, %info0, %info1, %info2, %info3)
{
	SuburbiaClient.recipe_title.setText("<just:center><font:Arial Bold: 25>" @ %name);
	
	%icon = strReplace(%icon, " 1", "");
	%icon = strReplace(%icon, " 2", "");
	%icon = strReplace(%icon, " 3", "");
	%icon = strReplace(%icon, " ", "");
	
	SuburbiaClient.recipe_bitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon @ ".png");
	SuburbiaClient.recipe_bitmap.visible = true;
	SuburbiaClient.recipe_background.visible = true;
	
	%position = 170;
	SuburbiaClient.recipe_text.setText("<font:Arial:16>Recipe:" SPC %recipe);
	SuburbiaClient.recipe_text.forceReflow();
	SuburbiaClient.recipe_text.position = 10 SPC %position;
	%position += getWord(SuburbiaClient.recipe_text.extent, 1) + 6;
	
	for(%i = 0; %i < 4; %i++)
	{
		%text = %info[%i];
		SuburbiaClient.recipe_infotext[%i].setText("<font:Arial:16>" @ %text);
		SuburbiaClient.recipe_infotext[%i].forceReflow();
		SuburbiaClient.recipe_infotext[%i].position = 10 SPC %position;
		%position += getWord(SuburbiaClient.recipe_infotext[%i].extent, 1) + 6;
	}
}

function setCraftingMode(%mode)
{
	// character crafting gui display
	if(!%mode)
	{
		SuburbiaClient.recipe_list = Suburbia_RecipeList;
		SuburbiaClient.recipe_bitmap = Suburbia_WeaponRecipeBitmap;
		SuburbiaClient.recipe_background = Suburbia_WeaponRecipeBackground;
		SuburbiaClient.recipe_cover	= Suburbia_RecipeSwatchCover;
		SuburbiaClient.recipe_title = Suburbia_ItemDescTitle;
		SuburbiaClient.recipe_food_button = SRB_FoodsRecipeButton;
		SuburbiaClient.recipe_weapon_button = SRB_WeaponsRecipeButton;
		
		SuburbiaClient.recipe_text = Suburbia_RecipeText;
		SuburbiaClient.recipe_infotext0 = Suburbia_RecipeInfoText0;
		SuburbiaClient.recipe_infotext1 = Suburbia_RecipeInfoText1;
		SuburbiaClient.recipe_infotext2 = Suburbia_RecipeInfoText2;
		SuburbiaClient.recipe_infotext3 = Suburbia_RecipeInfoText3;
	}
	else
	{
		SuburbiaClient.recipe_list = Suburbia_RecipeList2;
		SuburbiaClient.recipe_bitmap = Suburbia_WeaponRecipeBitmap2;
		SuburbiaClient.recipe_background = Suburbia_WeaponRecipeBackground2;
		SuburbiaClient.recipe_cover	= Suburbia_RecipeSwatchCover2;
		SuburbiaClient.recipe_title = Suburbia_ItemDescTitle2;
		SuburbiaClient.recipe_food_button = SRB_FoodsRecipeButton2;
		SuburbiaClient.recipe_weapon_button = SRB_WeaponsRecipeButton2;
		
		SuburbiaClient.recipe_text = Suburbia_RecipeText2;
		SuburbiaClient.recipe_infotext0 = Suburbia_RecipeInfoText2_0;
		SuburbiaClient.recipe_infotext1 = Suburbia_RecipeInfoText2_1;
		SuburbiaClient.recipe_infotext2 = Suburbia_RecipeInfoText2_2;
		SuburbiaClient.recipe_infotext3 = Suburbia_RecipeInfoText2_3;
	}
}



function clientCmdShowCraftingGui()
{
	resetCraftingScreens();
	Canvas.pushDialog(SRB_Crafting_Main);
	setCraftingMode(1);
}

function clientCmdCloseCraftingGui()
{
	Canvas.popDialog(SRB_Crafting_Main);
}


function clientCmdShowCraftingDialog(%name, %amt)
{
	srb_showCraftingDialog(%name, %amt);
}

function srb_showCraftingDialog(%name, %amt)
{
	SuburbiaClient.crafting_item = %name;
	SuburbiaClient.max_crafting_amount = %amt;
	
	if(SuburbiaClient.recipe_section $= "food")
	{
		%icon = strReplace(%name, " 1", "");
		%icon = strReplace(%icon, " 2", "");
		%icon = strReplace(%icon, " 3", "");
		%icon = strReplace(%icon, " ", "");
		
		SRB_Crafting_Bitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon @ ".png");
	}
	else
	{
		SRB_Crafting_Bitmap.setBitmap(SuburbiaClient.weapon_recipe[%name, "icon"]);
		%icon = %name;
	}
	
	if(%name $= "Heavy Machine Gun" || %name $= "Warhead Launcher")
		SRB_Crafting_Text.setText("<font:Calibri:23>Craft" SPC %name);
	else
		SRB_Crafting_Text.setText("<font:Calibri:24>Craft" SPC %name);
	
	SRB_CraftButton.setText("Craft" SPC %name);
	
	SRB_Crafting_Bitmap.position = 54 + SuburbiaClient.crafting_offset[%icon] SPC 29;
	SRB_Crafting_Text.position = 100 + SuburbiaClient.crafting_offset[%icon] SPC 38;
	
	Canvas.pushDialog(SRB_Crafting_Amount);
	
	SRB_CraftingInput.setValue("");
	SRB_CraftMaxAmount.setText("You can only craft a max of" SPC SuburbiaClient.max_crafting_amount);
}

function setCraftingAmountInput(%val)
{
	if(%val !$= "")
		%val = mClamp(%val, 0, SuburbiaClient.max_crafting_amount);
	
	SRB_CraftingInput.setValue(%val);
}

function srb_craftItem()
{
	%name = SuburbiaClient.crafting_item;
	%count = SRB_CraftingInput.getValue();
	
	CommandToServer('CraftItem', %name, %count);
}

function resetCraftingScreens()
{
	Suburbia_RecipeList.clear();
	Suburbia_RecipeList2.clear();
	
	Suburbia_RecipeSwatchCover.visible = true;
	Suburbia_RecipeSwatchCover2.visible = true;
	
	SRB_FoodsRecipeButton.mColor = "225 225 225 255";
	SRB_WeaponsRecipeButton.mColor = "225 225 225 255";
	
	SRB_FoodsRecipeButton2.mColor = "225 225 225 255";
	SRB_WeaponsRecipeButton2.mColor = "225 225 225 255";
}










function clientCmdSuburbia_SetSalesTax(%tax)
{
	SuburbiaClient.sales_tax = %tax;
	SRB_Shop_SalesTax.setText("Current Sales Tax:" SPC mFloor(%tax * 100) @ "%");
	SRB_Shop_SalesTax.centerX();
}

if(!isObject(SuburbiaShop))
	new ScriptObject(SuburbiaShop);

function showShopGui()
{
	CommandToServer('RequestShopUpdate');
}

function clientCmdFinishShopUpdate()
{
	displayShopType("food");
	Canvas.pushDialog(SRB_Character_Shop);
}

function displayShopFoodInfo(%name)
{
	SRB_ShopDescCover.visible = false;
	
	%position = 32;
	
	%icon = strReplace(%name, " 1", "");
	%icon = strReplace(%icon, " 2", "");
	%icon = strReplace(%icon, " 3", "");
	%icon = strReplace(%icon, " ", "");
	
	SRB_ShopItemTitle.setText("<just:center><font:Arial Bold:18>" @ %name);
	
	SRB_ShopBitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon @ ".png");
	
	for(%i = 0; %i < 4; %i++)
	{
		%element = ("Suburbia_ShopText_" @ %i);
		
		%text = SuburbiaClient.food_recipe[%name, "info" @ %i];
		%element.setText("<font:Arial:16>" @ %text);
		%element.forceReflow();
		%element.position = 126 SPC %position;
		%position += getWord(%element.extent, 1) + 6;
	}
}

function displayShopWeaponInfo(%name)
{
	SRB_ShopDescCover.visible = false;
	
	%position = 32;
	
	%icon = strReplace(%name, " 1", "");
	%icon = strReplace(%icon, " 2", "");
	%icon = strReplace(%icon, " 3", "");
	%icon = strReplace(%icon, " ", "");
	
	SRB_ShopItemTitle.setText("<just:center><font:Arial Bold:18>" @ %name);
	
	SRB_ShopBitmap.setBitmap(SuburbiaClient.weapon_recipe[%name, "icon"]);
	
	for(%i = 0; %i < 4; %i++)
	{
		%element = ("Suburbia_ShopText_" @ %i);
		
		%text = SuburbiaClient.weapon_recipe[%name, "info" @ %i];
		%element.setText("<font:Arial:16>" @ %text);
		%element.forceReflow();
		%element.position = 126 SPC %position;
		%position += getWord(%element.extent, 1) + 6;
	}
}

function displayShopResourceInfo(%name)
{
	SRB_ShopDescCover.visible = false;
	
	SRB_ShopItemTitle.setText("<just:center><font:Arial Bold:18>" @ %name);
	
	SRB_ShopBitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %name @ ".png");
	
	for(%i = 0; %i < 4; %i++)
	{
		%element = ("Suburbia_ShopText_" @ %i);
		%element.setText("");
	}
}




function displayPlayerShopResources()
{
	SRB_Shop_PlayerInventory.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 0; %i < 14; %i++)
	{
		%name = SuburbiaClient.ingredients[%i];
		%count = SuburbiaClient.ingredients[%name];
		
		if(%count <= 0 || %displayed[%name] == true)
			continue;
		
		if(%name $= "Puff" || %name $= "Henk" || %name $= "Krunt" || %name $= "Boom" || %name $= "Mystery Meat")
			continue;
		
		%displayed[%name] = true;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 24";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_Shop_PlayerInventory.add(%swatch);
		%swatch.position = 0 SPC %food_count * 23 + 4;
		
		if(%name $= "Mystery Meat")
			%icon = "corpse";
		else
			%icon = %name;
		
		// creating bitmap/text
		%bitmap = new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon @ ".png";
			clipToParent = true;
			enabled = true;
			extent = "24 24";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
			
			food_text = %text;
		};
		SRB_Shop_PlayerInventory.add(%bitmap);
		%bitmap.position = 5 SPC %food_count * 23 + 4;
		
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %count SPC %name @ ((%count != 1 && %name $= "Egg") ? "s" : "");
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_Shop_PlayerInventory.add(%text);
		%text.position = 33 SPC %food_count * 23 + 9;
		
		%mouse = new GuiMouseEventCtrl(SRB_PlayerShopResources)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 24";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "resource_player";
			resource = %name;
			icon = %icon;
			count = %count;
			
			swatch = %swatch;
		};
		SRB_Shop_PlayerInventory.add(%mouse);
		%mouse.position = 0 SPC %food_count * 23 + 4;
		
		%food_count++;
	}
	
	SRB_Shop_PlayerInventory.resize(1, 1, getWord(SRB_Shop_PlayerInventory.extent, 0), mClamp(%food_count * 23 + 10, 189, 1000));
}

function displayPlayerShopFoods()
{
	SRB_Shop_PlayerInventory.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 1; %i <= 4; %i++)
	{
		%tier_list = Suburbia_FoodGroup.tier[%i];
		
		%tier_list.sort(0, true);
		
		%count = %tier_list.rowCount();
		for(%x = 0; %x < %count; %x++)
		{
			%data = Suburbia_FoodGroup.food[%tier_list.getRowText(%x)];
			
			if(!isObject(%data) || %data.count <= 0 || %displayed[%tier_list.getRowText(%x)] == true)
				continue;
			
			if(SuburbiaClient.food_recipe[trim(%data.text), "illegal"])
				continue;
			
			%displayed[%tier_list.getRowText(%x)] = true;
			
			// swatch used for highlighting selected items
			%swatch = new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 4";
				extent = "140 24";
				minExtent = "8 2";
				enabled = "1";
				visible = false;
				clipToParent = "1";
				color = "180 180 180 255";
			};
			SRB_Shop_PlayerInventory.add(%swatch);
			%swatch.position = 0 SPC %food_count * 23 + 4;
			
			// creating bitmap/text
			%bitmap = new GuiBitmapCtrl()
			{
				alignLeft = false;
				alignTop = false;
				bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %data.icon @ ".png";
				clipToParent = true;
				enabled = true;
				extent = "24 24";
				horizSizing = "right";
				keepCached = false;
				lockAspectRatio = false;
				mColor = "255 255 255 255";
				minExtent = "1 1";
				mMultiply = false;
				overflowImage = false;
				position = "2 2";
				profile = "GuiDefaultProfile";
				vertSizing = "bottom";
				visible = true;
				wrap = false;
				
				food_text = %data.text;
			};
			SRB_Shop_PlayerInventory.add(%bitmap);
			%bitmap.position = 5 SPC %food_count * 23 + 4;
			
			%text = new GuiMLTextCtrl()
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "96 20";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 99";
				profile = "GuiMLTextProfile";
				selectable = false;
				text = %data.count SPC %data.text @ (%data.count != 1 ? "'s" : "");
				vertSizing = "bottom";
				visible = true;
				
				food_text = %text;
			};
			SRB_Shop_PlayerInventory.add(%text);
			%text.position = 33 SPC %food_count * 23 + 9;
			
			%mouse = new GuiMouseEventCtrl(SRB_PlayerShopResources)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "140 24";
				minExtent = "8 2";
				enabled = true;
				visible = true;
				clipToParent = true;
				lockMouse = false;
				
				type = "food_player";
				food = %data.text;
				icon = %data.icon;
				count = %data.count;
				
				swatch = %swatch;
			};
			SRB_Shop_PlayerInventory.add(%mouse);
			%mouse.position = 0 SPC %food_count * 23 + 4;
			
			%food_count++;
		}
	}
	
	SRB_Shop_PlayerInventory.resize(1, 1, getWord(SRB_Shop_PlayerInventory.extent, 0), mClamp(%food_count * 23 + 10, 189, 1000));
}

function clientCmdSetPlayerMaxAmt(%weapon1, %weapon2, %weapon3, %weapon4, %weapon5, %weapon6, %weapon7, %weapon8, %weapon9, %weapon10)
{
	for(%i = 1; %i <= 10; %i++)
		Suburbia_WeaponGroup.weapon_max_amt[getWords(%weapon[%i], 0, getWordCount(%weapon[%i]) - 2)] = getWord(%weapon[%i], getWordCount(%weapon[%i]) - 1);
}

function displayPlayerShopWeapons()
{
	SRB_Shop_PlayerInventory.deleteAll();
	
	Suburbia_WeaponGroup.player_weapons.sort(0, true);
	
	// going through the different tiers and then putting them in
	%count = Suburbia_WeaponGroup.player_weapons.rowCount();
	for(%i = 0; %i < %count; %i++)
	{
		%name = trim(Suburbia_WeaponGroup.player_weapons.getRowText(%i));
		
		if(%name $= "" || strLwr(%name) $= "hammer" || strLwr(%name) $= "wrench" || strLwr(%name) $= "printer")
			continue;
		
		if(SuburbiaClient.weapon_recipe[%name, "illegal"])
			continue;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 18";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_Shop_PlayerInventory.add(%swatch);
		%swatch.position = 0 SPC %weapon_count * 20 + 4;
		
		// creating bitmap/text
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %name;
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_Shop_PlayerInventory.add(%text);
		%text.position = 8 SPC %weapon_count * 20 + 6;
		
		%mouse = new GuiMouseEventCtrl(SRB_PlayerShopResources)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 18";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "weapons_player";
			weapon = %name;
			icon = %icon;
			count = 1;
			max_amt = Suburbia_WeaponGroup.weapon_max_amt[%name];
			
			swatch = %swatch;
		};
		SRB_Shop_PlayerInventory.add(%mouse);
		%mouse.position = 0 SPC %weapon_count * 20 + 4;
		
		%weapon_count++;
	}
	
	SRB_Shop_PlayerInventory.resize(1, 1, getWord(SRB_Shop_PlayerInventory.extent, 0), mClamp(%weapon_count * 23 + 10, 189, 1000));
}

function SRB_PlayerShopResources::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = true;
	%this.mousedown = true;
}

function SRB_PlayerShopResources::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
	
	if(%this.food !$= "")
	{
		SRB_ShopUpload_Bitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %this.icon @ ".png";
		SRB_ShopUpload_Text.setText("<font:Calibri:24>" @ %this.count SPC %this.food @ (%this.count != 1 ? "'s" : ""));
		
		SuburbiaShop.shop_sell_max = %this.count;
		SuburbiaShop.selected_name = %this.food;
		
		%food_name = trim(strReplace(%this.food, "1", ""));
		%food_name = trim(strReplace(%food_name, "2", ""));
		%food_name = trim(strReplace(%food_name, "3", ""));
		
		SRB_ShopUpload_Bitmap.position = 54 + SuburbiaClient.food_offset[%food_name] SPC 29;
		SRB_ShopUpload_Text.position = 100 + SuburbiaClient.food_offset[%food_name] SPC 38;
		
		Canvas.pushDialog(SRB_Character_ShopUpload);
	}
	else if(%this.resource !$= "")
	{
		SRB_ShopUpload_Bitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %this.icon @ ".png";
		SRB_ShopUpload_Text.setText("<font:Calibri:24>" @ %this.count SPC %this.resource);
		
		SuburbiaShop.shop_sell_max = %this.count;
		SuburbiaShop.selected_name = %this.resource;
		
		%resource_name = trim(strReplace(%this.resource, "1", ""));
		%resource_name = trim(strReplace(%resource_name, "2", ""));
		%resource_name = trim(strReplace(%resource_name, "3", ""));
		
		SRB_ShopUpload_Bitmap.position = 54 + SuburbiaClient.food_offset[%resource_name] SPC 29;
		SRB_ShopUpload_Text.position = 100 + SuburbiaClient.food_offset[%resource_name] SPC 38;
		
		Canvas.pushDialog(SRB_Character_ShopUpload);
	}
	else if(%this.weapon !$= "")
	{
		SRB_ShopUploadWeapon_Text.setText("<just:center><font:Calibri:24>" @ %this.weapon);
		SRB_ShopUploadItem_Text.setText("<just:center><font:Calibri:24>" @ %this.weapon);
		SRB_ShopUploadWeaponAmt_Text.setText("<just:center>You can sell" SPC %this.max_amt);
		
		SuburbiaShop.shop_sell_max = %this.count;
		SuburbiaShop.selected_name = %this.weapon;
		SuburbiaShop.max_amt = %this.max_amt;
		
		%weapon_name = trim(strReplace(%this.weapon, "1", ""));
		%weapon_name = trim(strReplace(%weapon_name, "2", ""));
		%weapon_name = trim(strReplace(%weapon_name, "3", ""));
		
		if(%this.max_amt !$= "")
			Canvas.pushDialog(SRB_Character_ShopUploadWeapons);
		else
			Canvas.pushDialog(SRB_Character_ShopUploadItems);
	}
	// echo(%this.weapon SPC "<= a");
}

function SRB_PlayerShopResources::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
}

function displayPlayerShopIllegalWeapons()
{
	Suburbia_WeaponGroup.player_weapons.sort(0, true);
	
	// going through the different tiers and then putting them in
	%count = Suburbia_WeaponGroup.player_weapons.rowCount();
	for(%i = 0; %i < %count; %i++)
	{
		%name = trim(Suburbia_WeaponGroup.player_weapons.getRowText(%i));
		
		if(%name $= "" || strLwr(%name) $= "hammer" || strLwr(%name) $= "wrench" || strLwr(%name) $= "printer")
			continue;
		
		if(!SuburbiaClient.weapon_recipe[%name, "illegal"])
			continue;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 18";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_Shop_PlayerInventory.add(%swatch);
		%swatch.position = 0 SPC %weapon_count * 20 + 4;
		
		// creating bitmap/text
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %name;
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_Shop_PlayerInventory.add(%text);
		%text.position = 8 SPC %weapon_count * 20 + 6;
		
		%mouse = new GuiMouseEventCtrl(SRB_PlayerShopResources)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 18";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "weapons_player";
			weapon = %name;
			icon = %icon;
			count = 1;
			
			swatch = %swatch;
		};
		SRB_Shop_PlayerInventory.add(%mouse);
		%mouse.position = 0 SPC %weapon_count * 20 + 4;
		
		%weapon_count++;
	}
	
	return %weapon_count;
}

function displayPlayerShopIllegalFoods(%total_count)
{
	// going through the different tiers and then putting them in
	for(%i = 1; %i <= 4; %i++)
	{
		%tier_list = Suburbia_FoodGroup.tier[%i];
		
		%tier_list.sort(0, true);
		
		%count = %tier_list.rowCount();
		for(%x = 0; %x < %count; %x++)
		{
			%data = Suburbia_FoodGroup.food[%tier_list.getRowText(%x)];
			
			if(!isObject(%data) || %data.count <= 0 || %displayed[%tier_list.getRowText(%x)] == true)
				continue;
			
			if(!SuburbiaClient.food_recipe[trim(%data.text), "illegal"])
				continue;
			
			%displayed[%tier_list.getRowText(%x)] = true;
			
			// swatch used for highlighting selected items
			%swatch = new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 4";
				extent = "140 18";
				minExtent = "8 2";
				enabled = "1";
				visible = false;
				clipToParent = "1";
				color = "180 180 180 255";
			};
			SRB_Shop_PlayerInventory.add(%swatch);
			%swatch.position = 0 SPC (%food_count + %total_count) * 20 + 4;
			
			%text = new GuiMLTextCtrl()
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "96 20";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 99";
				profile = "GuiMLTextProfile";
				selectable = false;
				text = %data.count SPC %data.text @ (%data.count != 1 ? "'s" : "");
				vertSizing = "bottom";
				visible = true;
				
				food_text = %text;
			};
			SRB_Shop_PlayerInventory.add(%text);
			%text.position = 8 SPC (%food_count + %total_count) * 20 + 6;
			
			%mouse = new GuiMouseEventCtrl(SRB_PlayerShopResources)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "140 18";
				minExtent = "8 2";
				enabled = true;
				visible = true;
				clipToParent = true;
				lockMouse = false;
				
				type = "food_player";
				food = %data.text;
				icon = %data.icon;
				count = %data.count;
				
				swatch = %swatch;
			};
			SRB_Shop_PlayerInventory.add(%mouse);
			%mouse.position = 0 SPC (%food_count + %total_count) * 20 + 4;
			
			%food_count++;
		}
	}
	
	return %food_count;
}

function displayPlayerShopIllegalResources(%total_count)
{
	// going through the different tiers and then putting them in
	for(%i = 0; %i < 14; %i++)
	{
		%name = SuburbiaClient.ingredients[%i];
		%count = SuburbiaClient.ingredients[%name];
		
		if(%count <= 0 || %displayed[%name] == true)
			continue;
		
		if(%name !$= "Puff" && %name !$= "Henk" && %name !$= "Krunt" && %name !$= "Boom" && %name !$= "Mystery Meat")
			continue;
		
		%displayed[%name] = true;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 24";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_Shop_PlayerInventory.add(%swatch);
		%swatch.position = 0 SPC (%food_count + %total_count) * 20 + 4;
		
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %count SPC %name @ ((%count != 1 && %name $= "Egg") ? "s" : "");
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_Shop_PlayerInventory.add(%text);
		%text.position = 8 SPC (%food_count + %total_count) * 20 + 6;
		
		if(%name $= "Mystery Meat")
			%icon = "corpse";
		else
			%icon = %name;
		
		%mouse = new GuiMouseEventCtrl(SRB_PlayerShopResources)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 24";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "resource_player";
			resource = %name;
			icon = %icon;
			count = %count;
			
			swatch = %swatch;
		};
		SRB_Shop_PlayerInventory.add(%mouse);
		%mouse.position = 0 SPC (%food_count + %total_count) * 20 + 4;
		
		%food_count++;
	}
	
	return %food_count;
}


function clientCmdClearShopItems()
{
	SuburbiaShop.item_count["food"] = 0;
	SuburbiaShop.item_count["weapon"] = 0;
	SuburbiaShop.item_count["resource"] = 0;
	SuburbiaShop.item_count["illegal"] = 0;
}

function clientCmdAddShopItem(%type, %item_name, %amt, %cost, %seller_name)
{
	if(SuburbiaShop.item_count[%type] $= "")
		SuburbiaShop.item_count[%type] = 0;
	
	SuburbiaShop.item[%type, SuburbiaShop.item_count[%type]] = %item_name TAB %amt TAB %cost TAB %seller_name;
	SuburbiaShop.item_count[%type]++;
}

function displayShopType(%type, %search)
{
	SRB_ShopDescCover.visible = true;
	
	SuburbiaShop.display_type = %type;
	
	if(%type $= "food")
	{
		SRB_Shop_FoodsButton.mColor = "90 96 245 255";
		SRB_Shop_WeaponsButton.mColor = "225 225 225 255";
		SRB_Shop_ResourcesButton.mColor = "225 225 225 255";
		SRB_Shop_IllegalButton.mColor = "225 225 225 255";
		
		Suburbia_FoodGroup.reorganizeFood();
		displayPlayerShopFoods();
	}
	else if(%type $= "weapon")
	{
		SRB_Shop_FoodsButton.mColor = "225 225 225 255";
		SRB_Shop_WeaponsButton.mColor = "90 96 245 255";
		SRB_Shop_ResourcesButton.mColor = "225 225 225 255";
		SRB_Shop_IllegalButton.mColor = "225 225 225 255";
		
		displayPlayerShopWeapons();
	}
	else if(%type $= "resource")
	{
		SRB_Shop_FoodsButton.mColor = "225 225 225 255";
		SRB_Shop_WeaponsButton.mColor = "225 225 225 255";
		SRB_Shop_ResourcesButton.mColor = "90 96 245 255";
		SRB_Shop_IllegalButton.mColor = "225 225 225 255";
		
		displayPlayerShopResources();
	}
	else if(%type $= "illegal")
	{
		SRB_Shop_FoodsButton.mColor = "225 225 225 255";
		SRB_Shop_WeaponsButton.mColor = "225 225 225 255";
		SRB_Shop_ResourcesButton.mColor = "225 225 225 255";
		SRB_Shop_IllegalButton.mColor = "90 96 245 255";
		
		SRB_Shop_PlayerInventory.deleteAll();
		Suburbia_FoodGroup.reorganizeFood();
		%total = displayPlayerShopIllegalWeapons();
		%total += displayPlayerShopIllegalFoods(%total);
		%total += displayPlayerShopIllegalResources(%total);
		
		SRB_Shop_PlayerInventory.resize(1, 1, getWord(SRB_Shop_PlayerInventory.extent, 0), mClamp(%total * 23 + 10, 189, 1000));
	}
	
	SRB_ShopDisplayList.clear();
	
	%count = SuburbiaShop.item_count[%type];
	for(%i = 0; %i < %count; %i++)
	{
		%item = SuburbiaShop.item[%type, %i];
		
		%name = getField(%item, 0);
		%amt = getField(%item, 1);
		%cost = getField(%item, 2);
		%seller = getField(%item, 3);
		
		if(%amt == 0)
			continue;
		
		if(%type $= "food")
			%thing = (%amt != 1 ? "'s" : "");
		else
			%thing = (%amt != 1 ? "s" : "");
		
		if(strPos(strLwr(%name), strLwr(%search)) != -1 || %search $= "")
			SRB_ShopDisplayList.addRow(SRB_ShopDisplayList.rowCount() + 3, %seller TAB %amt SPC trim(%name) @ %thing TAB " $" @ %cost TAB
			%name TAB %amt TAB %cost, 2);
	}
	
	SRB_ShopDisplayList.sortNumerical(5, true);
	
	SRB_ShopDisplayList.addRow(0, " ", 0);
	SRB_ShopDisplayList.addRow(1, "\c4Seller\tName\tCost", 1);
	SRB_ShopDisplayList.addRow(2, "\c4------------------------------------------------------------------", 2);
}

function updateShopItemInfo()
{
	%data = SRB_ShopDisplayList.getRowTextById(SRB_ShopDisplayList.getSelectedId());
	
	if(getField(%data, 5) $= "")
		return;
	
	SuburbiaShop.selected_item = getField(%data, 3);
	SuburbiaShop.selected_seller = getField(%data, 0);
	SuburbiaShop.selected_item_amount = getField(%data, 4);
	SuburbiaShop.selected_item_cost = getField(%data, 5);
	
	if(SuburbiaClient.food_recipe[SuburbiaShop.selected_item, "info1"] !$= "")
		displayShopFoodInfo(SuburbiaShop.selected_item);
	else if(SuburbiaClient.weapon_recipe[SuburbiaShop.selected_item, "info1"] !$= "")
		displayShopWeaponInfo(SuburbiaShop.selected_item);
	else
		displayShopResourceInfo(SuburbiaShop.selected_item);
	
	SRB_ShopItemCost.setText("<just:center><font:Arial bold italic:15>costs $" @ SuburbiaShop.selected_item_cost);
}

function displayShopPurchaseConfirm()
{
	if(SuburbiaShop.display_type !$= "illegal")
		%type = SuburbiaShop.display_type;
	else
	{
		%name = SuburbiaShop.selected_item;
		
		if(SuburbiaClient.food_recipe[%name, "icon"] !$= "")
			%type = "food";
		else if(SuburbiaClient.ingredients[%name] !$= "")
			%type = "resource";
		else if(SuburbiaClient.weapon_recipe[%name, "icon"] !$= "")
			%type = "weapon";
	}
	
	if(%type $= "food")
	{
		SRB_ShopPurchase_CostText.setText("<just:center>$" @ SuburbiaShop.selected_item_cost SPC "per item");
		
		%name = SuburbiaShop.selected_item;
		
		%icon_name = trim(strReplace(%name, "1", ""));
		%icon_name = trim(strReplace(%icon_name, "2", ""));
		%icon_name = trim(strReplace(%icon_name, "3", ""));
		
		SRB_ShopPurchase_Bitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon_name @ ".png";
		SRB_ShopPurchase_Text.setText("<font:Calibri:24>" @ SuburbiaShop.selected_item_amount SPC %name @ (SuburbiaShop.selected_item_amount != 1 ? "'s" : ""));
		
		SRB_ShopPurchase_Bitmap.position = 54 + SuburbiaClient.food_offset[%icon_name] SPC 29;
		SRB_ShopPurchase_Text.position = 100 + SuburbiaClient.food_offset[%icon_name] SPC 38;
		
		Canvas.pushDialog(SRB_Character_ShopPurchase);
	}
	else if(%type $= "resource")
	{
		SRB_ShopPurchase_CostText.setText("<just:center>$" @ SuburbiaShop.selected_item_cost SPC "per item");
		
		%name = SuburbiaShop.selected_item;
		
		%icon_name = trim(strReplace(%name, "1", ""));
		%icon_name = trim(strReplace(%icon_name, "2", ""));
		%icon_name = trim(strReplace(%icon_name, "3", ""));
		
		SRB_ShopPurchase_Bitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %name @ ".png";
		SRB_ShopPurchase_Text.setText("<font:Calibri:24>" @ SuburbiaShop.selected_item_amount SPC %name @ (SuburbiaShop.selected_item_amount != 1 ? "s" : ""));
		
		SRB_ShopPurchase_Bitmap.position = 54 + SuburbiaClient.food_offset[%icon_name] SPC 29;
		SRB_ShopPurchase_Text.position = 100 + SuburbiaClient.food_offset[%icon_name] SPC 38;
		
		Canvas.pushDialog(SRB_Character_ShopPurchase);
	}
	else if(%type $= "weapon")
	{
		SRB_ShopPurchase_CostText.setText("<just:center>$" @ SuburbiaShop.selected_item_cost SPC "per item");
		
		%name = SuburbiaShop.selected_item;
		
		%icon_name = trim(strReplace(%name, "1", ""));
		%icon_name = trim(strReplace(%icon_name, "2", ""));
		%icon_name = trim(strReplace(%icon_name, "3", ""));
		
		SRB_ShopPurchase_Bitmap.bitmap = "";
		SRB_ShopPurchase_Text.setText("<just:center><font:Calibri:24>" @ SuburbiaShop.selected_item_amount SPC %name @ (SuburbiaShop.selected_item_amount != 1 ? "s" : ""));
		
		SRB_ShopPurchase_Bitmap.position = "0 -1000";
		SRB_ShopPurchase_Text.position = "-16 38";
		
		Canvas.pushDialog(SRB_Character_ShopPurchase);
	}
}

function purchaseShopItem()
{
	%seller = SuburbiaShop.selected_seller;
	%name = SuburbiaShop.selected_item;
	%type = SuburbiaShop.display_type;
	%amount = SRB_ShopPurchaseInput.getValue();
	
	CommandToServer('PurchaseFromShop', %type, %seller, %name, %amount);
}

function uploadShopItem()
{
	%type = SuburbiaShop.display_type;
	%name = SuburbiaShop.selected_name;
	%amt = SRB_ShopUploadInput.getValue();
	%cost = SRB_ShopUploadCostInput.getValue();
	
	CommandToServer('AddToShop', %type, %name, %amt, %cost);
}

function uploadShopWeapon()
{
	%type = SuburbiaShop.display_type;
	%name = SuburbiaShop.selected_name;
	%amt = SRB_ShopUploadWeaponAmtInput.getValue();
	%cost = SRB_ShopUploadWeaponCostInput.getValue();
	
	CommandToServer('AddToShop', %type, %name, %amt, %cost);
}

function uploadShopItem2()
{
	%type = SuburbiaShop.display_type;
	%name = SuburbiaShop.selected_name;
	%cost = SRB_ShopUploadItemCostInput.getValue();
	
	CommandToServer('AddToShop', %type, %name, %amt, %cost);
}

function clientCmdDisplaySelectedShop()
{
	displayShopType(SuburbiaShop.display_type);
}

function clientCmdShopUploadSuccess(%type)
{
	if(%type $= "food")
		alxPlay(Suburbia_BankTransferSound);
	else
		alxPlay(Suburbia_BankWeaponTransferSound);
	
	Canvas.popDialog(SRB_Character_ShopUpload);
	Canvas.popDialog(SRB_Character_ShopUploadWeapons);
}

function clientCmdShopPurchaseSuccess(%type)
{
	if(%type $= "food")
		alxPlay(Suburbia_BankTransferSound);
	else
		alxPlay(Suburbia_BankWeaponTransferSound);
	
	Canvas.popDialog(SRB_Character_ShopPurchase);
}






function clientCmdReceiveSuperiors(%mayor, %pope, %police, %murder, %election)
{
	if(%mayor !$= "")
		SRB_Current_Mayor.setText("Current Mayor:" SPC %mayor);
	else
		SRB_Current_Mayor.setText("Current Mayor: nobody");
	
	if(%pope !$= "")
		SRB_Current_Pope.setText("Current Pope:" SPC %pope);
	else
		SRB_Current_Pope.setText("Current Pope: nobody");
	
	if(%police !$= "")
		SRB_Current_Police_Chief.setText("Current Police Chief:" SPC %police);
	else
		SRB_Current_Police_Chief.setText("Current Police Chief: nobody");
	
	if(%murder !$= "")
		SRB_Last_Murder.setText("Last Kill:" SPC %murder);
	else
		SRB_Last_Murder.setText("Last Kill: nobody");
	
	if(%election $= "no election")
	{
		SRB_Next_Election.setText("Next Election: no election due to totalitarianism law");
		SuburbiaClient.election_type = 0;
		cancel(SRB_Next_Election.election_sch);
	}
	else if(strPos(%election, "end") != -1)
	{
		SuburbiaClient.election_timer = getWord(%election, 1);
		SuburbiaClient.election_type = 2;
		SuburbiaClient.electionCountdown();
	}
	else
	{
		SuburbiaClient.election_timer = %election;
		SuburbiaClient.election_type = 1;
		SuburbiaClient.electionCountdown();
	}
}

function SuburbiaClient::electionCountdown(%this)
{
	cancel(%this.election_sch);
	
	%this.election_timer--;
	
	if(%this.election_timer < 0 || %this.election_type == 0)
		return;
	
	%minutes = mFloor(%this.election_timer / 60);
	%seconds = %this.election_timer % 60;
	
	if(%seconds < 10)
		%seconds = "0" @ %seconds;
	
	if(%this.election_type == 1)
		SRB_Next_Election.setText("Next Election:" SPC %minutes @ ":" @ %seconds);
	else if(%this.election_type == 2)
		SRB_Next_Election.setText("Election Ends in:" SPC %minutes @ ":" @ %seconds);
	
	%this.election_sch = %this.schedule(1000, electionCountdown);
}


















function clientCmdSuburbia_SetPopeSelected(%selected)
{
	SuburbiaClient.can_select_pope = %selected;
}

function createJobIcon(%name, %icon_file, %position)
{
	%gui_name = "SRB_JobIcon_" @ %name;
	
	%icon = new GuiSwatchCtrl(%gui_name)
	{
		clipToParent = 1;
		color = "0 0 0 255";
		enabled = 1;
		extent = "98 116";
		horizSizing = "right";
		minExtent = "1 1";
		position = %position;
		profile = "GuiDefaultProfile";
		vertSizing = "bottom";
		visible = 1;
		
		new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = "Add-Ons/Client_Suburbia/gui/icons/jobs/" @ %icon_file @ ".png";
			clipToParent = true;
			enabled = true;
			extent = "94 94";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
		};
		
		new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "ServerListProfile";
			selectable = true;
			text = "<color:ffffff><just:center><font:Arial:14>" @ %name;
			caption = %name;
			vertSizing = "bottom";
			visible = true;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "0 0";
			extent = "98 116";
			horizSizing = "right";
			minExtent = "1 1";
			position = "0 0";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "2 2";
			extent = "94 94";
			horizSizing = "right";
			minExtent = "1 1";
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiMouseEventCtrl(SRB_JobIconMouse)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "98 116";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
		};
	};
	Suburbia_JobScrollBackground.add(%icon);
	%icon.position = %position;
	
	%icon.icon_image = %icon.getObject(0);
	%icon.icon_caption = %icon.getObject(1);
	%icon.white_tint = %icon.getObject(2);
	%icon.yellow_tint = %icon.getObject(3);
	%icon.icon_mouseCtrl = %icon.getObject(4);
	
	%icon.original_position = %position;
	
	%icon.job_name = %name;
	
	return %gui_name;
}

function addJobIcon(%name, %icon_file)
{
	if(Suburbia_JobScroll.suburbia_currentRow $= "")
		Suburbia_JobScroll.suburbia_currentRow = 1;
	
	// calculate the height that we should be at
	%current_row = Suburbia_JobScroll.suburbia_currentRow;
	%height = (((%current_row - 1) * 116) + (%current_row * 7));
	
	// determine where along the x axis we should place the icon
	if(Suburbia_JobScroll.suburbia_row[%current_row, "slot"] $= "")
		Suburbia_JobScroll.suburbia_row[%current_row, "slot"] = 1;
	
	%current_slot = Suburbia_JobScroll.suburbia_row[%current_row, "slot"];
	%width = (((%current_slot - 1) * 98) + (%current_slot * 7));
	
	// create the gui and file the icon under an array all at the same time
	%icon = Suburbia_JobScroll.suburbia_row[%current_slot, Suburbia_JobScroll.suburbia_row[%current_row, "slot"]] = createJobIcon(%name, %icon_file, %width SPC %height);
	
	// if we have too many icons on one row, increment the total row count so next time we start on a new row
	if(Suburbia_JobScroll.suburbia_row[%current_row, "slot"] == 2)
		Suburbia_JobScroll.suburbia_currentRow++;
	else
		Suburbia_JobScroll.suburbia_row[%current_row, "slot"]++;
		
	// resizing the background so that the scroll works right
	%background_height = (%current_row * 116) + ((%current_row + 1) * 7);
	
	if(%background_height < 335)
		%background_height = 335;
	
	Suburbia_JobScrollBackground.resize(1, 1, 220, %background_height);
	
	return %icon;
}

function SRB_JobIconMouse::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setMouseDown();
}

function SRB_JobIconMouse::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	if(%this.mouseDown)
		%this.setSelectColors();
}

function SRB_JobIconMouse::onMouseEnter(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setHoverColors();
}

function SRB_JobIconMouse::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.resetHoverColors();
	
	%scroll = %this.getGroup().getGroup();
	if(%this.mouseDown == true && %this.isSelected == false && %scroll.currently_selected == %this)
		%this.resetSelectColors();
	
	if(%this.mouseDown == true)
		%this.resetMouseDown();
	
	%this.mouseDown = false;
}

function SRB_JobIconMouse::setHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("255 255 255 90");
	
	%this.hoverActive = true;
}

function SRB_JobIconMouse::resetHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("0 0 0 0");
	
	%this.hoverActive = false;
}

function SRB_JobIconMouse::setSelectColors(%this)
{
	%this.resetMouseDown();
	%parent = %this.getGroup();
	
	%parent.yellow_tint.setColor("255 255 0 115");
	%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:14>" @ %parent.icon_caption.caption);
	
	%scroll = %parent.getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	// set the description shit
	Suburbia_JobDescTitle.setValue("<just:center><font:Arial bold:24>" @ %parent.job_name);
	Suburbia_JobDescBitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/jobs/" @ $Suburbia::JobData[%parent.job_name, "icon"] @ ".png");
	Suburbia_JobDescCover.visible = false;
	
	
	%desc_parent = Suburbia_JobDescParent;
	%real_name = %parent.job_name;
	
	// remove old perk descriptions
	%count = %desc_parent.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = %desc_parent.getObject(%i);
		
		if(isObject(%obj))
			if(%obj.getName() $= "Suburbia_JobDescContent")
				%obj.delete();
	}
	
	// perk descriptions
	%desc_count = 1;
	%position = 186;
	for(%i = 1; %i < 4; %i++)
	{
		%index = "desc" @ %i;
		
		if($Suburbia::JobData[%real_name, %index] !$= "")
		{
			%text = $Suburbia::JobData[%real_name, %index];
			
			%desc = new GuiMLTextCtrl(Suburbia_JobDescContent)
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "240 0";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 0";
				profile = "GuiMLTextProfile";
				selectable = true;
				text = "";
				caption = %name;
				vertSizing = "bottom";
				visible = true;
			};
			%desc_parent.add(%desc);
			%desc.setText("<font:Arial:16><lmargin:20>- " @ setWord(%text, 2, "<lmargin:33>" @ getWord(%text, 2)));
			%desc.forceReflow();
			%desc.position = 0 SPC %position;
			%position += getWord(%desc.extent, 1) + 2;
		}
		else
			break;
	}
	
	if(%real_name $= "Pope" && !SuburbiaClient.can_select_pope)
		Suburbia_JobSelectButton.visible = false;
	else
		Suburbia_JobSelectButton.visible = true;
	
	%scroll.currently_selected = %this;
	%this.isSelected = true;
}

function SRB_JobIconMouse::resetSelectColors(%this)
{
	%this.getGroup().yellow_tint.setColor("0 0 0 0");
	%this.getGroup().icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	
	%scroll = %this.getGroup().getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	%scroll.currently_selected = "";
	
	%this.isSelected = false;
}

function SRB_JobIconMouse::setMouseDown(%this)
{
	%parent = %this.getGroup();
	
	if(%parent.original_position $= "")
		%parent.original_position = %parent.position;
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0) + 2, getWord(%position, 1) + 2, 94, 112);
	
	if(!%this.isSelected)
		%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	else
		%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	
	%parent.icon_caption.resize(0, 96, 92, 20);
	
	%parent.icon_image.resize(2, 2, 90, 90);
	%parent.yellow_tint.resize(2, 2, 90, 90);
	
	%this.mouseDown = true;
}

function SRB_JobIconMouse::resetMouseDown(%this)
{
	%parent = %this.getGroup();
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0), getWord(%position, 1), 98, 116);
	
	%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	%parent.icon_caption.resize(0, 99, 96, 20);
	
	%parent.icon_image.resize(2, 2, 94, 94);
	%parent.yellow_tint.resize(2, 2, 94, 94);
	
	%this.mouseDown = false;
}

function resetSelectedJobIcon()
{
	if(isObject(Suburbia_JobScrollBackground.currently_selected))
		if(isFunction(Suburbia_JobScrollBackground.currently_selected.getName(), resetSelectColors))
			Suburbia_JobScrollBackground.currently_selected.resetSelectColors();
	
	Suburbia_JobDescCover.visible = true;
	Suburbia_JobDescTitle.setText("");
}

function displayJobs()
{
	clearJobScrollList();
	
	for(%i = 0; %i < $Suburbia::JobDataCount; %i++)
	{
		%job_name = $Suburbia::JobData[%i];
		%icon_name = $Suburbia::JobData[%job_name, "icon"];
		%icon = addJobIcon(%job_name, %icon_name);
		%icon.job_name = %job_name;
	}
}

function clearJobScrollList()
{
	%count = getTaggedFieldCount(Suburbia_JobScroll);
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%field = Suburbia_JobScroll.getTaggedField(%i);
		%field_name = expandEscape(getField(%field, 0));
		eval("Suburbia_JobScroll." @ %field_name @ " = \"\";");
	}
	
	%count = Suburbia_JobScrollBackground.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = Suburbia_JobScrollBackground.getObject(%i);
		
		if(isObject(%obj))
			%obj.delete();
	}
}

function clearJobs()
{
	$Suburbia::JobStatsDisplayed = false;
	DeleteVariables("$Suburbia::JobData*");
	clearJobScrollList();
	Suburbia_JobDescCover.visible = true;
}

function clientCmdReceiveJobData(%job_name, %icon_name, %desc1, %desc2, %desc3, %desc4)
{
	if($Suburbia::JobDataCount $= "")
		$Suburbia::JobDataCount = 0;
	
	$Suburbia::JobData[$Suburbia::JobDataCount] = %job_name;
	$Suburbia::JobData[%job_name, "icon"] = %icon_name;
	$Suburbia::JobData[%job_name, "desc1"] = %desc1;
	$Suburbia::JobData[%job_name, "desc2"] = %desc2;
	$Suburbia::JobData[%job_name, "desc3"] = %desc3;
	$Suburbia::JobData[%job_name, "desc4"] = %desc4;
	
	$Suburbia::JobDataCount++;
}

function clientCmdClearJobs()
{
	clearJobs();
}

function clientCmdSetJob(%job)
{
	SuburbiaClient.job = %job;
	SRB_CurrentJobText.setText("<font:Arial bold:18>Current Job:" SPC (%job !$= "" ? %job : "error"));
}

function selectJob()
{
	CommandToServer('SetJob', Suburbia_JobScrollBackground.currently_selected.getGroup().job_name);
}













function loadCharacterLaw(%law)
{
	%law = trim(%law);
	
	if($Suburbia::Mayor::Meters[getWords(%law, 0, getWordCount(%law) - 2)])
	{
		%meter = getWord(%law, getWordCount(%law) - 1);
		%law = getWords(%law, 0, getWordCount(%law) - 2);
	}
	
	SRB_CHLawDescCover.visible = false;
	selectCharacterLaw(%law, %meter);
}

function selectCharacterLaw(%law, %meter)
{
	%desc_parent = SRB_CHLaw_Description_Container;
	%count = %desc_parent.getCount();
	// remove the old benefit / disbenefit messages
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = %desc_parent.getObject(%i);
		
		if(isObject(%obj))
			if(%obj.getName() $= "Suburbia_MayorLawsDescContent")
				%obj.delete();
	}
	
	// place the benefits / disbenefits
	
	if(!$Suburbia::Mayor::Meters[%law])
	{
		%desc_count = 1;
		%position = 190;
		for(%i = 1; %i < 6; %i++)
		{
			%index = "affect" @ %i;
			
			if($Suburbia::Mayor::Laws[%law, %index] !$= "")
			{
				%text = $Suburbia::Mayor::Laws[%law, %index];
				
				%desc = new GuiMLTextCtrl(Suburbia_MayorLawsDescContent)
				{
					allowColorChars = true;
					autoResize = true;
					clipToParent = true;
					enabled = true;
					extent = "240 0";
					horizSizing = "right";
					lineSpacing = 2;
					maxBitmapHeight = -1;
					maxChars = -1;
					minExtent = "8 2";
					position = "0 0";
					profile = "GuiMLTextProfile";
					selectable = true;
					text = "";
					caption = %name;
					vertSizing = "bottom";
					visible = true;
				};
				%desc_parent.add(%desc);
				%desc.setText("<font:Arial:17><lmargin:20>- " @ setWord(%text, 2, "<lmargin:33>" @ getWord(%text, 2)));
				%desc.forceReflow();
				%desc.position = 0 SPC %position;
				%position += getWord(%desc.extent, 1) + 6;
			}
			else
				break;
		}
	}
	else
	{
		%desc_count = 1;
		%position = 190;
		for(%i = 1; %i < 6; %i++)
		{
			%index = "affect" @ %i;
			
			if($Suburbia::Mayor::Meters[%law, %meter, %index] !$= "")
			{
				%text = $Suburbia::Mayor::Meters[%law, %meter, %index];
				
				%desc = new GuiMLTextCtrl(Suburbia_MayorLawsDescContent)
				{
					allowColorChars = true;
					autoResize = true;
					clipToParent = true;
					enabled = true;
					extent = "240 0";
					horizSizing = "right";
					lineSpacing = 2;
					maxBitmapHeight = -1;
					maxChars = -1;
					minExtent = "8 2";
					position = "0 0";
					profile = "GuiMLTextProfile";
					selectable = true;
					text = "";
					caption = %name;
					vertSizing = "bottom";
					visible = true;
				};
				%desc_parent.add(%desc);
				%desc.setText("<font:Arial:17><lmargin:20>- " @ setWord(%text, 2, "<lmargin:33>" @ getWord(%text, 2)));
				%desc.forceReflow();
				%desc.position = 0 SPC %position;
				%position += getWord(%desc.extent, 1) + 6;
			}
			else
				break;
		}
	}
	
	SRB_CHLawDescBitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/" @ $Suburbia::Mayor::Laws[%law, "icon"]);
	
	if(!$Suburbia::Mayor::Meters[%law])
		SRB_CHLawDescTitle.setText("<just:center><font:Arial Bold:25>" @ %law);
	else
		SRB_CHLawDescTitle.setText("<just:center><font:Arial Bold:25>" @ %law SPC %meter);
}

function displayCharacterLaws()
{
	SRB_CharacterLawList.clear();
	
	SRB_CHLawDescCover.visible = true;
	SRB_CHLawDescCover.getGroup().pushToBack(SRB_CHLawDescCover);
	
	for(%i = 0; %i < $Suburbia::Mayor::LawCount; %i++)
	{
		%name = $Suburbia::Mayor::Laws[%i];
		
		%meter_num = "";
		if($Suburbia::Mayor::Meters[%name])
		{
			for(%x = 1; %x <= $Suburbia::Mayor::Meters[%name, "meter_count"]; %x++)
			{
				if($Suburbia::Mayor::Meters[%name, %x, "enacted"])
				{
					%meter_num = %x;
					break;
				}
			}
		}
		
		if(!$Suburbia::Mayor::Meters[%law] && $Suburbia::Mayor::Laws[%name, "enacted"] == true)
			SRB_CharacterLawList.addRow(SRB_CharacterLawList.rowCount(), %name SPC "                                                  ");
		else if(%meter_num != $Suburbia::Mayor::Meters[%name, "default"] && %meter_num !$= "")
			SRB_CharacterLawList.addRow(SRB_CharacterLawList.rowCount(), %name SPC %meter_num SPC "                                                  ");
	}
	
	SRB_CharacterLawList.extent = 5000 SPC getWord(SRB_CharacterLawList.extent, 1);
	SRB_CharacterLawSwatch.extent = 5000 SPC getWord(SRB_CharacterLawList.extent, 1) + 10;
}











function SuburbiaClient::toggleAutoEat(%this, %val)
{
	SuburbiaClient.autoeat_enabled = %val;
}

function SuburbiaClient::initAutoEatList(%this)
{
	SRB_AutoEat_List.clear();
	SRB_AutoEat_List.add("Don't exclude any", 1);
	SRB_AutoEat_List.add("Tier 2 and above", 2);
	SRB_AutoEat_List.add("Tier 3 and above", 3);
	// SRB_AutoEat_List.add("Drug Tier", 4);
	SuburbiaClient.autoeat_init = true;
	
	SRB_AutoEat_List.setSelected(1);
}

function clientCmdSuburbia_SetSatiation(%level)
{
	SuburbiaClient.satiation = %level;
}

function SuburbiaClient::autoEatLoop(%this)
{
	cancel(%this.autoeat);
	
	if(SRB_AutoEat_List.getSelected() == 0 || SRB_AutoEat_List.getSelected() $= "")
		%this.initAutoEatList();
	
	if($Suburbia::HandshakeCompleted && %this.autoeat_enabled)
	{
		CommandToServer('RequestSatiation');
		%this.schedule(2000, attemptAutoEat);
	}
	
	%this.autoeat = %this.schedule(30000, autoEatLoop);
}

function SuburbiaClient::attemptAutoEat(%this)
{
	if(%this.satiation <= 3)
	{
		CommandToServer('RequestClientFood');
		%this.schedule(200, attemptAutoEat2);
	}
}

function SuburbiaClient::attemptAutoEat2(%this)
{
	%end_tier = (SRB_AutoEat_List.getSelected() != 1) ? SRB_AutoEat_List.getSelected() : 0;
	
	for(%i = 1; %i <= 3; %i++)
	{
		if(%i == %end_tier)
			break;
		
		%tier_list = Suburbia_FoodGroup.tier[%i];
		
		%tier_list.sort(0, true);
		
		%count = %tier_list.rowCount();
		for(%x = 0; %x < %count; %x++)
		{
			%data = Suburbia_FoodGroup.food[%tier_list.getRowText(%x)];
			
			if(!isObject(%data) || %data.count <= 0 || %data.count $= "" || %data.text $= "")
				continue;
			
			CommandToServer('EatFood', %data.text);
			SuburbiaClient.autoeat_failure = false;
			return;
		}
	}
	
	// means we have no avalible food to eat based on either having no inventory or auto-eat settings
	if(!SuburbiaClient.autoeat_failure)
	{
		newChatHud_AddLine("<font:Calibri bold:25>\c0Auto-Eat has ran out of food!");
		SuburbiaClient.autoeat_failure = true;
	}
}