function SuburbiaClient::createPopeWSIcon(%this, %name, %icon_file, %position)
{
	%gui_name = "SRB_PopeWSIcon_" @ %name;
	
	%icon = new GuiSwatchCtrl(%gui_name)
	{
		clipToParent = 1;
		color = "0 0 0 255";
		enabled = 1;
		extent = "98 116";
		horizSizing = "right";
		minExtent = "1 1";
		position = %position;
		profile = "GuiDefaultProfile";
		vertSizing = "bottom";
		visible = 1;
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "235 235 235 255";
			enabled = 1;
			position = "2 2";
			extent = "94 94";
			horizSizing = "right";
			minExtent = "1 1";
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = %icon_file;
			clipToParent = true;
			enabled = true;
			extent = "78 78";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "9 9";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
		};
		
		new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "ServerListProfile";
			selectable = true;
			text = "<color:ffffff><just:center><font:Arial:14>" @ %name;
			caption = %name;
			vertSizing = "bottom";
			visible = true;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "0 0";
			extent = "98 116";
			horizSizing = "right";
			minExtent = "1 1";
			position = "0 0";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "2 2";
			extent = "94 94";
			horizSizing = "right";
			minExtent = "1 1";
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiMouseEventCtrl(SRB_PopeWSIconMouse)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "98 116";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
		};
	};
	Suburbia_PopeWSScrollBackground.add(%icon);
	%icon.position = %position;
	
	%icon.background_bitmap = %icon.getObject(0);
	%icon.icon_image = %icon.getObject(1);
	%icon.icon_caption = %icon.getObject(2);
	%icon.white_tint = %icon.getObject(3);
	%icon.yellow_tint = %icon.getObject(4);
	%icon.icon_mouseCtrl = %icon.getObject(5);
	
	%icon.original_position = %position;
	
	%icon.weapon_name = %real_name;
	
	return %gui_name;
}

function SuburbiaClient::addPopeWSIcon(%this, %name, %icon_file)
{
	if(Suburbia_PopeWSScroll.suburbia_currentRow $= "")
		Suburbia_PopeWSScroll.suburbia_currentRow = 1;
	
	// calculate the height that we should be at
	%current_row = Suburbia_PopeWSScroll.suburbia_currentRow;
	%height = (((%current_row - 1) * 116) + (%current_row * 5));
	
	// determine where along the x axis we should place the icon
	if(Suburbia_PopeWSScroll.suburbia_row[%current_row, "slot"] $= "")
		Suburbia_PopeWSScroll.suburbia_row[%current_row, "slot"] = 1;
	
	%current_slot = Suburbia_PopeWSScroll.suburbia_row[%current_row, "slot"];
	%width = (((%current_slot - 1) * 98) + (%current_slot * 5));
	
	// create the gui and file the icon under an array all at the same time
	%icon = Suburbia_PopeWSScroll.suburbia_row[%current_slot, Suburbia_PopeWSScroll.suburbia_row[%current_row, "slot"]] = SuburbiaClient.createPopeWSIcon(%name, %icon_file, %width SPC %height);
	
	// if we have too many icons on one row, increment the total row count so next time we start on a new row
	if(Suburbia_PopeWSScroll.suburbia_row[%current_row, "slot"] == 3)
		Suburbia_PopeWSScroll.suburbia_currentRow++;
	else
		Suburbia_PopeWSScroll.suburbia_row[%current_row, "slot"]++;
		
	// resizing the background so that the scroll works right
	%background_height = (%current_row * 116) + ((%current_row + 1) * 5);
	
	if(%background_height < 298)
		%background_height = 298;
	
	Suburbia_PopeWSScrollBackground.resize(1, 1, 315, %background_height);
	
	return %icon;
}

function SRB_PopeWSIconMouse::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setMouseDown();
}

function SRB_PopeWSIconMouse::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	if(%this.mouseDown)
		%this.setSelectColors();
}

function SRB_PopeWSIconMouse::onMouseEnter(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setHoverColors();
}

function SRB_PopeWSIconMouse::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.resetHoverColors();
	
	%scroll = %this.getGroup().getGroup();
	if(%this.mouseDown == true && %this.isSelected == false && %scroll.currently_selected == %this)
		%this.resetSelectColors();
	
	if(%this.mouseDown == true)
		%this.resetMouseDown();
	
	%this.mouseDown = false;
}

function SRB_PopeWSIconMouse::setHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("255 255 255 90");
	
	%this.hoverActive = true;
}

function SRB_PopeWSIconMouse::resetHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("0 0 0 0");
	
	%this.hoverActive = false;
}

function SRB_PopeWSIconMouse::setSelectColors(%this)
{
	%this.resetMouseDown();
	%parent = %this.getGroup();
	
	%parent.yellow_tint.setColor("255 255 0 115");
	%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:14>" @ %parent.icon_caption.caption);
	
	%scroll = %parent.getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	// set the description shit
	%cost = $Suburbia::PopeWeaponData[%parent.weapon_name, "cost"];
	if(%cost $= "")
		%cost = 0;
	
	SRB_PopeWS_Button.setText("Add for $" @ %cost SPC "(+" SPC SuburbiaClient.getInflationDifference(%cost) @ ")");
	
	%scroll.currently_selected = %this;
	%this.isSelected = true;
}

function SRB_PopeWSIconMouse::resetSelectColors(%this)
{
	%this.getGroup().yellow_tint.setColor("0 0 0 0");
	%this.getGroup().icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	
	%scroll = %this.getGroup().getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	%scroll.currently_selected = "";
	
	%this.isSelected = false;
}

function SRB_PopeWSIconMouse::setMouseDown(%this)
{
	%parent = %this.getGroup();
	
	if(%parent.original_position $= "")
		%parent.original_position = %parent.position;
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0) + 2, getWord(%position, 1) + 2, 94, 112);
	
	if(!%this.isSelected)
		%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	else
		%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	
	%parent.icon_caption.resize(0, 96, 92, 20);
	
	%parent.background_bitmap.resize(2, 2, 90, 90);
	%parent.icon_image.resize(2, 2, 74, 74);
	%parent.yellow_tint.resize(2, 2, 90, 90);
	
	%parent.icon_image.position = "9 9";
	
	%this.mouseDown = true;
}

function SRB_PopeWSIconMouse::resetMouseDown(%this)
{
	%parent = %this.getGroup();
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0), getWord(%position, 1), 98, 116);
	
	%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	%parent.icon_caption.resize(0, 99, 96, 20);
	
	%parent.background_bitmap.resize(2, 2, 94, 94);
	%parent.icon_image.resize(2, 2, 78, 78);
	%parent.yellow_tint.resize(2, 2, 94, 94);
	
	%parent.icon_image.position = "9 9";
	
	%this.mouseDown = false;
}

function SuburbiaClient::clearPopeWSScrollList(%this)
{
	%count = getTaggedFieldCount(Suburbia_PopeWSScroll);
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%field = Suburbia_PopeWSScroll.getTaggedField(%i);
		%field_name = expandEscape(getField(%field, 0));
		eval("Suburbia_PopeWSScroll." @ %field_name @ " = \"\";");
	}
	
	%count = Suburbia_PopeWSScrollBackground.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = Suburbia_PopeWSScrollBackground.getObject(%i);
		
		if(isObject(%obj))
			%obj.delete();
	}
}

function SuburbiaClient::clearPopeWS()
{
	$Suburbia::PopeWeaponSelectDisplayed = false;
	DeleteVariables("$Suburbia::PopeWeaponData*");
	SuburbiaClient.clearPopeWSScrollList();
	$Suburbia::PopeWSDisplayed = false;
}

function clientCmdAddPopeWeapon(%name, %cost, %icon_file)
{
	if($Suburbia::PopeWeaponDataCount $= "")
		$Suburbia::PopeWeaponDataCount = 0;
	
	$Suburbia::PopeWeaponData[$Suburbia::PopeWeaponDataCount] = %name;
	$Suburbia::PopeWeaponData[%name, "cost"] = %cost;
	$Suburbia::PopeWeaponData[%name, "icon"] = %icon_file;
	
	$Suburbia::PopeWeaponDataCount++;
}

function SuburbiaClient::resetSelectedPopeWSIcon(%this)
{
	if(isObject(Suburbia_PopeWSScrollBackground.currently_selected))
		if(isFunction(Suburbia_PopeWSScrollBackground.currently_selected.getName(), resetSelectColors))
			Suburbia_PopeWSScrollBackground.currently_selected.resetSelectColors();
}

function SuburbiaClient::displayPopeWS(%this)
{
	for(%i = 0; %i < $Suburbia::PopeWeaponDataCount; %i++)
	{
		%weapon_name = $Suburbia::PopeWeaponData[%i];
		%icon_name = $Suburbia::PopeWeaponData[%weapon_name, "icon"];
		%cost = $Suburbia::PopeWeaponData[%weapon_name, "cost"];
		%icon = SuburbiaClient.addPopeWSIcon(%weapon_name, %icon_name);
		%icon.weapon_name = %weapon_name;
	}
	$Suburbia::PopeWSDisplayed = true;
}

function SuburbiaClient::showPopeWSGui(%this)
{
	if(!$Suburbia::PopeWSDisplayed)
		SuburbiaClient.displayPopeWS();
	
	SuburbiaClient.resetSelectedPopeWSIcon();
	Canvas.schedule(1, pushDialog, SRB_Pope_WS);
}

function SuburbiaClient::sendPopeWeapon(%this)
{
	%selected_slot = $Suburbia::PopeWSSlot;
	Canvas.popDialog(SRB_Pope_WS);
	%name = Suburbia_PopeWSScrollBackground.currently_selected.getGroup().weapon_name;
	
	if(%name !$= "")
		("SRB_Pope_Weapon" @ %selected_slot).setText(%name SPC "-" SPC SuburbiaClient.getInflationSum($Suburbia::PopeWeaponData[%name, "cost"]));
	else
		("SRB_Pope_Weapon" @ %selected_slot).setText("No Weapon Selected");
	
	CommandToServer('UpdatePopeWeapon', %name, %selected_slot);
}

function SuburbiaClient::selectPopeWeapon(%this, %num)
{
	$Suburbia::PopeWSSlot = %num;
	SRB_PopeWS_Button.setText("Remove Weapon from Slot");
	SuburbiaClient.showPopeWSGui();
}

function clientCmdUpdatePopeWeapon(%ui_name, %cost, %index)
{
	if(%ui_name !$= "")
		("SRB_Pope_Weapon" @ %index).setText(%ui_name SPC "-" SPC SuburbiaClient.getInflationSum(%cost));
	else
		("SRB_Pope_Weapon" @ %index).setText("No Weapon Selected");
}

function clientCmdClearPopeWeapons()
{
	SuburbiaClient.clearPopeWS();
}

function clientCmdAddPopeBudgetHistory(%day, %text, %cost)
{
	SuburbiaClient.addPopeBudgetRow(%day, %text, %cost);
}

function SuburbiaClient::addPopeBudgetRow(%this, %day, %text, %cost)
{
	%this = SRB_PopeBudgetList;
	
	if(%this.history_start $= "")
		%this.history_start = 0;
	
	if(%this.history_end $= "")
		%this.history_end = 0;
	
	%this.budget_history[%this.history_end] = %text;
	%this.budget_history[%this.history_end, "day"] = %day;
	%this.budget_history[%this.history_end, "cost"] = %cost;
	
	if(%this.history_end - %this.history_start > 25)
		%this.history_start++;
	
	%this.history_end++;
	
	SuburbiaClient.displayPopeBudgetHistory();
}

function SuburbiaClient::displayPopeBudgetHistory(%this)
{
	%this = SRB_PopeBudgetList;
	%this.setText("");
	
	%last_date = "";
	%total_cost = "";
	
	for(%i = %this.history_end - 1; %i >= %this.history_start; %i--)
	{
		%date = %this.budget_history[%i, "day"];
		
		if(%date !$= %last_date)
		{
			if(%total_cost !$= "")
			{
				if(%total_cost > 0)
					SRB_PopeBudgetListTML_addRow2("\c5Total Money Spent: $" @ mAbs(%total_cost));
				else
					SRB_PopeBudgetListTML_addRow2("\c5Total Money Gained: $" @ mAbs(%total_cost));
			}
			
			if(%i != %this.history_end - 1)
			{
				SRB_PopeBudgetListTML_addRow2("");
			}
			
			SRB_PopeBudgetListTML_addRow2("\c4" @ %date);
			SRB_PopeBudgetListTML_addRow2("\c4-----------------------------------------------------------");
			%last_date = %date;
			
			%total_cost = 0;
		}
		
		%total_cost += %this.budget_history[%i, "cost"];
		
		SRB_PopeBudgetListTML_addRow2(%this.budget_history[%i]);
	}
	
	// displaying the total spent/gained for the last date
	if(%total_cost !$= "")
	{
		if(%total_cost > 0)
			SRB_PopeBudgetListTML_addRow2("\c5Total Money Spent: $" @ mAbs(%total_cost));
		else
			SRB_PopeBudgetListTML_addRow2("\c5Total Money Gained: $" @ mAbs(%total_cost));
	}
}

function SRB_PopeBudgetListTML_addRow2(%text)
{
	%this = SRB_PopeBudgetList;
	
	%text = "<lmargin:5>" @ %text;
	%text = strReplace(%text, "\c5", "<color:0000FF>");
	%text = strReplace(%text, "\c4", "<color:FF6060>");
	
	%this.setText(%this.getText() @ "<br><color:000000>" @ %text);
}

function SuburbiaClient::clearPopeBudgetHistory()
{
	%this = SRB_PopeBudgetList;
	
	for(%i = 0; %i < %this.history_end; %i++)
	{
		%this.budget_history[%this.history_start] = "";
		%this.budget_history[%this.history_start, "day"] = "";
		%this.budget_history[%this.history_start, "cost"] = "";
	}
	
	%this.history_start = 0;
	%this.history_end = 0;
	
	SuburbiaClient.displayPopeBudgetHistory();
}

function SuburbiaClient::showPopeMainGui(%this)
{
	Canvas.schedule(1, pushDialog, SRB_Pope_Main);
}

function clientCmdShowPopeGui()
{
	SuburbiaClient.showPopeMainGui();
}

function clientCmdUpdatePietyLevel(%level, %good_trigger, %bad_trigger)
{
	// pos_x = 5
	// size_x = 518
	
	SuburbiaClient.piety = %level;
	%level = mClamp(%level, 0, 2000);
	%level2 = mFloor(%level);
	
	%position = ((%level / 2100) * 525) + 5;
	SRB_Piety_Arrow.position = %position SPC 25;
	
	if(%level < 1100 && %level > 900)
	{
		SRB_Piety_Arrow.setBitmap("Add-Ons/Client_Suburbia/gui/icons/pope/arrow_down");
		
		SRB_Piety_Text.position = %position + 21 SPC 28;
		SRB_Piety_Text.setText("<color:00ff00>" @ %level2 @ "/2000");
	}
	else if(%level >= 1100)
	{
		SRB_Piety_Arrow.setBitmap("Add-Ons/Client_Suburbia/gui/icons/pope/arrow_left");
		
		if(%level > 1800)
		{
			SRB_Piety_Text.position = %position - 62 SPC 28;
			SRB_Piety_Text.setText("<color:00ff00>" @ %level2 @ "/2000");
		}
		else
		{
			SRB_Piety_Text.position = %position + 21 SPC 28;
			SRB_Piety_Text.setText("<color:00ff00>" @ %level2 @ "/2000");
		}
	}
	else if(%level <= 900)
	{
		SRB_Piety_Arrow.setBitmap("Add-Ons/Client_Suburbia/gui/icons/pope/arrow_right");
		
		if(%level > 200)
		{
			SRB_Piety_Text.position = %position - 55 SPC 28;
			SRB_Piety_Text.setText("<color:00ff00>" @ %level2 @ "/2000");
		}
		else
		{
			SRB_Piety_Text.position = %position + 21 SPC 28;
			SRB_Piety_Text.setText("<color:00ff00>" @ %level2 @ "/2000");
		}
	}
	
	// updating good/bad event trigger buttons
	SRB_Pope_GoodEventBtn.setText("Trigger Good Event for" SPC %good_trigger SPC "Piety");
	SRB_Pope_BadEventBtn.setText("Trigger Bad Event for +" @ %bad_trigger SPC "Piety");
}

function SuburbiaClient::triggerGoodEvent(%this)
{
	SuburbiaClient.startPopeTimerLoop(300);
	CommandToServer('TriggerGoodEvent');
}

function SuburbiaClient::triggerBadEvent(%this)
{
	SuburbiaClient.startPopeTimerLoop(300);
	CommandToServer('TriggerBadEvent');
}

function SuburbiaClient::startPopeTimerLoop(%this, %time)
{
	SRB_Pope_BtnBlocker.visible = true;
	
	cancel($Suburbia::Pope::TimerSch);
	SRB_EventTriggerTimer.timer = %time;
	SuburbiaClient.eventPopeTimerLoop();
}

function SuburbiaClient::eventPopeTimerLoop(%this)
{
	cancel($Suburbia::Pope::TimerSch);
	
	if(SRB_EventTriggerTimer.timer <= 0)
	{
		SRB_Pope_BtnBlocker.visible = false;
		return;
	}
	
	SRB_EventTriggerTimer.setText("<just:center><font:Arial bold:20>" @ SRB_EventTriggerTimer.timer SPC "seconds remaining until available");
	SRB_EventTriggerTimer.timer--;
	
	$Suburbia::Pope::TimerSch = SuburbiaClient.schedule(1000, eventPopeTimerLoop);
}

function clientCmdSuburbia_RestartPopeTimer(%time)
{
	if($Suburbia::HandshakeCompleted == true)
		SuburbiaClient.startPopeTimerLoop(%time);
}

function clientCmdSuburbia_SetChurchFunds(%amt)
{
	if($Suburbia::HandshakeCompleted == true)
		Suburbia_PopeMoneyText.setText("<color:bbbbbb><font:Calibri:21>Funds: <color:00cc00>$" @ addCommasToNumber(%amt));
}

function clientCmdSuburbia_DisplayPopeJobs()
{
	if($Suburbia::HandshakeCompleted == true)
	 	SuburbiaClient.displayPopeHireFireList();
}

function SuburbiaClient::displayPopeHireFireList(%this)
{
	SRB_PopeHireFireList.clear();
	
	%list1 = $Suburbia::Pope::PriestApplicant;
	%list2 = $Suburbia::Pope::PriestJob;
	
	%list1.sort(0, true);
	%list2.sort(0, true);
	
	for(%i = 0; %i < %list1.row_count; %i++)
		SRB_PopeHireFireList.addRow(%i, "\c0" @ %list1.getRowTextById(%list1.getRowId(%i)) TAB "\c5Applicant", %i + 3);
	
	for(%i = 0; %i < %list2.row_count; %i++)
		SRB_PopeHireFireList.addRow(%i + %list1.row_count, "\c0" @ %list2.getRowTextById(%list2.getRowId(%i)) TAB "\c5      Priest", %i + 3 + %list1.row_count);
	
	SRB_PopeHireFireList.addRow(-1, "", 0);
	SRB_PopeHireFireList.addRow(-1, "\c4Player Name\t  Position", 1);
	SRB_PopeHireFireList.addRow(-1, "\c4----------------------------------------------------------------------", 2);
}

function SuburbiaClient::createApplicantList(%this)
{
	if(isObject($Suburbia::Pope::PriestApplicant) || isObject($Suburbia::Pope::PriestJob))
		return;
	
	$Suburbia::Pope::PriestApplicant = new GuiTextListCtrl();
	$Suburbia::Pope::PriestApplicant.row_count = 0;
	
	$Suburbia::Pope::PriestJob = new GuiTextListCtrl();
	$Suburbia::Pope::PriestJob.row_count = 0;
}

function SuburbiaClient::deleteApplicantList(%this)
{
	if(isObject($Suburbia::Pope::PriestApplicant))
		$Suburbia::Pope::PriestApplicant.delete();
	
	if(isObject($Suburbia::Pope::PriestJob))
		$Suburbia::Pope::PriestJob.delete();
}

function clientCmdAddPriestApplicant(%name)
{
	SuburbiaClient.createApplicantList();
	
	$Suburbia::Pope::PriestApplicant.addRow($Suburbia::Pope::PriestApplicant.row_count, %name);
	$Suburbia::Pope::PriestApplicant.row_count++;
}

function clientCmdAddPriestJob(%name)
{
	SuburbiaClient.createApplicantList();
	
	$Suburbia::Pope::PriestJob.addRow($Suburbia::Pope::PriestJob.row_count, %name);
	$Suburbia::Pope::PriestJob.row_count++;
}

function clientCmdClearPopeJobs()
{
	clearPopeJobList();
}

function clearPopeJobList()
{
	$Suburbia::Pope::PriestApplicant.clear();
	$Suburbia::Pope::PriestApplicant.row_count = 0;
	
	$Suburbia::Pope::PriestJob.clear();
	$Suburbia::Pope::PriestJob.row_count = 0;
}

function SuburbiaClient::selectPopeJob(%this)
{
	%id = SRB_PopeHireFireList.getSelectedId();
	%job = getField(SRB_PopeHireFireList.getRowTextById(%id), 1);
	
	if(%job $= "\c5Applicant")
	{
		SRB_PopeAcceptJobButton.visible = true;
		SRB_PopeDenyJobButton.visible = true;
		
		SRB_PopeFireJobButton.visible = false;
	}
	else if(%job $= "\c5      Priest")
	{
		SRB_PopeAcceptJobButton.visible = false;
		SRB_PopeDenyJobButton.visible = false;
		
		SRB_PopeFireJobButton.visible = true;
	}
	else
	{
		SRB_PopeAcceptJobButton.visible = false;
		SRB_PopeDenyJobButton.visible = false;
		
		SRB_PopeFireJobButton.visible = false;
	}
}

function SuburbiaClient::popeFirePriest(%this)
{
	%id = SRB_PopeHireFireList.getSelectedId();
	%name = strReplace(getField(SRB_PopeHireFireList.getRowTextById(%id), 0), "\c0", "");
	
	CommandToServer('FirePriest', %name);
}

function SuburbiaClient::popeHirePriest(%this)
{
	%id = SRB_PopeHireFireList.getSelectedId();
	%name = strReplace(getField(SRB_PopeHireFireList.getRowTextById(%id), 0), "\c0", "");
	
	CommandToServer('HirePriest', %name);
}

function SuburbiaClient::popeDenyPriest(%this)
{
	%id = SRB_PopeHireFireList.getSelectedId();
	%name = strReplace(getField(SRB_PopeHireFireList.getRowTextById(%id), 0), "\c0", "");
	
	CommandToServer('DenyPriest', %name);
}











function clientCmdAddPopePietyHistory(%day, %text, %amt)
{
	SuburbiaClient.addPopePietyRow(%day, %text, %amt);
}

function SuburbiaClient::addPopePietyRow(%this, %day, %text, %amt)
{
	%this = SRB_PopePietyList;
	
	if(%this.history_start $= "")
		%this.history_start = 0;
	
	if(%this.history_end $= "")
		%this.history_end = 0;
	
	%this.budget_history[%this.history_end] = %text;
	%this.budget_history[%this.history_end, "day"] = %day;
	%this.budget_history[%this.history_end, "piety"] = %amt;
	
	if(%this.history_end - %this.history_start > 25)
		%this.history_start++;
	
	%this.history_end++;
	
	SuburbiaClient.displayPopePietyHistory();
}

function SuburbiaClient::displayPopePietyHistory(%this)
{
	%this = SRB_PopePietyList;
	%this.setText("");
	
	%last_date = "";
	%total_cost = "";
	
	for(%i = %this.history_end - 1; %i >= %this.history_start; %i--)
	{
		%date = %this.budget_history[%i, "day"];
		
		if(%date !$= %last_date)
		{
			if(%total_cost !$= "")
			{
				if(%total_cost > 0)
					SRB_PopePietyListTML_addRow2("\c5Total Piety Gained: " @ mAbs(%total_cost));
				else
					SRB_PopePietyListTML_addRow2("\c5Total Piety Lost: " @ mAbs(%total_cost));
			}
			
			if(%i != %this.history_end - 1)
				SRB_PopePietyListTML_addRow2("");
			
			SRB_PopePietyListTML_addRow2("\c4" @ %date);
			SRB_PopePietyListTML_addRow2("\c4-----------------------------------------------------------");
			%last_date = %date;
			
			%total_cost = 0;
		}
		
		%total_cost += %this.budget_history[%i, "piety"];
		
		SRB_PopePietyListTML_addRow2(%this.budget_history[%i]);
	}
	
	// displaying the total spent/gained for the last date
	if(%total_cost !$= "")
	{
		if(%total_cost > 0)
			SRB_PopePietyListTML_addRow2("\c5Total Piety Gained: " @ mAbs(%total_cost));
		else
			SRB_PopePietyListTML_addRow2("\c5Total Piety Lost: " @ mAbs(%total_cost));
	}
}

function SRB_PopePietyListTML_addRow2(%text)
{
	%this = SRB_PopePietyList;
	
	%text = "<lmargin:5>" @ %text;
	%text = strReplace(%text, "\c5", "<color:0000FF>");
	%text = strReplace(%text, "\c4", "<color:FF6060>");
	
	%this.setText(%this.getText() @ "<br><color:000000>" @ %text);
}

function SuburbiaClient::clearPopePietyHistory(%this)
{
	%this = SRB_PopePietyList;
	
	for(%i = 0; %i < %this.history_end; %i++)
	{
		%this.budget_history[%this.history_start] = "";
		%this.budget_history[%this.history_start, "day"] = "";
		%this.budget_history[%this.history_start, "cost"] = "";
	}
	
	%this.history_start = 0;
	%this.history_end = 0;
	
	SuburbiaClient.displayPopePietyHistory();
}