if(!isObject(SpiderSet))
	new SimSet(SpiderSet);

function SuburbiaClient::createSpider()
{
	%ratio = 160 / 181;
	%scale = getRandom(50, 200);
	
	%spider = new GuiAnimatedBitmapCtrl(DrugSpider)
	{
	   profile = "GuiDefaultProfile";
	   horizSizing = "right";
	   vertSizing = "bottom";
	   position = "4192 4192";
	   extent = mFloor(%scale * %ratio) SPC mFloor(%scale * (1 / %ratio));
	   original_size = mFloor(%scale * %ratio) SPC mFloor(%scale * (1 / %ratio));
	   minExtent = "8 2";
	   enabled = "1";
	   visible = "1";
	   clipToParent = "1";
	   bitmap = "Add-Ons/Client_Suburbia/gui/icons/spider/spider";
	   wrap = "0";
	   lockAspectRatio = "0";
	   alignLeft = "0";
	   alignTop = "0";
	   overflowImage = "0";
	   keepCached = "0";
	   mColor = "255 255 255 255";
	   mMultiply = "0";
	   framesPerSecond = getRandom(20, 40);
	   numFrames = "19";
	   skipFrames = "0";
	};
	SpiderSet.add(%spider);
	%spider.offset = getRandom(0, getWord(PlayGui.extent, 0)) SPC getRandom(0, getWord(PlayGui.extent, 1));
	
	%spider.x_multiplier = getRandom(100, 400) / 100;
	%spider.y_multiplier = getRandom(100, 400) / 100;
	
	%spider.move_type = getRandom(1, 3);
	
	if(getRandom(1, 5) == 3)
	{
		%spider.sine_resize = getRandom(20, 250);
		%spider.sine_resize2 = getRandom(5, 20);
		%spider.sine_resize = true;
	}
	else
		%spider.sine_resize = false;
	
	if(%spider.move_type == 2)
	{
		%spider.y_multiplier = getRandom(20, 250);
		%spider.sine_multiplier = getRandom(5, 20);
	}
	
	%spider.tick();
}

function SuburbiaClient::startSpiders(%this)
{
	%this.spidersLoop();
}

function SuburbiaClient::spidersLoop(%this)
{
	cancel(%this.spider_sch);
	
	if(SpiderSet.getCount() < (13.16 * (getWord(PlayGui.extent, 0) / 100) - 70))
		%this.createSpider();
	
	// how fast this shit should be going
	%time = 20 - ($Sim::Time - %this.drugEffect4Start);
	
	%this.spider_sch = %this.schedule(mClamp(%time * 15, 16, 10000), SpidersLoop);
}

function SuburbiaClient::stopSpiders(%this)
{
	%count = SpiderSet.getCount();
	for(%i = 0; %i < %count; %i++)
	{
		%obj = SpiderSet.getObject(%i);
		%obj.fade_multiplier = getRandom(5, 20) / 10;
		%obj.fade = true;
	}
	cancel(%this.spider_sch);
}


function DrugSpider::tick(%this)
{
	cancel(%this.movesch);
	
	if(%this.getGroup().getName() !$= "PlayGui")
		PlayGui.add(%this);
	
	%offset_x = getWord(%this.offset, 0);
	%offset_y = getWord(%this.offset, 1);
	
	// making the fuckers move
	if(%offset_x > getWord(PlayGui.extent, 0) / 2)
		%neg_x = -1;
	else
		%neg_x = 1;
	
	if(%offset_y > getWord(PlayGui.extent, 1) / 2)
		%neg_y = -1;
	else
		%neg_y = 1;
	
	if(%this.move_type == 1)
	{
		%x += %this.x_multiplier * %this.tick * %neg_x + %offset_x;
		%y += %this.y_multiplier * %this.tick * %neg_y + %offset_y;
	}
	else if(%this.move_type == 2)
	{
		%x += %this.x_multiplier * %this.tick * %neg_x + %offset_x;
		%y += mSin(%this.tick / %this.sine_multiplier) * %this.y_multiplier + %offset_y;
	}
	else if(%this.move_type == 3)
	{
		%x += %this.x_multiplier * %this.tick * %neg_x + %offset_x + getRandom(-35, 35);
		%y += %this.y_multiplier * %this.tick * %neg_y + %offset_y + getRandom(-35, 35);
	}
	
	
	%size_x = getWord(%this.original_size, 0);
	%size_y = getWord(%this.original_size, 1);
	
	if(%this.sine_resize)
	{
		%size_x += (mSin(%this.tick / %this.sine_resize2) * %this.sine_resize * 50) * (160 / 181);
		%size_y += (mSin(%this.tick / %this.sine_resize2) * %this.sine_resize * 50) * (181 / 160);
		
		%this.extent = %size_x SPC %size_y;
	}
	
	%x -= mFloor(getWord(%this.extent, 0) / 2);
	%y -= mFloor(getWord(%this.extent, 1) / 2);
	
	%this.resize(%x, %y, %size_x, %size_y);
	
	%this.tick++;
	
	// checking to see if the spider is outside of the playgui at this point
	if(%x > getWord(PlayGui.extent, 0) + %size_x * 1.5 || %y > getWord(PlayGui.extent, 1) + %size_y * 1.5 || %x < -%size_x * 1.5 || %y < -%size_y * 1.5)
	{
		%this.delete();
		return;
	}
	
	if(%this.fade)
	{
		%a = mClamp(-%this.fadetick * %this.fade_multiplier + 255, 0, 255);
		%this.mColor = "255 255 255" SPC %a;
		
		%this.fadetick++;
		
		if(%a == 0)
		{
			%this.delete();
			return;
		}
	}
	else
		%this.mColor = "255 255 255" SPC mClamp(%this.tick * 4, 0, 255);
	
	%this.movesch = %this.schedule(16, tick);
}

function SuburbiaClient::loadUsernames(%this)
{
	%file = new FileObject();
	%file.openForRead("Add-Ons/Client_Suburbia/usernames.txt");
	
	$Suburbia::Drugs::UsernamesCount = 0;
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		$Suburbia::Drugs::Usernames[$Suburbia::Drugs::UsernamesCount] = %line;
		$Suburbia::Drugs::UsernamesCount++;
	}
	
	%file.close();
	%file.delete();
}

function SuburbiaClient::getRandomUsername(%this)
{
	if($Suburbia::Drugs::UsernamesCount $= "")
		%this.loadUsernames();
	
	return $Suburbia::Drugs::Usernames[getRandom(0, $Suburbia::Drugs::UsernamesCount -  1)];
}

function SuburbiaClient::loadInsults(%this)
{
	%file = new FileObject();
	%file.openForRead("Add-Ons/Client_Suburbia/insults.txt");
	
	$Suburbia::Drugs::InsultsCount = 0;
	while(!%file.isEOF())
	{
		%line = %file.readLine();
		$Suburbia::Drugs::Insults[$Suburbia::Drugs::InsultsCount] = %line;
		$Suburbia::Drugs::InsultsCount++;
	}
	
	%file.close();
	%file.delete();
}

function SuburbiaClient::getRandomInsult(%this)
{
	if($Suburbia::Drugs::InsultsCount $= "")
		%this.loadInsults();
	
	return $Suburbia::Drugs::Insults[getRandom(0, $Suburbia::Drugs::InsultsCount -  1)];
}

function SuburbiaClient::createFakeGlassMessageSide(%this, %name, %text, %icon)
{
	new ScriptObject(GlassNotification)
	{
		title = %name;
		text = %text;
		image = %icon $= "" ? "user" : %icon;

		sticky = false;
		callback = "";
	};
	GlassAudio::play("userMsgReceived", GlassSettings.get("Volume::DirectMessage"));
}

function SuburbiaClient::createFakeGlassMessage(%this, %name, %text, %position)
{
	if(GlassSettings.get("Notifications::DarkMode"))
		%color = "16 16 16 170";
	else
		%color = "255 255 255 170";
	
	%swatch = new GuiSwatchCtrl(FakeGlassNotification)
	{
		horizSizing = "right";
		vertSizing = "bottom";
		color = "255 255 255 0";
		position = %position;
		extent = "250 2";
	};
	%swatch.original_position = %position;

	%swatch.head = new GuiBitmapCtrl()
	{
		horizSizing = "right";
		vertSizing = "bottom";
		bitmap = "Add-Ons/System_BlocklandGlass/image/gui/notification_top.png";
		position = "0 0";
		extent = "250 10";
		minextent = "0 0";
		clipToParent = true;

		mColor = %color;
	};

	%swatch.body = new GuiSwatchCtrl()
	{
		horizSizing = "right";
		vertSizing = "bottom";
		color = %color;
		position = "0 10";
		extent = "250 2";
	};

	%swatch.foot = new GuiBitmapCtrl()
	{
		horizSizing = "right";
		vertSizing = "bottom";
		bitmap = "Add-Ons/System_BlocklandGlass/image/gui/notification_bottom.png";
		position = "0 0";
		extent = "250 10";
		minextent = "0 0";
		clipToParent = true;

		mColor = %color;
	};

	%swatch.image = new GuiBitmapCtrl()
	{
		horizSizing = "right";
		vertSizing = "center";
		bitmap = "Add-Ons/System_BlocklandGlass/image/icon/user.png";
		position = "6 4";
		extent = "16 16";
		minextent = "0 0";
		clipToParent = true;
	};

	%swatch.text = new GuiMLTextCtrl()
	{
		horizSizing = "right";
		vertSizing = "bottom";
		text = (GlassSettings.get("Notifications::DarkMode") ? "<color:eeeeee>" : "") @ "<font:verdana bold:15><just:left>" @ %name @ "<br><font:verdana:13>" @ %text;
		position = "28 7";
		extent = "210 12";
		minextent = "210 12";
		autoResize = true;
		maxBitmapHeight = "12";
	};
	GlassAudio::play("userMsgReceived", GlassSettings.get("Volume::DirectMessage"));
	
	%swatch.body.add(%swatch.image);

	%swatch.add(%swatch.head);
	%swatch.add(%swatch.body);
	%swatch.add(%swatch.foot);

	%swatch.add(%swatch.text);

	%swatch.position = %position;
	
	PlayGui.add(%swatch);
	
	if(%swatch.text.isAwake())
	{
		%swatch.text.forceReflow();
		%swatch.body.extent = 250 SPC getWord(%swatch.text.extent, 1)-6;
	}
	else
	{
		%swatch.body.extent = 250 SPC 10;
		%swatch.text.centerY();
	}
	%swatch.foot.placeBelow(%swatch.body);

	%swatch.verticalMatchChildren(20, 0);
	%swatch.image.centerY();
	
	%swatch.schedule(1, shake);
	%swatch.schedule(6000, fadeout);
}

function FakeGlassNotification::shake(%this)
{
	cancel(%this.shakesch);
	%this.position = getWord(%this.original_position, 0) + getRandom(-4, 4) SPC getWord(%this.original_position, 1) + getRandom(-4, 4);
	%this.shakesch = %this.schedule(16, shake);
}

function FakeGlassnotification::fadeout(%this)
{
	%this.delete();
}


function SuburbiaClient::startFakeGlassMsg(%this)
{
	%username1 = %this.getRandomUsername();
	%username2 = %this.getRandomUsername();
	%username3 = %this.getRandomUsername();
	%this.createFakeGlassMessageSide("Mentioned by" SPC %username1, "I just did realize something: I misprise thee.");
	%this.schedule(3000, CreateFakeGlassMessageSide, "General Discussion", %username2 @ ": I has't thee concur with thee" SPC %username1 @ ", I misprise his bones too", "tree");
	%this.schedule(4000, CreateFakeGlassMessageSide, "General Discussion", %username3 @ ": Yeah I misprise that gent", "tree");
	
	for(%i = 0; %i < 25; %i++)
	{
		%username = %this.getRandomUsername();
		%this.schedule(getRandom(100, 300) * %i + 5000, CreateFakeGlassMessageSide, "General Discussion", %username @ ":" SPC SuburbiaClient.getRandomInsult(), "tree");
	}
	
	%this.schedule(8000, CreateFakeGlassMsgLoop);
}

function SuburbiaClient::createFakeGlassMsgLoop(%this)
{
	cancel(%this.fakemsg_sch);
	
	%size_x = getWord(PlayGui.extent, 0);
	%size_y = getWord(PlayGui.extent, 1);
	
	%x = getRandom(mFloor(-250 / 2), %size_x);
	%y = getRandom(-50, %size_y);
	
	%this.createFakeGlassMessage(%this.getRandomUsername(), SuburbiaClient.getRandomInsult(), %x SPC %y);
	
	%this.fakemsg_sch = %this.schedule(mFloor(getWord(PlayGui.extent, 0) * -0.09375 + 240), CreateFakeGlassMsgLoop);
}

function SuburbiaClient::stopFakeGlassMsg(%this)
{
	cancel(%this.fakemsg_sch);
}

function SuburbiaClient::startDrugFX4(%this)
{
	SuburbiaClient.drugEffect4Start = $Sim::Time;
	
	clientCmdCenterPrint("<br><br>\c2You aren't feeling so good...", 5);
	
	CommandToServer('RequestVignette');
	%this.dfx4_vignette = 0;
	%this.dfx4_stop = false;
	%this.setVignetteDrugFX4();
	%this.schedule(4000, startFakeGlassMsg);
	%this.schedule(18000, startSpiders);
	
	%this.schedule(23 * 1000, stopFakeGlassMsg);
	%this.schedule(23 * 1000, stopSpiders);
	%this.schedule(28 * 1000, stopVignette);
}

function SuburbiaClient::setVignetteDrugFX4(%this)
{
	cancel(%this.dfx4vignettesch);
	
	%vignette = (mSin(%this.dfx4_vignette / 25) / 2 + 0.5) * 255;
	
	if(%this.dfx4_stop && (%vignette / 255) * 100 < getWord(%this.vignette, 1) * 100)
	{
		CommandToServer('RequestVignette');
		return;
	}
	
	clientCmdSetVignette(getWord(%this.vignette, 0), %vignette / 255 SPC getWords(%this.vignette, 2, 3) SPC %vignette / 255);
	%this.dfx4_vignette++;
	
	%this.dfx4vignettesch = %this.schedule(16, setVignetteDrugFX4);
}

function SuburbiaClient::stopVignette(%this)
{
	CommandToServer('RequestVignette');
	%this.dfx4_stop = true;
}

function clientCmdReceiveVignette(%multiply, %color)
{
	clientCmdSetVignette(%multiply, %color);
	SuburbiaClient.vignette = %multiply SPC %color;
}


function clientCmdStartDrugFX3(%client)
{
	// since the effects are so fuckin devastating i don't want other servers to fuck with players who have the client
	if($Suburbia::HandshakeCompleted)
		SuburbiaClient.startDrugFX3();
}

function clientCmdStartDrugFX4(%client)
{
	// since the effects are so fuckin devastating i don't want other servers to fuck with players who have the client
	if($Suburbia::HandshakeCompleted)
		SuburbiaClient.startDrugFX4();
}

function SuburbiaClient::startDrugFX3(%this)
{
	cancel(%this.dfx3sch);
	%this.drugFX3Loop();
	%this.schedule(20 * 1000, stopDrugFX3);
}

function SuburbiaClient::drugFX3Loop(%this)
{
	cancel(%this.dfx3sch);
	
	PlayGui.cameraZRot = mSin(mDegToRad(%this.drunk)) * 50;
	
	setFov((mSin(mDegToRad(%this.fov_change)) * 50) + 100);
	
	%this.drunk += 0.7;
	%this.fov_change += 1.2;
	%this.dfx3sch = %this.schedule(6, drugFX3Loop);
}

function SuburbiaClient::stopDrugFX3(%this)
{
	cancel(%this.dfx3sch);
	
	setFOV($Pref::Player::defaultFov);
	PlayGui.cameraZRot = 0;
}