

function clientCmdSuburbia_OpenExportGui(%tax, %alligator)
{
	SuburbiaClient.displayExportWeapons();
	SuburbiaClient.displayExportResources();
	SuburbiaClient.displayExportFoods();
	
	SuburbiaClient.export_tax = %tax;
	SRB_Export_ExportTax.setText("<just:center>Current Export Tax:" SPC mFloor(%tax * 100) @ "%");
	SRB_Export_SellAlligator.setText("Sell Alligator for $" @ mFloor(60 - (%tax * 60)));
	
	SRB_Export_AlligatorCover.setVisible(!%alligator);
	
	Canvas.pushDialog(SRB_Export);
}

function clientCmdSuburbia_OpenExportSellGui(%money, %gui)
{
	SRB_Export_SellInput.setValue("");
	SRB_Export_SellWeaponsInput.setValue("");
	
	SRB_Export_PriceEstimate1.setText("~$" @ %money SPC "per item");
	SRB_Export_PriceEstimate2.setText("~$" @ %money SPC "per item");
	SRB_Export_PriceEstimate3.setText("~$" @ %money SPC "per item");
	
	SRB_Export_PriceEstimate1.centerX();
	SRB_Export_PriceEstimate2.centerX();
	SRB_Export_PriceEstimate3.centerX();
	
	Canvas.pushDialog(%gui);
}

function clientCmdSuburbia_CloseExportGui()
{
	Canvas.popDialog(SRB_Export);
}

function SuburbiaClient::displayExportWeapons(%this)
{
	SRB_Export_WeaponSwatch.deleteAll();
	
	Suburbia_WeaponGroup.player_weapons.sort(0, true);
	
	// going through the different tiers and then putting them in
	%count = Suburbia_WeaponGroup.player_weapons.rowCount();
	for(%i = 0; %i < %count; %i++)
	{
		%name = trim(Suburbia_WeaponGroup.player_weapons.getRowText(%i));
		
		if(%name $= "" || strLwr(%name) $= "hammer" || strLwr(%name) $= "wrench" || strLwr(%name) $= "printer")
			continue;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 18";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_Export_WeaponSwatch.add(%swatch);
		%swatch.position = 0 SPC %weapon_count * 20 + 4;
		
		// creating bitmap/text
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %name;
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_Export_WeaponSwatch.add(%text);
		%text.position = 8 SPC %weapon_count * 20 + 6;
		
		%mouse = new GuiMouseEventCtrl(SRB_ExportResources)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 18";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "weapons_player";
			weapon = %name;
			icon = %icon;
			count = 1;
			max_amt = Suburbia_WeaponGroup.weapon_max_amt[%name];
			
			swatch = %swatch;
		};
		SRB_Export_WeaponSwatch.add(%mouse);
		%mouse.position = 0 SPC %weapon_count * 20 + 4;
		
		%weapon_count++;
	}
	
	SRB_Export_WeaponSwatch.resize(1, 1, getWord(SRB_Export_WeaponSwatch.extent, 0), mClamp(%weapon_count * 23 + 10, 189, 1000));
}

function SuburbiaClient::displayExportFoods()
{
	SRB_Export_FoodSwatch.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 1; %i <= 4; %i++)
	{
		%tier_list = Suburbia_FoodGroup.tier[%i];
		
		%tier_list.sort(0, true);
		
		%count = %tier_list.rowCount();
		for(%x = 0; %x < %count; %x++)
		{
			%data = Suburbia_FoodGroup.food[%tier_list.getRowText(%x)];
			
			if(!isObject(%data) || %data.count <= 0 || %displayed[%tier_list.getRowText(%x)] == true)
				continue;
			
			%displayed[%tier_list.getRowText(%x)] = true;
			
			// swatch used for highlighting selected items
			%swatch = new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 4";
				extent = "140 24";
				minExtent = "8 2";
				enabled = "1";
				visible = false;
				clipToParent = "1";
				color = "180 180 180 255";
			};
			SRB_Export_FoodSwatch.add(%swatch);
			%swatch.position = 0 SPC %food_count * 23 + 4;
			
			// creating bitmap/text
			%bitmap = new GuiBitmapCtrl()
			{
				alignLeft = false;
				alignTop = false;
				bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %data.icon @ ".png";
				clipToParent = true;
				enabled = true;
				extent = "24 24";
				horizSizing = "right";
				keepCached = false;
				lockAspectRatio = false;
				mColor = "255 255 255 255";
				minExtent = "1 1";
				mMultiply = false;
				overflowImage = false;
				position = "2 2";
				profile = "GuiDefaultProfile";
				vertSizing = "bottom";
				visible = true;
				wrap = false;
				
				food_text = %data.text;
			};
			SRB_Export_FoodSwatch.add(%bitmap);
			%bitmap.position = 5 SPC %food_count * 23 + 4;
			
			%text = new GuiMLTextCtrl()
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "130 20";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 99";
				profile = "GuiMLTextProfile";
				selectable = false;
				text = %data.count SPC %data.text @ (%data.count != 1 ? "'s" : "");
				vertSizing = "bottom";
				visible = true;
				
				food_text = %text;
			};
			SRB_Export_FoodSwatch.add(%text);
			%text.position = 33 SPC %food_count * 23 + 9;
			
			%mouse = new GuiMouseEventCtrl(SRB_ExportResources)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "140 24";
				minExtent = "8 2";
				enabled = true;
				visible = true;
				clipToParent = true;
				lockMouse = false;
				
				type = "food_player";
				food = %data.text;
				icon = %data.icon;
				count = %data.count;
				
				swatch = %swatch;
			};
			SRB_Export_FoodSwatch.add(%mouse);
			%mouse.position = 0 SPC %food_count * 23 + 4;
			
			%food_count++;
		}
	}
	
	SRB_Export_FoodSwatch.resize(1, 1, getWord(SRB_Export_FoodSwatch.extent, 0), mClamp(%food_count * 23 + 10, 189, 1000));
}

function SuburbiaClient::displayExportResources(%this)
{
	SRB_Export_ResourcesSwatch.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 0; %i < 14; %i++)
	{
		%name = SuburbiaClient.ingredients[%i];
		%count = SuburbiaClient.ingredients[%name];
		
		if(%count <= 0 || %displayed[%name] == true)
			continue;
		
		if(%name $= "Puff" || %name $= "Henk" || %name $= "Krunt" || %name $= "Boom" || %name $= "Mystery Meat")
			continue;
		
		%displayed[%name] = true;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 24";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_Export_ResourcesSwatch.add(%swatch);
		%swatch.position = 0 SPC %food_count * 23 + 4;
		
		if(%name $= "Mystery Meat")
			%icon = "corpse";
		else
			%icon = %name;
		
		// creating bitmap/text
		%bitmap = new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %icon @ ".png";
			clipToParent = true;
			enabled = true;
			extent = "24 24";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
			
			food_text = %text;
		};
		SRB_Export_ResourcesSwatch.add(%bitmap);
		%bitmap.position = 5 SPC %food_count * 23 + 4;
		
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %count SPC %name @ ((%count != 1 && %name $= "Egg") ? "s" : "");
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_Export_ResourcesSwatch.add(%text);
		%text.position = 33 SPC %food_count * 23 + 9;
		
		%mouse = new GuiMouseEventCtrl(SRB_ExportResources)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 24";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "resource_player";
			resource = %name;
			icon = %icon;
			count = %count;
			
			swatch = %swatch;
		};
		SRB_Export_ResourcesSwatch.add(%mouse);
		%mouse.position = 0 SPC %food_count * 23 + 4;
		
		%food_count++;
	}
	
	SRB_Export_ResourcesSwatch.resize(1, 1, getWord(SRB_Export_ResourcesSwatch.extent, 0), mClamp(%food_count * 23 + 10, 189, 1000));
}

function SRB_ExportResources::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = true;
	%this.mousedown = true;
}

function SRB_ExportResources::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
	
	if(%this.food !$= "" || %this.resource !$= "")
	{
		SRB_Export_SellBitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %this.icon @ ".png";
		
		if(%this.resource $= "")
		{
			%name = %this.food;
			SRB_Export_SellText.setText("<font:Calibri:24>" @ %this.count SPC %name @ (%this.count != 1 ? "'s" : ""));
		}
		else
		{
			%name = %this.resource;
			SRB_Export_SellText.setText("<font:Calibri:24>" @ %this.count SPC %name @ (%this.count != 1 && %name $= "Egg" ? "s" : ""));
		}
		
		SuburbiaClient.selected_export_name = %name;
		
		SRB_Export_SellBitmap.position = 54 + SuburbiaClient.food_offset[%name] SPC 29;
		SRB_Export_SellText.position = 100 + SuburbiaClient.food_offset[%name] SPC 38;
		
		CommandToServer('RequestExport', %name, SRB_Export_Sell);
	}
	else if(%this.weapon !$= "")
	{
		SRB_Export_SellItemText.setText("<just:center><font:Calibri:24>" @ %this.weapon);
		SRB_Export_SellWeaponText.setText("<just:center><font:Calibri:24>" @ %this.weapon);
		SRB_Export_SellWeaponAmt.setText("<just:center>You can sell" SPC %this.max_amt);
		
		SuburbiaClient.selected_export_name = %this.weapon;
		SuburbiaClient.max_export_amt = %this.max_amt;
		
		%name = %this.weapon;
		
		if(%this.max_amt !$= "")
			CommandToServer('RequestExport', %name, SRB_Export_SellWeapons);
		else
			CommandToServer('RequestExport', %name, SRB_Export_SellItems);
	}
}

function SRB_ExportResources::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
}

function SuburbiaClient::exportFood(%this)
{
	CommandToServer('Export', SuburbiaClient.selected_export_name, SRB_Export_SellInput.getValue());
}

function SuburbiaClient::exportItem(%this)
{
	CommandToServer('Export', SuburbiaClient.selected_export_name);
}

function SuburbiaClient::exportWeapon(%this)
{
	CommandToServer('Export', SuburbiaClient.selected_export_name, SRB_Export_SellWeaponsInput.getValue());
}

function SuburbiaClient::exportAlligator(%this)
{
	CommandToServer('Export', "alligator");
}

function clientCmdSuburbia_UpdateExport(%tax, %alligator)
{
	SuburbiaClient.displayExportWeapons();
	SuburbiaClient.displayExportResources();
	SuburbiaClient.displayExportFoods();
	
	SuburbiaClient.export_tax = %tax;
	SRB_Export_ExportTax.setText("<just:center>Current Export Tax:" SPC mFloor(%tax * 100) @ "%");
	SRB_Export_SellAlligator.setText("Sell Alligator for $" @ mFloor(60 - (%tax * 60)));
	
	SRB_Export_AlligatorCover.setVisible(!%alligator);
	
	
	Canvas.popDialog(SRB_Export_Sell);
	Canvas.popDialog(SRB_Export_SellItems);
	Canvas.popDialog(SRB_Export_SellWeapons);
}