function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}

function clientCmdSetVehicleGrounded(%grounded)
{
	$Suburbia::VehicleGrounded = %grounded;
}

$Suburbia::Vehicle["max"] = 55;

function clientCmdVehicleSpawned(%ghostId)
{
	if(alxIsPlaying($Suburbia::VehicleSound[%ghostId, "idle"]))
		return;
	
	// suburbia_updateEngineLoop(ServerConnection.resolveGhostId(%ghostId), %ghostId);
	echo(ServerConnection.resolveGhostId(%ghostID) SPC %ghostId);
	ServerConnection.resolveGhostId(%ghostID).engine_sounds(%ghostId);
}

function WheeledVehicle::engine_sounds(%this, %ghostId)
{
	cancel(%this.engine_sounds_sch);
	
	if(!isObject($Suburbia::VehicleDatablock))
		findWheeledVehicleDatablock();
	
	// figuring out sounds
	if(isObject(%this))
	{
		if(%this.ui_name $= "")
			%this.ui_name = %this.getDatablock().uiName;
		
		if(!$Suburbia::VehicleData[%this.ui_name, "sounds_set"])
			return;
	}
	
	if(!isObject(%this) || %ghostId == -1 || %ghostId $= "")
	{
		alxStop($Suburbia::VehicleSound[%ghostId, "idle"]);
		alxStop($Suburbia::VehicleSound[%ghostId, "sample"]);
		// alxStop($Suburbia::VehicleSound[%ghostId, "sample2"]);
	
		return;
	}
	
	if(!alxIsPlaying($Suburbia::VehicleSound[%ghostId, "idle"]))
	{
		alxStop($Suburbia::VehicleSound[%ghostId, "idle"]);
		alxStop($Suburbia::VehicleSound[%ghostId, "sample"]);
		// alxStop($Suburbia::VehicleSound[%ghostId, "sample2"]);
		
		$Suburbia::VehicleSound[%ghostId, "idle"] = alxPlay($Suburbia::VehicleData[%this.ui_name, "idle"]);
		$Suburbia::VehicleSound[%ghostId, "sample"] = alxPlay($Suburbia::VehicleData[%this.ui_name, "sample"]);
		
		// if($Suburbia::VehicleData[%this.ui_name, "sample2"] !$= "")
		// 	$Suburbia::VehicleSound[%ghostId, "sample2"] = alxPlay($Suburbia::VehicleData[%this.ui_name, "sample2"]);
	}
	
	%resistence = -0.2;
	%gear_limit = 3;
	
	
	// all the calculations that figure out rpm
		%speed = VectorLen(%this.getVelocity());
		
		if(%this.vehicle_tick % 100 == 0)
			%this.last_velocity = mFloor(%speed);
		
		if($mvForwardAction && $mvBackwardAction)
		{
			%direction = "\c7(+-) ";
			%dir = 0;
		}
		else if($mvForwardAction)
		{
			%direction = "\c3(+) ";
			%dir = 1;
		}
		else if($mvBackwardAction)
		{
			%direction = "\c0(-) ";
			%dir = -1;
		}
		else
		{
			%direction = "\c4(n) ";
			%dir = 0;
		}
		
		if($mvTriggerCount2)
		{
			%direction = %direction @ "\c6(b) ";
			%brake = true;
		}
		else
			%brake = false;
		
		%pos = %this.positionGet();
		
		%angle = getWords(%this.rotationGet(), 0, 2) SPC getWord(%this.rotationGet(), 3) * 0.0174533;
		%angle = axisToEuler(%angle);
		%angle = getWord(%angle, 0);
		
		// work scale: 50 is normal work, 0 is no work, 100 is all the work
		%factor = (0.04 * mPow(%speed - ($Suburbia::Vehicle["max"] / 2), 2)) + 5;
		%factor = %speed * 0.2;
		
		if(%factor $= "1.#INF")
			%factor = 0;
		
		if(!$Suburbia::VehicleGrounded)
			%grounded_factor = 100;
		else
			%grounded_factor = 1;
		
		
		%work = (%angle + (%factor)) * %grounded_factor;
		%work = mClampF(%work, 0, 50);
		
		if(%dir != 0 && %brake != true)
			%this.rpm += %work * 0.05;
		else
			%this.rpm += %resistence;
		
		%this.rpm = mClampF(%this.rpm, 0, 300);
		
		if(%this.last_velocity == 0 && %dir != 0)
		{
			%this.rpm = 0;
			%this.gear = 1;
			%this.last_velocity = mFloor(%speed);
		}
		
		if(%dir != 0 && %this.rpm > 100 && %this.gear < %gear_limit)
		{
			%this.gear++;
			%this.rpm = 0;
		}
		
		%this.last_work = %work;
		
		%msg1 = "<just:left>\c2Speed:" SPC %direction @ "\c2" @ mFloor(%speed) @ "<br>\c2Angle:" SPC mFloor(%angle) @ "\xB0<br>\c2Grounded:" SPC $Suburbia::VehicleGrounded @ "<br>\c2Work:" SPC mFloor(%work);
		%msg2 = "<br>\c2Pseudo RPM:" SPC mFloor(%this.rpm) @ "<br>\c2Gear:" SPC %this.gear;
		clientCmdCenterPrint(%msg1 @ %msg2, 1);
	// end calculations
	
	// ok now lets do the sound
	%idle = (%speed * -0.03) + 1;
	
	alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_REFERENCE_DISTANCE", %idle * 3);
	alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_PITCH", %idle);
	
	if(%this.rpm $= "")
		%this.rpm = 0;
	
	%engine_pitch = mClampF((%this.rpm / 100) + ((%this.gear - 1) * 0.6), 0, 2);
	echo(%engine_pitch);
	
	alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_REFERENCE_DISTANCE", 1);
	alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_PITCH", %engine_pitch + 0.1);
	
	alxSourcef($Suburbia::VehicleSound[%ghostId, "idle"], "AL_GAIN", (0.6 * $Suburbia::EngineVolume));
	alxSourcef($Suburbia::VehicleSound[%ghostId, "sample"], "AL_GAIN", mClampF((1 + %engine_pitch), 0, 3) * (0.6 * $Suburbia::EngineVolume));
	
	alxSource3f($Suburbia::VehicleSound[%ghostId, "idle"], "AL_POSITION", "0 0 0.1");
	alxSource3f($Suburbia::VehicleSound[%ghostId, "sample"], "AL_POSITION", "0 0 0.1");
	
	%this.vehicle_tick++;
	%this.engine_sounds_sch = %this.schedule(5, engine_sounds, %ghostId);
}