
function SuburbiaClient::openTradeGui(%this)
{
	%this.displayTradeSelection();
	Canvas.pushDialog(SRB_Character_TradeSelect);
}

function clientCmdSuburbia_ShowTradeGui(%trader, %money)
{
	SRB_Trade_PlayerOffersName.setText(%trader @ "'s Offers");
	SuburbiaClient.displayTradeMoney(%money);
	SuburbiaClient.displayTradeFoodWeapons();
	SuburbiaClient.displayTradeResources();
	
	Canvas.pushDialog(SRB_Character_Trade);
	SRB_Trade_MoneyInput.schedule(1, setActive, false);
}

function SuburbiaClient::displayTradeMoney(%this, %amt)
{
	SRB_Trade_MoneyText.setText("<color:bbbbbb><font:Calibri:26>Funds: <color:00cc00>$" @ mFloor(%amt));
}

function SuburbiaClient::displayTradeFoodWeapons(%this)
{
	SRB_Trade_FoodSwatch.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 1; %i <= 4; %i++)
	{
		%tier_list = Suburbia_FoodGroup.tier[%i];
		
		%tier_list.sort(0, true);
		
		%count = %tier_list.rowCount();
		for(%x = 0; %x < %count; %x++)
		{
			%data = Suburbia_FoodGroup.food[%tier_list.getRowText(%x)];
			
			if(!isObject(%data) || %data.count <= 0 || %displayed[%tier_list.getRowText(%x)] == true)
				continue;
			
			%displayed[%tier_list.getRowText(%x)] = true;
			
			// swatch used for highlighting selected items
			%swatch = new GuiSwatchCtrl()
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 4";
				extent = "140 18";
				minExtent = "8 2";
				enabled = "1";
				visible = false;
				clipToParent = "1";
				color = "180 180 180 255";
			};
			SRB_Trade_FoodSwatch.add(%swatch);
			%swatch.position = 0 SPC %food_count * 20 + 4;
			
			%text = new GuiMLTextCtrl()
			{
				allowColorChars = true;
				autoResize = true;
				clipToParent = true;
				enabled = true;
				extent = "96 20";
				horizSizing = "right";
				lineSpacing = 2;
				maxBitmapHeight = -1;
				maxChars = -1;
				minExtent = "8 2";
				position = "0 99";
				profile = "GuiMLTextProfile";
				selectable = false;
				text = %data.count SPC %data.text @ (%data.count != 1 ? "'s" : "");
				vertSizing = "bottom";
				visible = true;
				
				food_text = %text;
			};
			SRB_Trade_FoodSwatch.add(%text);
			%text.position = 8 SPC %food_count * 20 + 6;
			
			%mouse = new GuiMouseEventCtrl(SRB_TradeResources)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "0 0";
				extent = "140 24";
				minExtent = "8 2";
				enabled = true;
				visible = true;
				clipToParent = true;
				lockMouse = false;
				
				type = "food_player";
				food = %data.text;
				icon = %data.icon;
				count = %data.count;
				
				swatch = %swatch;
			};
			SRB_Trade_FoodSwatch.add(%mouse);
			%mouse.position = 0 SPC %food_count * 20 + 4;
			
			%food_count++;
		}
	}
	
	Suburbia_WeaponGroup.player_weapons.sort(0, true);
	
	%weapon_count += %food_count;
	
	// going through the different tiers and then putting them in
	%count = Suburbia_WeaponGroup.player_weapons.rowCount();
	for(%i = 0; %i < %count; %i++)
	{
		%name = trim(Suburbia_WeaponGroup.player_weapons.getRowText(%i));
		
		if(%name $= "" || strLwr(%name) $= "hammer" || strLwr(%name) $= "wrench" || strLwr(%name) $= "printer")
			continue;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 18";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_Trade_FoodSwatch.add(%swatch);
		%swatch.position = 0 SPC %weapon_count * 20 + 4;
		
		// creating bitmap/text
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %name;
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_Trade_FoodSwatch.add(%text);
		%text.position = 8 SPC %weapon_count * 20 + 6;
		
		%mouse = new GuiMouseEventCtrl(SRB_TradeResources)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 18";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "weapons_player";
			weapon = %name;
			icon = %icon;
			count = 1;
			max_amt = Suburbia_WeaponGroup.weapon_max_amt[%name];
			
			swatch = %swatch;
		};
		SRB_Trade_FoodSwatch.add(%mouse);
		%mouse.position = 0 SPC %weapon_count * 20 + 4;
		
		%weapon_count++;
	}
	
	SRB_Trade_FoodSwatch.resize(1, 1, getWord(SRB_Trade_FoodSwatch.extent, 0), mClamp(%weapon_count * 20 + 10, 189, 1000));
}

function SuburbiaClient::displayTradeResources(%this)
{
	SRB_Trade_ResourcesSwatch.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 0; %i < 14; %i++)
	{
		%name = SuburbiaClient.ingredients[%i];
		%count = SuburbiaClient.ingredients[%name];
		
		if(%count <= 0 || %displayed[%name] == true)
			continue;
		
		if(%name $= "Mystery Meat")
			continue;
		
		%displayed[%name] = true;
		
		// swatch used for highlighting selected items
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 18";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		SRB_Trade_ResourcesSwatch.add(%swatch);
		%swatch.position = 0 SPC %food_count * 20 + 4;
		
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %count SPC %name @ ((%count != 1 && %name $= "Egg") ? "s" : "");
			vertSizing = "bottom";
			visible = true;
			
			food_text = %text;
		};
		SRB_Trade_ResourcesSwatch.add(%text);
		%text.position = 8 SPC %food_count * 20 + 6;
		
		%mouse = new GuiMouseEventCtrl(SRB_TradeResources)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 24";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			type = "resource_player";
			resource = %name;
			icon = %name;
			count = %count;
			
			swatch = %swatch;
		};
		SRB_Trade_ResourcesSwatch.add(%mouse);
		%mouse.position = 0 SPC %food_count * 20 + 4;
		
		%food_count++;
	}
	
	SRB_Trade_ResourcesSwatch.resize(1, 1, getWord(SRB_Trade_ResourcesSwatch.extent, 0), mClamp(%food_count * 20 + 10, 189, 1000));
}

function SRB_TradeResources::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = true;
	%this.mousedown = true;
}

function SRB_TradeResources::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
	
	if(%this.food !$= "")
	{
		SRB_Trade_OfferBitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %this.icon @ ".png";
		SRB_Trade_OfferText.setText("<font:Calibri:24>" @ %this.count SPC %this.food @ (%this.count != 1 ? "'s" : ""));
		
		SuburbiaClient.trade_offer_max = %this.count;
		SuburbiaClient.selected_trade_name = %this.food;
		
		%food_name = trim(strReplace(%this.food, "1", ""));
		%food_name = trim(strReplace(%food_name, "2", ""));
		%food_name = trim(strReplace(%food_name, "3", ""));
		
		SRB_Trade_OfferBitmap.position = 54 + SuburbiaClient.food_offset[%food_name] SPC 29;
		SRB_Trade_OfferText.position = 100 + SuburbiaClient.food_offset[%food_name] SPC 38;
		
		SRB_Trade_ResourceOfferAmount.setValue("");
		Canvas.pushDialog(SRB_Character_TradeOfferResources);
	}
	else if(%this.resource !$= "")
	{
		SRB_Trade_OfferBitmap.bitmap = "Add-Ons/Client_Suburbia/gui/icons/inventory/" @ %this.icon @ ".png";
		SRB_Trade_OfferText.setText("<font:Calibri:24>" @ %this.count SPC %this.resource);
		
		SuburbiaClient.trade_offer_max = %this.count;
		SuburbiaClient.selected_trade_name = %this.resource;
		
		%resource_name = trim(strReplace(%this.resource, "1", ""));
		%resource_name = trim(strReplace(%resource_name, "2", ""));
		%resource_name = trim(strReplace(%resource_name, "3", ""));
		
		SRB_Trade_OfferBitmap.position = 54 + SuburbiaClient.food_offset[%resource_name] SPC 29;
		SRB_Trade_OfferText.position = 100 + SuburbiaClient.food_offset[%resource_name] SPC 38;
		
		SRB_Trade_ResourceOfferAmount.setValue("");
		Canvas.pushDialog(SRB_Character_TradeOfferResources);
	}
	else if(%this.weapon !$= "")
	{
		SRB_Trade_OfferWeaponText.setText("<just:center><font:Calibri:24>" @ %this.weapon);
		SRB_Trade_OfferItemText.setText("<just:center><font:Calibri:24>" @ %this.weapon);
		SRB_Trade_OfferWeaponAmtText.setText("<just:center>You can trade" SPC %this.max_amt);
		
		SuburbiaClient.trade_offer_max = %this.count;
		SuburbiaClient.selected_trade_name = %this.weapon;
		SuburbiaClient.max_amt = %this.max_amt;
		
		%weapon_name = trim(strReplace(%this.weapon, "1", ""));
		%weapon_name = trim(strReplace(%weapon_name, "2", ""));
		%weapon_name = trim(strReplace(%weapon_name, "3", ""));
		
		if(%this.max_amt !$= "")
		{
			SRB_Trade_WeaponOfferAmount.setValue("");
			Canvas.pushDialog(SRB_Character_TradeOfferWeapons);
		}
		else
			Canvas.pushDialog(SRB_Character_TradeOfferItems);
	}
}

function SRB_TradeResources::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
}




function SuburbiaClient::tradeOfferItem(%this)
{
	%name = %this.selected_trade_name;
	Canvas.popDialog(SRB_Character_TradeOfferItems);
	
	CommandToServer('AddTradeElement', %name);
}

function SuburbiaClient::offerResourceTrade(%this)
{
	%amt = SRB_Trade_ResourceOfferAmount.getValue();
	%name = %this.selected_trade_name;
	Canvas.popDialog(SRB_Character_TradeOfferResources);
	
	CommandToServer('AddTradeElement', %name, %amt);
}

function SuburbiaClient::tradeOfferWeapon(%this)
{
	%amt = SRB_Trade_WeaponOfferAmount.getValue();
	%name = %this.selected_trade_name;
	Canvas.popDialog(SRB_Character_TradeOfferWeapons);
	
	CommandToServer('AddTradeElement', %name, %amt);
}

function SuburbiaClient::tradeOfferMoney(%this)
{
	CommandToServer('AddTradeElement', "Money", SRB_Trade_MoneyInput.getValue());
}


function SuburbiaClient::displayTradeElements(%this)
{
	%group = %this.tradegroup;
	
	SRB_Trade_PlayerOffersSwatch.deleteAll();
	SRB_Trade_OtherOffersSwatch.deleteAll();
	
	// going through the different tiers and then putting them in
	for(%i = 0; %i < %group.getCount(); %i++)
	{
		%obj = %group.getObject(%i);
		%name = %obj.name;
		%count = %obj.amt;
		%owner = %obj.owner;
		
		if(%owner)
			%egg = SRB_Trade_PlayerOffersSwatch;
		else
			%egg = SRB_Trade_OtherOffersSwatch;
		
		%swatch = new GuiSwatchCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 4";
			extent = "140 18";
			minExtent = "8 2";
			enabled = "1";
			visible = false;
			clipToParent = "1";
			color = "180 180 180 255";
		};
		%egg.add(%swatch);
		
		if(%owner)
			%swatch.position = 0 SPC %owner_count * 20 + 4;
		else
			%swatch.position = 0 SPC %other_count * 20 + 4;
		
		
		
		if(%name $= "Money")
			%text2 = "$" @ %count;
		else if(%count !$= "")
			%text2 = %count SPC %name @ "(s)";
		else
			%text2 = %name;
		
		%text = new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "GuiMLTextProfile";
			selectable = false;
			text = %text2;
			vertSizing = "bottom";
			visible = true;
		};
		%egg.add(%text);
		
		if(%owner)
			%text.position = 8 SPC %owner_count * 20 + 6;
		else
			%text.position = 8 SPC %other_count * 20 + 6;
		
		
		
		%mouse = new GuiMouseEventCtrl(SRB_TradeOffer)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "140 24";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
			
			name = %name;
			count = %count;
			
			swatch = %swatch;
		};
		%egg.add(%mouse);
		
		if(%owner)
			%mouse.position = 0 SPC %owner_count * 20 + 4;
		else
			%mouse.position = 0 SPC %other_count * 20 + 4;
		
		
		if(%owner)
			%owner_count++;
		else
			%other_count++;
	}
	
	SRB_Trade_PlayerOffersSwatch.resize(1, 1, getWord(SRB_Trade_PlayerOffersSwatch.extent, 0), mClamp(%owner_count * 20 + 10, 307, 1000));
	SRB_Trade_OtherOffersSwatch.resize(1, 1, getWord(SRB_Trade_OtherOffersSwatch.extent, 0), mClamp(%other_count * 20 + 10, 307, 1000));
}

function SRB_TradeOffer::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = true;
	%this.mousedown = true;
}

function SRB_TradeOffer::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
	
	echo("a");
	
	CommandToServer('RemoveTradeElement', %this.name);
}

function SRB_TradeOffer::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.swatch.visible = false;
}



function clientCmdSuburbia_ClearTradeElements()
{
	if(!isObject(SuburbiaClient.tradegroup))
		SuburbiaClient.tradegroup = new ScriptGroup();
	
	SuburbiaClient.tradegroup.deleteAll();
}

function clientCmdSuburbia_AddTradeElement(%name, %amt, %owner)
{
	if(!isObject(SuburbiaClient.tradegroup))
		SuburbiaClient.tradegroup = new ScriptGroup();
	
	%element = new ScriptObject()
	{
		name = %name;
		amt = %amt;
		owner = %owner;
	};
	SuburbiaClient.tradegroup.add(%element);
}

function clientCmdSuburbia_DisplayTradeElements()
{
	if(!isObject(SuburbiaClient.tradegroup))
		SuburbiaClient.tradegroup = new ScriptGroup();
	
	SuburbiaClient.displayTradeElements();
}

function clientCmdSuburbia_UpdateTradeResources(%money)
{
	SuburbiaClient.displayTradeMoney(%money);
	SuburbiaClient.displayTradeFoodWeapons();
	SuburbiaClient.displayTradeResources();
}

function clientCmdSuburbia_UpdateTradeAccept(%name, %accept, %client_accepted)
{
	if(%accept)
		SRB_Trade_AcceptWarning.setText("<just:center>" @ %name SPC "has accepted");
	else
		SRB_Trade_AcceptWarning.setText("<just:center>" @ %name SPC "has not accepted");
	
	SuburbiaClient.tradeaccepted = %client_accepted;
	
	if(!%client_accepted)
		SRB_Trade_Accept.setText("Accept Trade");
	else
		SRB_Trade_Accept.setText("Unaccept Trade");
}

function SuburbiaClient::acceptTrade(%this)
{
	if(!%this.tradeaccepted)
	{
		CommandToServer('AcceptTrade');
		SRB_Trade_Accept.setText("Unaccept Trade");
	}
	else
	{
		CommandToServer('CancelAcceptTrade');
		SRB_Trade_Accept.setText("Accept Trade");
	}
}

function SuburbiaClient::cancelTrade(%this)
{
	CommandToServer('CancelTrade');
}

function clientCmdSuburbia_HideTradeGui()
{
	Canvas.popDialog(SRB_Character_Trade);
}






function SuburbiaClient::displayTradeSelection(%this)
{
	SRB_Trade_Playerlist.clear();
	
	for(%i = 0; %i < NPL_List.rowCount(); %i++)
	{
		%name = getField(NPL_List.getRowTextById(NPL_List.getRowId(%i)), 1);
		
		if(%name !$= $Pref::Player::NetName)
			SRB_Trade_Playerlist.addRow(%i, %name, 0);
	}
	
	SRB_Trade_Playerlist.sort(0);
}

function SuburbiaClient::offerTrade(%this)
{
	CommandToServer('RequestTrade', SRB_Trade_Playerlist.getRowTextById(SRB_Trade_Playerlist.getSelectedId()));
}

function clientCmdSuburbia_HideTradeSelect()
{
	Canvas.popDialog(SRB_Character_TradeSelect);
}