function createVehicleIcon(%name, %icon_file, %position)
{
	%gui_name = "SRB_VehicleIcon_" @ %name;
	
	%icon = new GuiSwatchCtrl(%gui_name)
	{
		clipToParent = 1;
		color = "0 0 0 255";
		enabled = 1;
		extent = "98 116";
		horizSizing = "right";
		minExtent = "1 1";
		position = %position;
		profile = "GuiDefaultProfile";
		vertSizing = "bottom";
		visible = 1;
		
		new GuiBitmapCtrl()
		{
			alignLeft = false;
			alignTop = false;
			bitmap = "Add-Ons/Client_Suburbia/gui/icons/vehicles/" @ %icon_file @ ".png";
			clipToParent = true;
			enabled = true;
			extent = "94 94";
			horizSizing = "right";
			keepCached = false;
			lockAspectRatio = false;
			mColor = "255 255 255 255";
			minExtent = "1 1";
			mMultiply = false;
			overflowImage = false;
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = true;
			wrap = false;
		};
		
		new GuiMLTextCtrl()
		{
			allowColorChars = true;
			autoResize = true;
			clipToParent = true;
			enabled = true;
			extent = "96 20";
			horizSizing = "right";
			lineSpacing = 2;
			maxBitmapHeight = -1;
			maxChars = -1;
			minExtent = "8 2";
			position = "0 99";
			profile = "ServerListProfile";
			selectable = true;
			text = "<color:ffffff><just:center><font:Arial:14>" @ %name;
			caption = %name;
			vertSizing = "bottom";
			visible = true;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "0 0";
			extent = "98 116";
			horizSizing = "right";
			minExtent = "1 1";
			position = "0 0";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiSwatchCtrl()
		{
			clipToParent = 1;
			color = "0 0 0 0";
			enabled = 1;
			position = "2 2";
			extent = "94 94";
			horizSizing = "right";
			minExtent = "1 1";
			position = "2 2";
			profile = "GuiDefaultProfile";
			vertSizing = "bottom";
			visible = 1;
		};
		
		new GuiMouseEventCtrl(SRB_VehicleIconMouse)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "98 116";
			minExtent = "8 2";
			enabled = true;
			visible = true;
			clipToParent = true;
			lockMouse = false;
		};
	};
	Suburbia_VehicleScrollBackground.add(%icon);
	%icon.position = %position;
	
	%icon.icon_image = %icon.getObject(0);
	%icon.icon_caption = %icon.getObject(1);
	%icon.white_tint = %icon.getObject(2);
	%icon.yellow_tint = %icon.getObject(3);
	%icon.icon_mouseCtrl = %icon.getObject(4);
	
	%icon.original_position = %position;
	
	%icon.vehicle_name = %real_name;
	
	return %gui_name;
}

function addVehicleIcon(%name, %icon_file)
{
	if(Suburbia_VehicleScroll.suburbia_currentRow $= "")
		Suburbia_VehicleScroll.suburbia_currentRow = 1;
	
	// calculate the height that we should be at
	%current_row = Suburbia_VehicleScroll.suburbia_currentRow;
	%height = (((%current_row - 1) * 116) + (%current_row * 5));
	
	// determine where along the x axis we should place the icon
	if(Suburbia_VehicleScroll.suburbia_row[%current_row, "slot"] $= "")
		Suburbia_VehicleScroll.suburbia_row[%current_row, "slot"] = 1;
	
	%current_slot = Suburbia_VehicleScroll.suburbia_row[%current_row, "slot"];
	%width = (((%current_slot - 1) * 98) + (%current_slot * 5));
	
	// create the gui and file the icon under an array all at the same time
	%icon = Suburbia_VehicleScroll.suburbia_row[%current_slot, Suburbia_VehicleScroll.suburbia_row[%current_row, "slot"]] = createVehicleIcon(%name, %icon_file, %width SPC %height);
	
	// if we have too many icons on one row, increment the total row count so next time we start on a new row
	if(Suburbia_VehicleScroll.suburbia_row[%current_row, "slot"] == 3)
		Suburbia_VehicleScroll.suburbia_currentRow++;
	else
		Suburbia_VehicleScroll.suburbia_row[%current_row, "slot"]++;
		
	// resizing the background so that the scroll works right
	%background_height = (%current_row * 116) + ((%current_row + 1) * 5);
	
	if(%background_height < 292)
		%background_height = 292;
	
	Suburbia_VehicleScrollBackground.resize(1, 1, 315, %background_height);
	
	return %icon;
}

function SRB_VehicleIconMouse::onMouseDown(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setMouseDown();
}

function SRB_VehicleIconMouse::onMouseUp(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	if(%this.mouseDown)
		%this.setSelectColors();
}

function SRB_VehicleIconMouse::onMouseEnter(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.setHoverColors();
}

function SRB_VehicleIconMouse::onMouseLeave(%this, %control, %eventModifier, %xy, %numMouseClicks)
{
	%this.resetHoverColors();
	
	%scroll = %this.getGroup().getGroup();
	if(%this.mouseDown == true && %this.isSelected == false && %scroll.currently_selected == %this)
		%this.resetSelectColors();
	
	if(%this.mouseDown == true)
		%this.resetMouseDown();
	
	%this.mouseDown = false;
}

function SRB_VehicleIconMouse::setHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("255 255 255 90");
	
	%this.hoverActive = true;
}

function SRB_VehicleIconMouse::resetHoverColors(%this)
{
	%this.getGroup().white_tint.setColor("0 0 0 0");
	
	%this.hoverActive = false;
}

function SRB_VehicleIconMouse::setSelectColors(%this)
{
	CommandToServer('RequestInflation');
	
	%this.resetMouseDown();
	%parent = %this.getGroup();
	
	%parent.yellow_tint.setColor("255 255 0 115");
	%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:14>" @ %parent.icon_caption.caption);
	
	%scroll = %parent.getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	// set the description shit
	Suburbia_VehicleDescTitle.setValue("<just:center><font:Arial bold:24>" @ %parent.vehicle_name);
	
	%cost = $Suburbia::VehicleData[%parent.vehicle_name, "cost"];
	if(%cost $= "")
		%cost = 0;
	
	Suburbia_VehicleDescBitmap.setBitmap("Add-Ons/Client_Suburbia/gui/icons/vehicles/" @ $Suburbia::VehicleData[%parent.vehicle_name, "icon"] @ ".png");
	Suburbia_VehicleDescCost.setValue("<font:Arial italic:15>Cost: $" @ %cost SPC "(+" SPC SuburbiaClient.getInflationDifference(%cost) @ ")");
	
	Suburbia_VehicleDescCost.extent = "500 10";
	Suburbia_VehicleDescHP.position = "120 190";
	
	Suburbia_VehicleDescHP.setValue("<font:Arial italic:15>HP:" SPC $Suburbia::VehicleData[%parent.vehicle_name, "hp"]);
	Suburbia_VehicleDescSeats.setValue("<font:Arial italic:15>Seats:" SPC $Suburbia::VehicleData[%parent.vehicle_name, "seats"]);
	
	setVehicleSpeedBar($Suburbia::VehicleData[%parent.vehicle_name, "speed"]);
	setVehicleAccelBar($Suburbia::VehicleData[%parent.vehicle_name, "accel"]);
	setVehicleBrakeBar($Suburbia::VehicleData[%parent.vehicle_name, "brake"]);
	setVehicleHandlingBar($Suburbia::VehicleData[%parent.vehicle_name, "handling"]);
	Suburbia_VehicleDescCover.visible = false;
	
	%scroll.currently_selected = %this;
	%this.isSelected = true;
}

function SRB_VehicleIconMouse::resetSelectColors(%this)
{
	%this.getGroup().yellow_tint.setColor("0 0 0 0");
	%this.getGroup().icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	
	%scroll = %this.getGroup().getGroup();
	if(isObject(%scroll.currently_selected) && %scroll.currently_selected != %this)
		%scroll.currently_selected.resetSelectColors();
	
	%scroll.currently_selected = "";
	
	%this.isSelected = false;
}

function SRB_VehicleIconMouse::setMouseDown(%this)
{
	%parent = %this.getGroup();
	
	if(%parent.original_position $= "")
		%parent.original_position = %parent.position;
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0) + 2, getWord(%position, 1) + 2, 94, 112);
	
	if(!%this.isSelected)
		%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	else
		%parent.icon_caption.setValue("<color:FFFF00><just:center><font:Arial:12>" @ %this.getGroup().icon_caption.caption);
	
	%parent.icon_caption.resize(0, 96, 92, 20);
	
	%parent.icon_image.resize(2, 2, 90, 90);
	%parent.yellow_tint.resize(2, 2, 90, 90);
	
	%this.mouseDown = true;
}

function SRB_VehicleIconMouse::resetMouseDown(%this)
{
	%parent = %this.getGroup();
	
	%position = %parent.original_position;
	%parent.resize(getWord(%position, 0), getWord(%position, 1), 98, 116);
	
	%parent.icon_caption.setValue("<color:FFFFFF><just:center><font:Arial:14>" @ %this.getGroup().icon_caption.caption);
	%parent.icon_caption.resize(0, 99, 96, 20);
	
	%parent.icon_image.resize(2, 2, 94, 94);
	%parent.yellow_tint.resize(2, 2, 94, 94);
	
	%this.mouseDown = false;
}

function SuburbiaClient::showVehiclesGui()
{
	if(!$Suburbia::HandshakeCompleted)
		return;
	
	if($Suburbia::VehicleDataCount $= "" || $Suburbia::VehicleDataCount == 0)
	{
		SuburbiaClient.clearVehicleScrollList();
		SuburbiaClient.displayVehicles();
	}
	
	SuburbiaClient.resetSelectedVehicleIcon();
	Canvas.schedule(1, pushDialog, SRB_Vehicle_Purchase);
}

function SuburbiaClient::resetSelectedVehicleIcon()
{
	if(isObject(Suburbia_VehicleScrollBackground.currently_selected))
		if(isFunction(Suburbia_VehicleScrollBackground.currently_selected.getName(), resetSelectColors))
			Suburbia_VehicleScrollBackground.currently_selected.resetSelectColors();
	
	Suburbia_VehicleDescCover.visible = true;
	Suburbia_VehicleDescCost.setText("");
	Suburbia_VehicleDescTitle.setText("");
	Suburbia_VehicleDescButton.setVisible(false);
}

function SuburbiaClient::displayVehicles()
{
	if(!$Suburbia::HandshakeCompleted)
		return;
	
	for(%i = 0; %i < $Suburbia::VehicleDataCount; %i++)
	{
		%vehicle_name = $Suburbia::VehicleData[%i];
		
		if($Suburbia::VehicleTab == $Suburbia::VehicleData[%vehicle_name, "tab"])
		{
			%caption_name = $Suburbia::VehicleData[%vehicle_name, "caption"];
			%icon_name = $Suburbia::VehicleData[%vehicle_name, "icon"];
			%icon = addVehicleIcon(%caption_name, %icon_name);
			%icon.vehicle_name = %vehicle_name;
		}
	}
	$Suburbia::VehicleStatsDisplayed = true;
}

function SuburbiaClient::setVehicleTab(%this, %section)
{
	if(!$Suburbia::HandshakeCompleted)
		return;
	
	$Suburbia::VehicleTab = %section;
	SuburbiaClient.clearVehicleScrollList();
	SuburbiaClient.displayVehicles();
	
	// echo(("SRB_VehiclesPurchase_Tab" @ %section) SPC $Suburbia::LastHighlighedVehicleTab);
	
	$Suburbia::LastHighlighedVehicleTab.mColor = "255 255 255 255";
	("SRB_VehiclesPurchase_Tab" @ %section).mColor = "90 96 254 255";
	
	$Suburbia::LastHighlighedVehicleTab = ("SRB_VehiclesPurchase_Tab" @ %section);
}

function clientCmdShowVehicleStatsGui(%vehicle_name)
{
	if(!$Suburbia::HandshakeCompleted)
		return;
	
	if(%vehicle_name $= "")
		SuburbiaClient.showVehiclesGui();
	else
	{
		SuburbiaClient.showVehiclesGui();
		SuburbiaClient.setVehicleTab($Suburbia::VehicleData[%vehicle_name, "tab"]);
		%obj = ("SRB_VehicleIcon_" @ %vehicle_name);
		%obj.getObject(%obj.getCount() - 1).setSelectColors();
		
		%max_y = getWord(Suburbia_VehicleScrollBackground, 1);
		%y = getWord(%obj.position, 1) - 116 + 20;
		
		Suburbia_VehicleScrollBackground.position = "1" SPC -mClamp(%y, 0, 5393);
	}
}

function clientCmdRecieveVehicleData(%vehicle_name, %caption_name, %cost, %speed, %accel, %brake, %handling, %seats, %hp, %tab)
{
	if(!$Suburbia::HandshakeCompleted)
		return;
	
	%icon_name = getSafeVariableName(%vehicle_name);
	
	$Suburbia::VehicleData[%vehicle_name] = true;
	$Suburbia::VehicleData[%vehicle_name, "caption"] = %caption_name;
	$Suburbia::VehicleData[%vehicle_name, "icon"] = %icon_name;
	$Suburbia::VehicleData[%vehicle_name, "cost"] = %cost;
	$Suburbia::VehicleData[%vehicle_name, "speed"] = %speed;
	$Suburbia::VehicleData[%vehicle_name, "accel"] = %accel;
	$Suburbia::VehicleData[%vehicle_name, "brake"] = %brake;
	$Suburbia::VehicleData[%vehicle_name, "handling"] = %handling;
	$Suburbia::VehicleData[%vehicle_name, "seats"] = %seats;
	$Suburbia::VehicleData[%vehicle_name, "hp"] = %hp;
	$Suburbia::VehicleData[%vehicle_name, "tab"] = %tab;
	
	if($Suburbia::VehicleDataCount $= "")
		$Suburbia::VehicleDataCount = 0;
	
	$Suburbia::VehicleData[$Suburbia::VehicleDataCount] = %vehicle_name;
	$Suburbia::VehicleDataCount++;
}

function clientCmdSuburbia_ClearVehicleData()
{
	SuburbiaClient::clearVehicles();
}

function SuburbiaClient::clearVehicles()
{
	if(!$Suburbia::HandshakeCompleted)
		return;
	
	$Suburbia::VehicleStatsDisplayed = false;
	DeleteVariables("$Suburbia::VehicleData*");
	SuburbiaClient.clearVehicleScrollList();
}

function SuburbiaClient::clearVehicleScrollList()
{
	if(!$Suburbia::HandshakeCompleted)
		return;
	
	%count = getTaggedFieldCount(Suburbia_VehicleScroll);
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%field = Suburbia_VehicleScroll.getTaggedField(%i);
		%field_name = expandEscape(getField(%field, 0));
		eval("Suburbia_VehicleScroll." @ %field_name @ " = \"\";");
	}
	
	%count = Suburbia_VehicleScrollBackground.getCount();
	for(%i = %count - 1; %i >= 0; %i--)
	{
		%obj = Suburbia_VehicleScrollBackground.getObject(%i);
		
		if(isObject(%obj))
			%obj.delete();
	}
}

function setVehicleSpeedBar(%speed)
{
	%percent = mClampF((0.01666 * %speed) - 0.335, 0.05, 1);
	setVehicleStatBar(Suburbia_VehicleSpeedBarBitmap, Suburbia_VehicleSpeedBarBCap, %percent);
}

function setVehicleAccelBar(%accel)
{
	%percent = mClampF((0.0415546 * %accel) - 0.2652, 0.05, 1);
	setVehicleStatBar(Suburbia_VehicleAccelBarBitmap, Suburbia_VehicleAccelBarBCap, %percent);
}

function setVehicleBrakeBar(%brake)
{
	%percent = mClampF((-0.0297609724 * %brake) + 1.0972, 0.05, 1);
	setVehicleStatBar(Suburbia_VehicleBrakeBarBitmap, Suburbia_VehicleBrakeBarBCap, %percent);
}

function setVehicleHandlingBar(%handling)
{
	// echo(%handling SPC "<= z");
	%percent = mClampF(((0.182093 * %handling) + 0.012) * 100, 5, 100);
	%percent /= 100;
	setVehicleStatBar(Suburbia_VehicleHandlingBarBitmap, Suburbia_VehicleHandlingBarBCap, %percent);
}

function setVehicleStatBar(%bar, %end, %percent)
{
	%width = mFloor(223 * %percent);
	%bar.extent = %width SPC "7";
	%end.position = getWord(%bar.position, 0) + %width SPC getWord(%end.position, 1);
}

DeactivatePackage(Suburbia_VehicleStatistics);
package Suburbia_VehicleStatistics
{
	function clientCmdOpenWrenchVehicleSpawnDlg(%title, %a, %b, %c)
	{
		Parent::clientCmdOpenWrenchVehicleSpawnDlg(%title, %a, %b, %c);
		
		if(getSubStr($ServerInfo::Name, 0, 9) $= "Scenery's")
		{
			if(!isObject(Suburbia_VehicleStatsButton))
			{
				%gui = new GuiBitmapButtonCtrl(Suburbia_VehicleStatsButton)
				{
					profile = "BlockButtonProfile";
					horizSizing = "right";
					vertSizing = "top";
					position = "217 200";
					extent = "91 38";
					minExtent = "8 2";
					enabled = "1";
					visible = "1";
					clipToParent = "1";
					command = "clientCmdShowVehicleStatsGui(WrenchVehicleSpawn_Vehicles.getValue());";
					text = "< Stats >";
					groupNum = "-1";
					buttonType = "PushButton";
					bitmap = "base/client/ui/button2";
					lockAspectRatio = "0";
					alignLeft = "0";
					alignTop = "0";
					overflowImage = "0";
					mKeepCached = "0";
					mColor = "192 192 255 255";
				};
				WrenchVehicleSpawn_Window.add(%gui);
				%gui.position = "217 200";
			}
		}
		else
		{
			if(isObject(Suburbia_VehicleStatsButton))
				Suburbia_VehicleStatsButton.delete();
		}
	}
};
ActivatePackage(Suburbia_VehicleStatistics);